/* ================================================================================== */
/* Copyright (c) 1998-1999 3Com Corporation or its subsidiaries. All rights reserved. */
/* ================================================================================== */

#ifndef _CGREMLINS_H_
#define _CGREMLINS_H_

class Gremlins
{
public:
				Gremlins();
				~Gremlins();
	Boolean	IsInitialized() const;
	void		Initialize(unsigned short newNumber = -1, unsigned long untilStep = -1);
	void		Status(unsigned short *currentNumber, unsigned long *currentStep,
					unsigned long *currentUntil);
	Boolean	SetSeed(unsigned long newSeed);
	void		SetUntil(unsigned long newUntil);
	void 		Step();
	Boolean	GetFakeEvent();
	void		GetPenMovement();
	Boolean 	SendCharsToType();

private:
	unsigned short	keyProbabilitiesSum;	// The sum of all the key possiblities.
	Point				lastPoint;				// The previous point enqueued to TD.
	Boolean			lastPenDown;			// TRUE - last point caused a penDownEvent, FALSE - pen is up or already down.
	unsigned short	number;					// the random seed (-1 means not started)
	unsigned long	counter;					// The number of "events" produced by Gremlins.
	unsigned long	until;					// The maximum numbe of "events" to produce.
	unsigned long	saveUntil;
	Boolean		inited;					// TRUE - Gremlins has been initialized, FALSE - not inited.
	Boolean		catchUp;					// TRUE - Event loop needs time to catch up, FALSE - event loop doesn't need time.
	Boolean		needPenUp;				// TRUE - A pen up need to be enqueued, FALSE - pen up doesn't need to be  enqueued.
	char			charsToType[2048];	// Chars to send to the emulator.
};


#ifdef __cplusplus
extern "C" {
#endif

extern void GremlinsSendEvent (void);

extern void GremlinsProcessPacket (void* pktBodyP);

#ifdef __cplusplus 
}
#endif


#endif /* _CGREMLINS_H_ */

