/*******************************************************************
 *						 Pilot Software
 *
 *	   Copyright(c) 1994, Palm Computing Inc., All Rights Reserved	
 *
 *-------------------------------------------------------------------
 * FileName:
 *	  SerialLibWin.h
 *
 * Description:
 *	  Include file for Windows Serial Library
 *
 * History:
 *	  2/7/95 Created by Ron Marianetti
 *	  vmk	8/21/95  Added defQData field to serial globals
 *
 *******************************************************************/

#ifndef __SERIAL_LIB_WIN_H
#define __SERIAL_LIB_WIN_H


// Pilot common definitions
#include <Common.h>
#include <SerialMgr.h>


// scanning mode states
#define scmOff						0  // scanning disabled
#define scmIdle 					1  // idle while port is in use
#define scmActive					2  // active 
#define scmOpening					3  // scanning is being activated


/********************************************************************
 * Serial Globals 
 ********************************************************************/
//
// Types used by this module only
//
typedef struct SerGlobalsType {
   UInt 			 openCount; 	   // number of times we have been opened
   Int				 port;			   // port number: 1-4 0 if using a pipe
   SerSettingsType	 settings;		   // serial settings
   Word 			 lineErrors;	   // line errors bitfield
   
   void*			 commHdl;
   DWord			 inQSize;
   DWord			 outQSize;
   Ptr				 qData; 		   // pointer to queue data
   
   // IrDA stuff
   Boolean			 irdaMode;		   // true if UART is set to IrDA mode
   Byte 			 scanningMode;	   // current state of Ir scanning mode
   Boolean			 scanIrdaMode;	   // true if scanning should be done in irda mode
   SerWakeupHandler  scanWakeHandler;  // scannning Wakeup handler,
   DWord			 scanWakeParam;    // parameter to pass to wake handler

   } SerGlobalsType;
typedef SerGlobalsType* SerGlobalsPtr;

#define serDefaultRcvBufferSize 	(30*1024)
#define serDefaultXmitBufferSize	(2*1024)

#endif	 //__SERIAL_LIB_WIN_H
