/* ================================================================================== */
/* Copyright (c) 1998-1999 3Com Corporation or its subsidiaries. All rights reserved. */
/* ================================================================================== */

#ifndef _PLATFORM_NETLIB_H_
#define _PLATFORM_NETLIB_H_


namespace Platform
{
	namespace NetLib
	{
		Bool			Redirecting (void);

		Err				Open (Word libRefNum, WordPtr netIFErrsP);
		Err				OpenConfig (Word libRefNum, Word configIndex, DWord openFlags, WordPtr netIFErrsP);
		Err				Close (Word libRefNum, Word immediate);
		Err				Sleep (Word libRefNum);
		Err				Wake (Word libRefNum);
		Err				FinishCloseWait(Word libRefNum);
		Err				OpenIfCloseWait(Word libRefNum);
		Err				OpenCount (Word refNum, WordPtr countP);
		Err				HandlePowerOff (Word refNum, EventPtr eventP);
		Err				ConnectionRefresh(Word refNum, Boolean refresh, 
									BooleanPtr allInterfacesUpP, WordPtr netIFErrP);
		NetSocketRef	SocketOpen(Word libRefNum, NetSocketAddrEnum domain, 
									NetSocketTypeEnum type, SWord protocol, SDWord timeout, 
									Err* errP);
		SWord			SocketClose(Word libRefNum, NetSocketRef socket, SDWord timeout, 
									Err* errP);
		SWord			SocketOptionSet(Word libRefNum, NetSocketRef socket,
									NetSocketOptLevelEnum level, NetSocketOptEnum option, 
									VoidPtr optValueP, Word optValueLen,
									SDWord timeout, Err* errP);
		SWord			SocketOptionGet(Word libRefNum, NetSocketRef socket,
									NetSocketOptLevelEnum level, NetSocketOptEnum option,
									VoidPtr optValueP, WordPtr optValueLenP,
									SDWord timeout, Err* errP);
		SWord			SocketBind(Word libRefNum, NetSocketRef socket,
									NetSocketAddrType* sockAddrP, SWord addrLen, SDWord timeout, 
									Err* errP);
		SWord			SocketConnect(Word libRefNum, NetSocketRef socket,
									NetSocketAddrType* sockAddrP, SWord addrLen, SDWord timeout, 
									Err* errP);
		SWord			SocketListen(Word libRefNum, NetSocketRef socket,
									Word queueLen, SDWord timeout, Err* errP);
		SWord			SocketAccept(Word libRefNum, NetSocketRef socket,
									NetSocketAddrType* sockAddrP, SWord* addrLenP, SDWord timeout,
									Err* errP);
		SWord			SocketShutdown(Word libRefNum, NetSocketRef socket, 
									SWord /*NetSocketDirEnum*/ direction, SDWord timeout, Err* errP);
		SWord			SocketAddr(Word libRefNum, NetSocketRef socketRef,
									NetSocketAddrType* locAddrP, SWord* locAddrLenP, 
									NetSocketAddrType* remAddrP, SWord* remAddrLenP, 
									SDWord timeout, Err* errP);
		SWord			SendPB(Word libRefNum, NetSocketRef socket,
									NetIOParamType* pbP, Word flags, SDWord timeout, Err* errP);
		SWord			Send(Word libRefNum, NetSocketRef socket,
									const VoidPtr bufP, Word bufLen, Word flags,
									VoidPtr toAddrP, Word toLen, SDWord timeout, Err* errP);
		SWord			ReceivePB(Word libRefNum, NetSocketRef socket,
									NetIOParamType* pbP, Word flags, SDWord timeout, Err* errP);
		SWord			Receive(Word libRefNum, NetSocketRef socket,
									VoidPtr bufP, Word bufLen, Word flags, 
									VoidPtr fromAddrP, WordPtr fromLenP, SDWord timeout, Err* errP);
		SWord			DmReceive(Word libRefNum, NetSocketRef socket,
									VoidPtr recordP, DWord recordOffset, Word rcvLen, Word flags, 
									VoidPtr fromAddrP, WordPtr fromLenP, SDWord timeout, Err* errP);
		NetHostInfoPtr	GetHostByName(Word libRefNum, CharPtr nameP, 
									NetHostInfoBufPtr bufP, Long timeout, Err* errP);
		NetHostInfoPtr	GetHostByAddr(Word libRefNum, BytePtr addrP, Word len, Word type,
									NetHostInfoBufPtr bufP, Long timeout, Err* errP);
		NetServInfoPtr	GetServByName(Word libRefNum, CharPtr servNameP, 
									CharPtr protoNameP, NetServInfoBufPtr bufP, 
									Long timeout, Err* errP);
		SWord			GetMailExchangeByName(Word libRefNum, CharPtr mailNameP, 
									Word maxEntries, 
									Char hostNames[][netDNSMaxDomainName+1], Word priorities[], 
									Long timeout, Err* errP);
		SWord			Select(Word libRefNum, Word width, NetFDSetType* readFDs, 
									NetFDSetType* writeFDs, NetFDSetType* exceptFDs,
									Long timeout, Err* errP);
	}
}

#endif	// _PLATFORM_NETLIB_H_
