/* ================================================================================== */
/* Copyright (c) 1998-1999 3Com Corporation or its subsidiaries. All rights reserved. */
/* ================================================================================== */

#ifndef _EMULATOR_COMMON_H_
#define _EMULATOR_COMMON_H_

// Common header file included by all Palm OS Emulator for Windows files.

// Turn off some warnings that we don't care about.

#pragma warning( disable : 4065 )	// warning C4065: switch statement contains default but no case labels
#pragma warning( disable : 4068 )	// warning C4068: unknown pragma
#pragma warning( disable : 4101 )	// warning C4101: exitWinPtr : unreferenced local variable
#pragma warning( disable : 4102 )	// warning C4102: l8 : unreferenced label
#pragma warning( disable : 4244 )	// warning C4244: initializing : conversion from unsigned long to unsigned short, possible loss of data
#pragma warning( disable : 4786 )	// warning C4786: '<foo>' : identifier was truncated to '255' characters in the browser information


// Configuration

#include "Switches.h"


// Palm headers

#include "Palm.h"


// UAE headers

#include "UAE.h"


// Std C/C++ Library stuff

#include <assert.h>
#include <ctype.h>				// isalpha, tolower
#include <stdarg.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// There is a bug in the string class in VC++ 5.0 (see KB: Q172398).
// We get around this by including a file with the fixed class.
// To make sure we get the fixed class, we must include this string2
// file *before* any other STL file can possibly bring it in.

#include "string2"

#include <algorithm>			// find, sort
#include <deque>				// deque
#include <list>					// list
#include <utility>				// pair
#include <vector>


using namespace std;


// Windows headers

#include <Windows.h>


// Define a boolean type that is most efficient on each platform.
// Yes, they appear to be different...

typedef int		Bool;


// A *very* handy macro.  Let's put this in a central place.

#define countof(a)	(sizeof(a) / sizeof (a[0]))


#endif	/* _EMULATOR_COMMON_H_ */

