/* ================================================================================== */
/* Copyright (c) 1998-1999 3Com Corporation or its subsidiaries. All rights reserved. */
/* ================================================================================== */

#pragma once

extern const char*	kDefaultRegistryKey;

namespace Registry
{
	void	SetString	(const char* name, const string& data, const char* key = kDefaultRegistryKey);
	Bool	GetString	(const char* name, string& data, const char* key = kDefaultRegistryKey);

	void	SetInt		(const char* name, uae_u32 data, const char* key = kDefaultRegistryKey);
	Bool	GetInt		(const char* name, uae_u32& data, const char* key = kDefaultRegistryKey);
	Bool	GetInt		(const char* name, uae_s32& data, const char* key = kDefaultRegistryKey);
	Bool	GetInt		(const char* name, uae_u16& data, const char* key = kDefaultRegistryKey);
	Bool	GetInt		(const char* name, uae_s16& data, const char* key = kDefaultRegistryKey);
	Bool	GetInt		(const char* name, uae_u8& data, const char* key = kDefaultRegistryKey);
	Bool	GetInt		(const char* name, uae_s8& data, const char* key = kDefaultRegistryKey);

	void	SetBool		(const char* name, Bool data, const char* key = kDefaultRegistryKey);
	void	SetBool		(const char* name, bool data, const char* key = kDefaultRegistryKey);
	Bool	GetBool		(const char* name, Bool& data, const char* key = kDefaultRegistryKey);
	Bool	GetBool		(const char* name, bool& data, const char* key = kDefaultRegistryKey);

	void	SetBinary	(const char* name, const void* data, uae_u32 datasize, const char* key = kDefaultRegistryKey);
	Bool	GetBinary	(const char* name, void* data, uae_u32 datasize, const char* key = kDefaultRegistryKey);

	void	RemoveSlot	(const char* name, const char* key = kDefaultRegistryKey);

	void	SetRegistry	(const char* key,
						 const char* name,
						 DWORD type,
						 const void* data,
						 DWORD datasize);
	Bool	GetRegistry	(const char* key,
						 const char* name,
						 DWORD type,
						 void* data,
						 DWORD datasize);
}

