/* ================================================================================== */
/* Copyright (c) 1998-1999 3Com Corporation or its subsidiaries. All rights reserved. */
/* ================================================================================== */

#pragma once

#include "AppPreferences.h"


class TSettings : public AppPreferences
{
	public:
								TSettings			(void);
								~TSettings			(void);

		void					Load				(void);
		void					Save				(void);

		Bool					EditProperties		(HWND hwnd);
		void					EditLoggingOptions	(HWND hwnd, int panel);
		void					EditDebugOptions	(HWND hwnd);

		FileReference&			GetLastPRCDir		(void);
		void					SetLastPRCDir		(FileReference&);

		static string			GetIndCommPort		(int index);
		static void				PopulatePortMenu	(HWND portPopup);

	private:
		static void				UpdateCheckBox				(HWND hwnd, UINT id, bool value);
		static void				UpdatePreference			(HWND hwnd, UINT id, bool& value);
		static void				UpdateCheckBox				(HWND hwnd, UINT id, uae_u8 value, int bitMask);
		static void				UpdatePreference			(HWND hwnd, UINT id, uae_u8& value, int bitMask);

		BOOL					EditPropertiesDlgProc		(HWND hwnd,
															 UINT msg,
															 WPARAM wparam,
															 LPARAM lparam);
		BOOL					EditLoggingOptionsDlgProc	(HWND hwnd,
															 UINT msg,
															 WPARAM wparam,
															 LPARAM lparam,
															 int whichPage);
		BOOL					EditDebugOptionsDlgProc		(HWND hwnd,
															 UINT msg,
															 WPARAM wparam,
															 LPARAM lparam);

		static BOOL CALLBACK	EditPropertiesDlgProcSt		(HWND hwnd,
															 UINT msg,
															 WPARAM wparam,
															 LPARAM lparam);
		static BOOL CALLBACK	EditLoggingOptionsDlgProcSt1(HWND hwnd,
															 UINT msg,
															 WPARAM wparam,
															 LPARAM lparam);
		static BOOL CALLBACK	EditLoggingOptionsDlgProcSt2(HWND hwnd,
															 UINT msg,
															 WPARAM wparam,
															 LPARAM lparam);
		static BOOL CALLBACK	EditDebugOptionsDlgProcSt	(HWND hwnd,
															 UINT msg,
															 WPARAM wparam,
															 LPARAM lparam);

		static void				CreatePortNameCache			(void);
		static void				SearchForPorts				(HKEY HLM, HKEY key);


		FileReference			fLastPRCFile;

		static deque<string>	fgCachedPorts;
};

extern TSettings*	gHostPrefs;
