/*********************************************************************
 *
 * Copyright (c) 1998-1999
 * 3Com/Palm Computing Division.  All rights reserved.
 *
 * Portions copyright (c) 1995-1998
 * Bernd Schmidt.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgement:
 *
 *		This product includes software developed by 3Com and its
 *		contributors.
 *
 * 4. Neither 3Com nor the names of its contributors may be used to
 *    endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY 3COM AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 3COM OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
 * OF SUCH DAMAGE.
 *
 *******************************************************************/

#include "UAE.h"
#if HAS_PROFILING
#include "Profiling.h"
#endif

#if !defined(PART_1) && !defined(PART_2) && !defined(PART_3) && !defined(PART_4) && !defined(PART_5) && !defined(PART_6) && !defined(PART_7) && !defined(PART_8)
#define PART_1 1
#define PART_2 1
#define PART_3 1
#define PART_4 1
#define PART_5 1
#define PART_6 1
#define PART_7 1
#define PART_8 1
#endif

#ifdef PART_1
unsigned long REGPARAM2 op_0_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uae_s8 src = get_ibyte(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}m68k_incpc(4);
endlabel1: (void)0;
return 4;
}
unsigned long REGPARAM2 op_10_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel2: (void)0;
return 8;
}
unsigned long REGPARAM2 op_18_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel3: (void)0;
return 8;
}
unsigned long REGPARAM2 op_20_0(uae_u32 opcode) /* OR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel4: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_28_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel5: (void)0;
return 10;
}
unsigned long REGPARAM2 op_30_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = get_ibyte(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel6: (void)0;
return 8;
}
unsigned long REGPARAM2 op_38_0(uae_u32 opcode) /* OR */
{
{{	uae_s8 src = get_ibyte(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(6);
endlabel7: (void)0;
return 10;
}
unsigned long REGPARAM2 op_39_0(uae_u32 opcode) /* OR */
{
{{	uae_s8 src = get_ibyte(2);
	uaecptr dsta = get_ilong(4);
{	uae_s8 dst = get_byte(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(8);
endlabel8: (void)0;
return 12;
}
unsigned long REGPARAM2 op_3c_0(uae_u32 opcode) /* ORSR */
{
{	MakeSR();
{	uae_s16 src = get_iword(2);
	src &= 0xFF;
	regs.sr |= src;
	MakeFromSR();
}}m68k_incpc(4);
endlabel9: (void)0;
return 4;
}
unsigned long REGPARAM2 op_40_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}m68k_incpc(4);
endlabel10: (void)0;
return 4;
}
unsigned long REGPARAM2 op_50_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel11: (void)0;
return 8;
}
unsigned long REGPARAM2 op_58_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel12: (void)0;
return 8;
}
unsigned long REGPARAM2 op_60_0(uae_u32 opcode) /* OR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel13: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_68_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel14: (void)0;
return 10;
}
unsigned long REGPARAM2 op_70_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s16 dst = get_word(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel15: (void)0;
return 8;
}
unsigned long REGPARAM2 op_78_0(uae_u32 opcode) /* OR */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 dst = get_word(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(6);
endlabel16: (void)0;
return 10;
}
unsigned long REGPARAM2 op_79_0(uae_u32 opcode) /* OR */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s16 dst = get_word(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(8);
endlabel17: (void)0;
return 12;
}
unsigned long REGPARAM2 op_7c_0(uae_u32 opcode) /* ORSR */
{
{if (!regs.s) { Exception(8,0); goto endlabel18; }
{	MakeSR();
{	uae_s16 src = get_iword(2);
	regs.sr |= src;
	MakeFromSR();
}}}m68k_incpc(4);
endlabel18: (void)0;
return 4;
}
unsigned long REGPARAM2 op_80_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}m68k_incpc(6);
endlabel19: (void)0;
return 6;
}
unsigned long REGPARAM2 op_90_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel20: (void)0;
return 14;
}
unsigned long REGPARAM2 op_98_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel21: (void)0;
return 14;
}
unsigned long REGPARAM2 op_a0_0(uae_u32 opcode) /* OR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel22: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 14;
}
unsigned long REGPARAM2 op_a8_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(8);
endlabel23: (void)0;
return 16;
}
unsigned long REGPARAM2 op_b0_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = get_ilong(2);
m68k_incpc(6);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel24: (void)0;
return 14;
}
unsigned long REGPARAM2 op_b8_0(uae_u32 opcode) /* OR */
{
{{	uae_s32 src = get_ilong(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 dst = get_long(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(8);
endlabel25: (void)0;
return 16;
}
unsigned long REGPARAM2 op_b9_0(uae_u32 opcode) /* OR */
{
{{	uae_s32 src = get_ilong(2);
	uaecptr dsta = get_ilong(6);
{	uae_s32 dst = get_long(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(10);
endlabel26: (void)0;
return 18;
}
unsigned long REGPARAM2 op_d0_0(uae_u32 opcode) /* CHK2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 extra = get_iword(2);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=(uae_s32)(uae_s8)get_byte(dsta); upper = (uae_s32)(uae_s8)get_byte(dsta+1);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s8)reg;
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel27; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}}m68k_incpc(4);
endlabel27: (void)0;
return 4;
}
unsigned long REGPARAM2 op_e8_0(uae_u32 opcode) /* CHK2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 extra = get_iword(2);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=(uae_s32)(uae_s8)get_byte(dsta); upper = (uae_s32)(uae_s8)get_byte(dsta+1);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s8)reg;
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel28; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}}m68k_incpc(6);
endlabel28: (void)0;
return 6;
}
unsigned long REGPARAM2 op_f0_0(uae_u32 opcode) /* CHK2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=(uae_s32)(uae_s8)get_byte(dsta); upper = (uae_s32)(uae_s8)get_byte(dsta+1);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s8)reg;
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel29; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}}endlabel29: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f8_0(uae_u32 opcode) /* CHK2 */
{
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=(uae_s32)(uae_s8)get_byte(dsta); upper = (uae_s32)(uae_s8)get_byte(dsta+1);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s8)reg;
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel30; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}m68k_incpc(6);
endlabel30: (void)0;
return 6;
}
unsigned long REGPARAM2 op_f9_0(uae_u32 opcode) /* CHK2 */
{
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(2);
	uaecptr dsta = get_ilong(4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=(uae_s32)(uae_s8)get_byte(dsta); upper = (uae_s32)(uae_s8)get_byte(dsta+1);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s8)reg;
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel31; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}m68k_incpc(8);
endlabel31: (void)0;
return 8;
}
unsigned long REGPARAM2 op_fa_0(uae_u32 opcode) /* CHK2 */
{
	uae_u32 dstreg = 2;
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(2);
	uaecptr dsta = m68k_getpc () + 4;
	dsta += (uae_s32)(uae_s16)get_iword(4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=(uae_s32)(uae_s8)get_byte(dsta); upper = (uae_s32)(uae_s8)get_byte(dsta+1);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s8)reg;
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel32; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}m68k_incpc(6);
endlabel32: (void)0;
return 6;
}
unsigned long REGPARAM2 op_fb_0(uae_u32 opcode) /* CHK2 */
{
	uae_u32 dstreg = 3;
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=(uae_s32)(uae_s8)get_byte(dsta); upper = (uae_s32)(uae_s8)get_byte(dsta+1);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s8)reg;
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel33; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}}endlabel33: (void)0;
return 4;
}
unsigned long REGPARAM2 op_100_0(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src &= 31;
	ZFLG = !(dst & (1 << src));
}}}m68k_incpc(2);
endlabel34: (void)0;
return 2;
}
unsigned long REGPARAM2 op_108_0(uae_u32 opcode) /* MVPMR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr memp = m68k_areg(regs, srcreg) + get_iword(2);
{	uae_u16 val = (get_byte(memp) << 8) + get_byte(memp + 2);
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
}}m68k_incpc(4);
endlabel35: (void)0;
return 4;
}
unsigned long REGPARAM2 op_110_0(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}m68k_incpc(2);
endlabel36: (void)0;
return 4;
}
unsigned long REGPARAM2 op_118_0(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}m68k_incpc(2);
endlabel37: (void)0;
return 4;
}
unsigned long REGPARAM2 op_120_0(uae_u32 opcode) /* BTST */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}m68k_incpc(2);
endlabel38: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_128_0(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}m68k_incpc(4);
endlabel39: (void)0;
return 6;
}
unsigned long REGPARAM2 op_130_0(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}endlabel40: (void)0;
return 4;
}
unsigned long REGPARAM2 op_138_0(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}m68k_incpc(4);
endlabel41: (void)0;
return 6;
}
unsigned long REGPARAM2 op_139_0(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}m68k_incpc(6);
endlabel42: (void)0;
return 8;
}
unsigned long REGPARAM2 op_13a_0(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
	uae_u32 dstreg = 2;
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_getpc () + 2;
	dsta += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}m68k_incpc(4);
endlabel43: (void)0;
return 6;
}
unsigned long REGPARAM2 op_13b_0(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
	uae_u32 dstreg = 3;
{{	uae_s8 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}endlabel44: (void)0;
return 4;
}
unsigned long REGPARAM2 op_13c_0(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uae_s8 dst = get_ibyte(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}m68k_incpc(4);
endlabel45: (void)0;
return 4;
}
unsigned long REGPARAM2 op_140_0(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src &= 31;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	m68k_dreg(regs, dstreg) = (dst);
}}}m68k_incpc(2);
endlabel46: (void)0;
return 2;
}
unsigned long REGPARAM2 op_148_0(uae_u32 opcode) /* MVPMR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr memp = m68k_areg(regs, srcreg) + get_iword(2);
{	uae_u32 val = (get_byte(memp) << 24) + (get_byte(memp + 2) << 16)
              + (get_byte(memp + 4) << 8) + get_byte(memp + 6);
	m68k_dreg(regs, dstreg) = (val);
}}m68k_incpc(4);
endlabel47: (void)0;
return 4;
}
unsigned long REGPARAM2 op_150_0(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(2);
endlabel48: (void)0;
return 6;
}
unsigned long REGPARAM2 op_158_0(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(2);
endlabel49: (void)0;
return 6;
}
unsigned long REGPARAM2 op_160_0(uae_u32 opcode) /* BCHG */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(2);
endlabel50: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_168_0(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel51: (void)0;
return 8;
}
unsigned long REGPARAM2 op_170_0(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}endlabel52: (void)0;
return 6;
}
unsigned long REGPARAM2 op_178_0(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel53: (void)0;
return 8;
}
unsigned long REGPARAM2 op_179_0(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(6);
endlabel54: (void)0;
return 10;
}
unsigned long REGPARAM2 op_17a_0(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
	uae_u32 dstreg = 2;
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_getpc () + 2;
	dsta += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel55: (void)0;
return 8;
}
unsigned long REGPARAM2 op_17b_0(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
	uae_u32 dstreg = 3;
{{	uae_s8 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}endlabel56: (void)0;
return 6;
}
unsigned long REGPARAM2 op_180_0(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src &= 31;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	m68k_dreg(regs, dstreg) = (dst);
}}}m68k_incpc(2);
endlabel57: (void)0;
return 2;
}
unsigned long REGPARAM2 op_188_0(uae_u32 opcode) /* MVPRM */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
	uaecptr memp = m68k_areg(regs, dstreg) + get_iword(2);
	put_byte(memp, src >> 8); put_byte(memp + 2, src);
}}m68k_incpc(4);
endlabel58: (void)0;
return 4;
}
unsigned long REGPARAM2 op_190_0(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(2);
endlabel59: (void)0;
return 6;
}
unsigned long REGPARAM2 op_198_0(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(2);
endlabel60: (void)0;
return 6;
}
unsigned long REGPARAM2 op_1a0_0(uae_u32 opcode) /* BCLR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(2);
endlabel61: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_1a8_0(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel62: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1b0_0(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}endlabel63: (void)0;
return 6;
}
unsigned long REGPARAM2 op_1b8_0(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel64: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1b9_0(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(6);
endlabel65: (void)0;
return 10;
}
unsigned long REGPARAM2 op_1ba_0(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
	uae_u32 dstreg = 2;
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_getpc () + 2;
	dsta += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel66: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1bb_0(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
	uae_u32 dstreg = 3;
{{	uae_s8 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}endlabel67: (void)0;
return 6;
}
unsigned long REGPARAM2 op_1c0_0(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src &= 31;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	m68k_dreg(regs, dstreg) = (dst);
}}}m68k_incpc(2);
endlabel68: (void)0;
return 2;
}
unsigned long REGPARAM2 op_1c8_0(uae_u32 opcode) /* MVPRM */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
	uaecptr memp = m68k_areg(regs, dstreg) + get_iword(2);
	put_byte(memp, src >> 24); put_byte(memp + 2, src >> 16);
	put_byte(memp + 4, src >> 8); put_byte(memp + 6, src);
}}m68k_incpc(4);
endlabel69: (void)0;
return 4;
}
unsigned long REGPARAM2 op_1d0_0(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(2);
endlabel70: (void)0;
return 6;
}
unsigned long REGPARAM2 op_1d8_0(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(2);
endlabel71: (void)0;
return 6;
}
unsigned long REGPARAM2 op_1e0_0(uae_u32 opcode) /* BSET */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(2);
endlabel72: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_1e8_0(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel73: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1f0_0(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}endlabel74: (void)0;
return 6;
}
unsigned long REGPARAM2 op_1f8_0(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel75: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1f9_0(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(6);
endlabel76: (void)0;
return 10;
}
unsigned long REGPARAM2 op_1fa_0(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
	uae_u32 dstreg = 2;
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_getpc () + 2;
	dsta += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel77: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1fb_0(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
	uae_u32 dstreg = 3;
{{	uae_s8 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}endlabel78: (void)0;
return 6;
}
unsigned long REGPARAM2 op_200_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uae_s8 src = get_ibyte(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}m68k_incpc(4);
endlabel79: (void)0;
return 4;
}
unsigned long REGPARAM2 op_210_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel80: (void)0;
return 8;
}
unsigned long REGPARAM2 op_218_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel81: (void)0;
return 8;
}
unsigned long REGPARAM2 op_220_0(uae_u32 opcode) /* AND */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel82: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_228_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel83: (void)0;
return 10;
}
unsigned long REGPARAM2 op_230_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = get_ibyte(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel84: (void)0;
return 8;
}
unsigned long REGPARAM2 op_238_0(uae_u32 opcode) /* AND */
{
{{	uae_s8 src = get_ibyte(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(6);
endlabel85: (void)0;
return 10;
}
unsigned long REGPARAM2 op_239_0(uae_u32 opcode) /* AND */
{
{{	uae_s8 src = get_ibyte(2);
	uaecptr dsta = get_ilong(4);
{	uae_s8 dst = get_byte(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(8);
endlabel86: (void)0;
return 12;
}
unsigned long REGPARAM2 op_23c_0(uae_u32 opcode) /* ANDSR */
{
{	MakeSR();
{	uae_s16 src = get_iword(2);
	src |= 0xFF00;
	regs.sr &= src;
	MakeFromSR();
}}m68k_incpc(4);
endlabel87: (void)0;
return 4;
}
unsigned long REGPARAM2 op_240_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}m68k_incpc(4);
endlabel88: (void)0;
return 4;
}
unsigned long REGPARAM2 op_250_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel89: (void)0;
return 8;
}
unsigned long REGPARAM2 op_258_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel90: (void)0;
return 8;
}
unsigned long REGPARAM2 op_260_0(uae_u32 opcode) /* AND */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel91: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_268_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel92: (void)0;
return 10;
}
unsigned long REGPARAM2 op_270_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s16 dst = get_word(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel93: (void)0;
return 8;
}
unsigned long REGPARAM2 op_278_0(uae_u32 opcode) /* AND */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 dst = get_word(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(6);
endlabel94: (void)0;
return 10;
}
unsigned long REGPARAM2 op_279_0(uae_u32 opcode) /* AND */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s16 dst = get_word(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(8);
endlabel95: (void)0;
return 12;
}
unsigned long REGPARAM2 op_27c_0(uae_u32 opcode) /* ANDSR */
{
{if (!regs.s) { Exception(8,0); goto endlabel96; }
{	MakeSR();
{	uae_s16 src = get_iword(2);
	regs.sr &= src;
	MakeFromSR();
}}}m68k_incpc(4);
endlabel96: (void)0;
return 4;
}
unsigned long REGPARAM2 op_280_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}m68k_incpc(6);
endlabel97: (void)0;
return 6;
}
unsigned long REGPARAM2 op_290_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel98: (void)0;
return 14;
}
unsigned long REGPARAM2 op_298_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel99: (void)0;
return 14;
}
unsigned long REGPARAM2 op_2a0_0(uae_u32 opcode) /* AND */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel100: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 14;
}
unsigned long REGPARAM2 op_2a8_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(8);
endlabel101: (void)0;
return 16;
}
unsigned long REGPARAM2 op_2b0_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = get_ilong(2);
m68k_incpc(6);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel102: (void)0;
return 14;
}
unsigned long REGPARAM2 op_2b8_0(uae_u32 opcode) /* AND */
{
{{	uae_s32 src = get_ilong(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 dst = get_long(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(8);
endlabel103: (void)0;
return 16;
}
unsigned long REGPARAM2 op_2b9_0(uae_u32 opcode) /* AND */
{
{{	uae_s32 src = get_ilong(2);
	uaecptr dsta = get_ilong(6);
{	uae_s32 dst = get_long(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(10);
endlabel104: (void)0;
return 18;
}
unsigned long REGPARAM2 op_2d0_0(uae_u32 opcode) /* CHK2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 extra = get_iword(2);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=(uae_s32)(uae_s16)get_word(dsta); upper = (uae_s32)(uae_s16)get_word(dsta+2);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s16)reg;
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel105; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}}m68k_incpc(4);
endlabel105: (void)0;
return 4;
}
unsigned long REGPARAM2 op_2e8_0(uae_u32 opcode) /* CHK2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 extra = get_iword(2);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=(uae_s32)(uae_s16)get_word(dsta); upper = (uae_s32)(uae_s16)get_word(dsta+2);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s16)reg;
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel106; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}}m68k_incpc(6);
endlabel106: (void)0;
return 6;
}
unsigned long REGPARAM2 op_2f0_0(uae_u32 opcode) /* CHK2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=(uae_s32)(uae_s16)get_word(dsta); upper = (uae_s32)(uae_s16)get_word(dsta+2);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s16)reg;
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel107; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}}endlabel107: (void)0;
return 4;
}
unsigned long REGPARAM2 op_2f8_0(uae_u32 opcode) /* CHK2 */
{
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=(uae_s32)(uae_s16)get_word(dsta); upper = (uae_s32)(uae_s16)get_word(dsta+2);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s16)reg;
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel108; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}m68k_incpc(6);
endlabel108: (void)0;
return 6;
}
unsigned long REGPARAM2 op_2f9_0(uae_u32 opcode) /* CHK2 */
{
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(2);
	uaecptr dsta = get_ilong(4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=(uae_s32)(uae_s16)get_word(dsta); upper = (uae_s32)(uae_s16)get_word(dsta+2);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s16)reg;
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel109; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}m68k_incpc(8);
endlabel109: (void)0;
return 8;
}
unsigned long REGPARAM2 op_2fa_0(uae_u32 opcode) /* CHK2 */
{
	uae_u32 dstreg = 2;
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(2);
	uaecptr dsta = m68k_getpc () + 4;
	dsta += (uae_s32)(uae_s16)get_iword(4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=(uae_s32)(uae_s16)get_word(dsta); upper = (uae_s32)(uae_s16)get_word(dsta+2);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s16)reg;
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel110; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}m68k_incpc(6);
endlabel110: (void)0;
return 6;
}
unsigned long REGPARAM2 op_2fb_0(uae_u32 opcode) /* CHK2 */
{
	uae_u32 dstreg = 3;
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=(uae_s32)(uae_s16)get_word(dsta); upper = (uae_s32)(uae_s16)get_word(dsta+2);
	if ((extra & 0x8000) == 0) reg = (uae_s32)(uae_s16)reg;
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel111; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}}endlabel111: (void)0;
return 4;
}
unsigned long REGPARAM2 op_400_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}m68k_incpc(4);
endlabel112: (void)0;
return 4;
}
unsigned long REGPARAM2 op_410_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel113: (void)0;
return 8;
}
unsigned long REGPARAM2 op_418_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel114: (void)0;
return 8;
}
unsigned long REGPARAM2 op_420_0(uae_u32 opcode) /* SUB */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel115: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_428_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel116: (void)0;
return 10;
}
unsigned long REGPARAM2 op_430_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = get_ibyte(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}endlabel117: (void)0;
return 8;
}
unsigned long REGPARAM2 op_438_0(uae_u32 opcode) /* SUB */
{
{{	uae_s8 src = get_ibyte(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(6);
endlabel118: (void)0;
return 10;
}
unsigned long REGPARAM2 op_439_0(uae_u32 opcode) /* SUB */
{
{{	uae_s8 src = get_ibyte(2);
	uaecptr dsta = get_ilong(4);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(8);
endlabel119: (void)0;
return 12;
}
unsigned long REGPARAM2 op_440_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}m68k_incpc(4);
endlabel120: (void)0;
return 4;
}
unsigned long REGPARAM2 op_450_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel121: (void)0;
return 8;
}
unsigned long REGPARAM2 op_458_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel122: (void)0;
return 8;
}
unsigned long REGPARAM2 op_460_0(uae_u32 opcode) /* SUB */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel123: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_468_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel124: (void)0;
return 10;
}
unsigned long REGPARAM2 op_470_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}endlabel125: (void)0;
return 8;
}
unsigned long REGPARAM2 op_478_0(uae_u32 opcode) /* SUB */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(6);
endlabel126: (void)0;
return 10;
}
unsigned long REGPARAM2 op_479_0(uae_u32 opcode) /* SUB */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(8);
endlabel127: (void)0;
return 12;
}
unsigned long REGPARAM2 op_480_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}m68k_incpc(6);
endlabel128: (void)0;
return 6;
}
unsigned long REGPARAM2 op_490_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel129: (void)0;
return 14;
}
unsigned long REGPARAM2 op_498_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel130: (void)0;
return 14;
}
unsigned long REGPARAM2 op_4a0_0(uae_u32 opcode) /* SUB */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel131: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 14;
}
unsigned long REGPARAM2 op_4a8_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(8);
endlabel132: (void)0;
return 16;
}
unsigned long REGPARAM2 op_4b0_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = get_ilong(2);
m68k_incpc(6);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}endlabel133: (void)0;
return 14;
}
unsigned long REGPARAM2 op_4b8_0(uae_u32 opcode) /* SUB */
{
{{	uae_s32 src = get_ilong(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(8);
endlabel134: (void)0;
return 16;
}
unsigned long REGPARAM2 op_4b9_0(uae_u32 opcode) /* SUB */
{
{{	uae_s32 src = get_ilong(2);
	uaecptr dsta = get_ilong(6);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(10);
endlabel135: (void)0;
return 18;
}
unsigned long REGPARAM2 op_4d0_0(uae_u32 opcode) /* CHK2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 extra = get_iword(2);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=get_long(dsta); upper = get_long(dsta+4);
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel136; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}}m68k_incpc(4);
endlabel136: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4e8_0(uae_u32 opcode) /* CHK2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 extra = get_iword(2);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=get_long(dsta); upper = get_long(dsta+4);
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel137; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}}m68k_incpc(6);
endlabel137: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4f0_0(uae_u32 opcode) /* CHK2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=get_long(dsta); upper = get_long(dsta+4);
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel138; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}}endlabel138: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4f8_0(uae_u32 opcode) /* CHK2 */
{
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=get_long(dsta); upper = get_long(dsta+4);
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel139; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}m68k_incpc(6);
endlabel139: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4f9_0(uae_u32 opcode) /* CHK2 */
{
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(2);
	uaecptr dsta = get_ilong(4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=get_long(dsta); upper = get_long(dsta+4);
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel140; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}m68k_incpc(8);
endlabel140: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4fa_0(uae_u32 opcode) /* CHK2 */
{
	uae_u32 dstreg = 2;
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(2);
	uaecptr dsta = m68k_getpc () + 4;
	dsta += (uae_s32)(uae_s16)get_iword(4);
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=get_long(dsta); upper = get_long(dsta+4);
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel141; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}m68k_incpc(6);
endlabel141: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4fb_0(uae_u32 opcode) /* CHK2 */
{
	uae_u32 dstreg = 3;
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
	{uae_s32 upper,lower,reg = regs.regs[(extra >> 12) & 15];
	lower=get_long(dsta); upper = get_long(dsta+4);
	ZFLG=upper == reg || lower == reg;
	CFLG=lower <= upper ? reg < lower || reg > upper : reg > upper || reg < lower;
	if ((extra & 0x800) && CFLG) { Exception(6,oldpc); goto endlabel142; }
}
	// perf CHK2 10(1/0)+ if no trap, 40(4/3)+ if trap
}}}endlabel142: (void)0;
return 4;
}
unsigned long REGPARAM2 op_600_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}m68k_incpc(4);
endlabel143: (void)0;
return 4;
}
unsigned long REGPARAM2 op_610_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel144: (void)0;
return 8;
}
unsigned long REGPARAM2 op_618_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel145: (void)0;
return 8;
}
unsigned long REGPARAM2 op_620_0(uae_u32 opcode) /* ADD */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel146: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_628_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel147: (void)0;
return 10;
}
unsigned long REGPARAM2 op_630_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = get_ibyte(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}endlabel148: (void)0;
return 8;
}
unsigned long REGPARAM2 op_638_0(uae_u32 opcode) /* ADD */
{
{{	uae_s8 src = get_ibyte(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(6);
endlabel149: (void)0;
return 10;
}
unsigned long REGPARAM2 op_639_0(uae_u32 opcode) /* ADD */
{
{{	uae_s8 src = get_ibyte(2);
	uaecptr dsta = get_ilong(4);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(8);
endlabel150: (void)0;
return 12;
}
unsigned long REGPARAM2 op_640_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}m68k_incpc(4);
endlabel151: (void)0;
return 4;
}
unsigned long REGPARAM2 op_650_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel152: (void)0;
return 8;
}
unsigned long REGPARAM2 op_658_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel153: (void)0;
return 8;
}
unsigned long REGPARAM2 op_660_0(uae_u32 opcode) /* ADD */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel154: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_668_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel155: (void)0;
return 10;
}
unsigned long REGPARAM2 op_670_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}endlabel156: (void)0;
return 8;
}
unsigned long REGPARAM2 op_678_0(uae_u32 opcode) /* ADD */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(6);
endlabel157: (void)0;
return 10;
}
unsigned long REGPARAM2 op_679_0(uae_u32 opcode) /* ADD */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(8);
endlabel158: (void)0;
return 12;
}
unsigned long REGPARAM2 op_680_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}m68k_incpc(6);
endlabel159: (void)0;
return 6;
}
unsigned long REGPARAM2 op_690_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel160: (void)0;
return 14;
}
unsigned long REGPARAM2 op_698_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel161: (void)0;
return 14;
}
unsigned long REGPARAM2 op_6a0_0(uae_u32 opcode) /* ADD */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel162: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 14;
}
unsigned long REGPARAM2 op_6a8_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(8);
endlabel163: (void)0;
return 16;
}
unsigned long REGPARAM2 op_6b0_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = get_ilong(2);
m68k_incpc(6);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}endlabel164: (void)0;
return 14;
}
unsigned long REGPARAM2 op_6b8_0(uae_u32 opcode) /* ADD */
{
{{	uae_s32 src = get_ilong(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(8);
endlabel165: (void)0;
return 16;
}
unsigned long REGPARAM2 op_6b9_0(uae_u32 opcode) /* ADD */
{
{{	uae_s32 src = get_ilong(2);
	uaecptr dsta = get_ilong(6);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(10);
endlabel166: (void)0;
return 18;
}
unsigned long REGPARAM2 op_6c0_0(uae_u32 opcode) /* RTM */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
	op_illg(opcode);
}endlabel167: (void)0;
return 2;
}
unsigned long REGPARAM2 op_6c8_0(uae_u32 opcode) /* RTM */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
	op_illg(opcode);
}endlabel168: (void)0;
return 2;
}
unsigned long REGPARAM2 op_6d0_0(uae_u32 opcode) /* CALLM */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
	op_illg(opcode);
}endlabel169: (void)0;
return 2;
}
unsigned long REGPARAM2 op_6e8_0(uae_u32 opcode) /* CALLM */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
	op_illg(opcode);
}endlabel170: (void)0;
return 2;
}
unsigned long REGPARAM2 op_6f0_0(uae_u32 opcode) /* CALLM */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
	op_illg(opcode);
}endlabel171: (void)0;
return 2;
}
unsigned long REGPARAM2 op_6f8_0(uae_u32 opcode) /* CALLM */
{
{m68k_incpc(2);
	op_illg(opcode);
}endlabel172: (void)0;
return 2;
}
unsigned long REGPARAM2 op_6f9_0(uae_u32 opcode) /* CALLM */
{
{m68k_incpc(2);
	op_illg(opcode);
}endlabel173: (void)0;
return 2;
}
unsigned long REGPARAM2 op_6fa_0(uae_u32 opcode) /* CALLM */
{
{m68k_incpc(2);
	op_illg(opcode);
}endlabel174: (void)0;
return 2;
}
unsigned long REGPARAM2 op_6fb_0(uae_u32 opcode) /* CALLM */
{
{m68k_incpc(2);
	op_illg(opcode);
}endlabel175: (void)0;
return 2;
}
unsigned long REGPARAM2 op_800_0(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
	src &= 31;
	ZFLG = !(dst & (1 << src));
}}}m68k_incpc(4);
endlabel176: (void)0;
return 4;
}
unsigned long REGPARAM2 op_810_0(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}m68k_incpc(4);
endlabel177: (void)0;
return 6;
}
unsigned long REGPARAM2 op_818_0(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}m68k_incpc(4);
endlabel178: (void)0;
return 6;
}
unsigned long REGPARAM2 op_820_0(uae_u32 opcode) /* BTST */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}m68k_incpc(4);
endlabel179: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_828_0(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}m68k_incpc(6);
endlabel180: (void)0;
return 8;
}
unsigned long REGPARAM2 op_830_0(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}endlabel181: (void)0;
return 6;
}
unsigned long REGPARAM2 op_838_0(uae_u32 opcode) /* BTST */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}m68k_incpc(6);
endlabel182: (void)0;
return 8;
}
unsigned long REGPARAM2 op_839_0(uae_u32 opcode) /* BTST */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}m68k_incpc(8);
endlabel183: (void)0;
return 10;
}
unsigned long REGPARAM2 op_83a_0(uae_u32 opcode) /* BTST */
{
	uae_u32 dstreg = 2;
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = m68k_getpc () + 4;
	dsta += (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}m68k_incpc(6);
endlabel184: (void)0;
return 8;
}
unsigned long REGPARAM2 op_83b_0(uae_u32 opcode) /* BTST */
{
	uae_u32 dstreg = 3;
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}endlabel185: (void)0;
return 6;
}
unsigned long REGPARAM2 op_83c_0(uae_u32 opcode) /* BTST */
{
{{	uae_s16 src = get_iword(2);
	uae_s8 dst = get_ibyte(4);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}m68k_incpc(6);
endlabel186: (void)0;
return 6;
}
unsigned long REGPARAM2 op_840_0(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
	src &= 31;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	m68k_dreg(regs, dstreg) = (dst);
}}}m68k_incpc(4);
endlabel187: (void)0;
return 4;
}
unsigned long REGPARAM2 op_850_0(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel188: (void)0;
return 8;
}
unsigned long REGPARAM2 op_858_0(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel189: (void)0;
return 8;
}
unsigned long REGPARAM2 op_860_0(uae_u32 opcode) /* BCHG */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel190: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_868_0(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(6);
endlabel191: (void)0;
return 10;
}
unsigned long REGPARAM2 op_870_0(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}endlabel192: (void)0;
return 8;
}
unsigned long REGPARAM2 op_878_0(uae_u32 opcode) /* BCHG */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}m68k_incpc(6);
endlabel193: (void)0;
return 10;
}
unsigned long REGPARAM2 op_879_0(uae_u32 opcode) /* BCHG */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}m68k_incpc(8);
endlabel194: (void)0;
return 12;
}
unsigned long REGPARAM2 op_87a_0(uae_u32 opcode) /* BCHG */
{
	uae_u32 dstreg = 2;
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = m68k_getpc () + 4;
	dsta += (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}m68k_incpc(6);
endlabel195: (void)0;
return 10;
}
unsigned long REGPARAM2 op_87b_0(uae_u32 opcode) /* BCHG */
{
	uae_u32 dstreg = 3;
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}endlabel196: (void)0;
return 8;
}
unsigned long REGPARAM2 op_880_0(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
	src &= 31;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	m68k_dreg(regs, dstreg) = (dst);
}}}m68k_incpc(4);
endlabel197: (void)0;
return 4;
}
unsigned long REGPARAM2 op_890_0(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel198: (void)0;
return 8;
}
unsigned long REGPARAM2 op_898_0(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel199: (void)0;
return 8;
}
unsigned long REGPARAM2 op_8a0_0(uae_u32 opcode) /* BCLR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel200: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_8a8_0(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(6);
endlabel201: (void)0;
return 10;
}
unsigned long REGPARAM2 op_8b0_0(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}endlabel202: (void)0;
return 8;
}
unsigned long REGPARAM2 op_8b8_0(uae_u32 opcode) /* BCLR */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}m68k_incpc(6);
endlabel203: (void)0;
return 10;
}
unsigned long REGPARAM2 op_8b9_0(uae_u32 opcode) /* BCLR */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}m68k_incpc(8);
endlabel204: (void)0;
return 12;
}
unsigned long REGPARAM2 op_8ba_0(uae_u32 opcode) /* BCLR */
{
	uae_u32 dstreg = 2;
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = m68k_getpc () + 4;
	dsta += (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}m68k_incpc(6);
endlabel205: (void)0;
return 10;
}
unsigned long REGPARAM2 op_8bb_0(uae_u32 opcode) /* BCLR */
{
	uae_u32 dstreg = 3;
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}endlabel206: (void)0;
return 8;
}
unsigned long REGPARAM2 op_8c0_0(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
	src &= 31;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	m68k_dreg(regs, dstreg) = (dst);
}}}m68k_incpc(4);
endlabel207: (void)0;
return 4;
}
unsigned long REGPARAM2 op_8d0_0(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel208: (void)0;
return 8;
}
unsigned long REGPARAM2 op_8d8_0(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel209: (void)0;
return 8;
}
unsigned long REGPARAM2 op_8e0_0(uae_u32 opcode) /* BSET */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel210: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_8e8_0(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(6);
endlabel211: (void)0;
return 10;
}
unsigned long REGPARAM2 op_8f0_0(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}endlabel212: (void)0;
return 8;
}
unsigned long REGPARAM2 op_8f8_0(uae_u32 opcode) /* BSET */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}m68k_incpc(6);
endlabel213: (void)0;
return 10;
}
unsigned long REGPARAM2 op_8f9_0(uae_u32 opcode) /* BSET */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}m68k_incpc(8);
endlabel214: (void)0;
return 12;
}
unsigned long REGPARAM2 op_8fa_0(uae_u32 opcode) /* BSET */
{
	uae_u32 dstreg = 2;
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = m68k_getpc () + 4;
	dsta += (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}m68k_incpc(6);
endlabel215: (void)0;
return 10;
}
unsigned long REGPARAM2 op_8fb_0(uae_u32 opcode) /* BSET */
{
	uae_u32 dstreg = 3;
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}endlabel216: (void)0;
return 8;
}
unsigned long REGPARAM2 op_a00_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uae_s8 src = get_ibyte(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}m68k_incpc(4);
endlabel217: (void)0;
return 4;
}
unsigned long REGPARAM2 op_a10_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel218: (void)0;
return 8;
}
unsigned long REGPARAM2 op_a18_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel219: (void)0;
return 8;
}
unsigned long REGPARAM2 op_a20_0(uae_u32 opcode) /* EOR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel220: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_a28_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel221: (void)0;
return 10;
}
unsigned long REGPARAM2 op_a30_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = get_ibyte(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel222: (void)0;
return 8;
}
unsigned long REGPARAM2 op_a38_0(uae_u32 opcode) /* EOR */
{
{{	uae_s8 src = get_ibyte(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(6);
endlabel223: (void)0;
return 10;
}
unsigned long REGPARAM2 op_a39_0(uae_u32 opcode) /* EOR */
{
{{	uae_s8 src = get_ibyte(2);
	uaecptr dsta = get_ilong(4);
{	uae_s8 dst = get_byte(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(8);
endlabel224: (void)0;
return 12;
}
unsigned long REGPARAM2 op_a3c_0(uae_u32 opcode) /* EORSR */
{
{	MakeSR();
{	uae_s16 src = get_iword(2);
	src &= 0xFF;
	regs.sr ^= src;
	MakeFromSR();
}}m68k_incpc(4);
endlabel225: (void)0;
return 4;
}
unsigned long REGPARAM2 op_a40_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}m68k_incpc(4);
endlabel226: (void)0;
return 4;
}
unsigned long REGPARAM2 op_a50_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel227: (void)0;
return 8;
}
unsigned long REGPARAM2 op_a58_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel228: (void)0;
return 8;
}
unsigned long REGPARAM2 op_a60_0(uae_u32 opcode) /* EOR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel229: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_a68_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel230: (void)0;
return 10;
}
unsigned long REGPARAM2 op_a70_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s16 dst = get_word(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel231: (void)0;
return 8;
}
#endif

#ifdef PART_2
unsigned long REGPARAM2 op_a78_0(uae_u32 opcode) /* EOR */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 dst = get_word(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(6);
endlabel232: (void)0;
return 10;
}
unsigned long REGPARAM2 op_a79_0(uae_u32 opcode) /* EOR */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s16 dst = get_word(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(8);
endlabel233: (void)0;
return 12;
}
unsigned long REGPARAM2 op_a7c_0(uae_u32 opcode) /* EORSR */
{
{if (!regs.s) { Exception(8,0); goto endlabel234; }
{	MakeSR();
{	uae_s16 src = get_iword(2);
	regs.sr ^= src;
	MakeFromSR();
}}}m68k_incpc(4);
endlabel234: (void)0;
return 4;
}
unsigned long REGPARAM2 op_a80_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}m68k_incpc(6);
endlabel235: (void)0;
return 6;
}
unsigned long REGPARAM2 op_a90_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel236: (void)0;
return 14;
}
unsigned long REGPARAM2 op_a98_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel237: (void)0;
return 14;
}
unsigned long REGPARAM2 op_aa0_0(uae_u32 opcode) /* EOR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel238: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 14;
}
unsigned long REGPARAM2 op_aa8_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(8);
endlabel239: (void)0;
return 16;
}
unsigned long REGPARAM2 op_ab0_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = get_ilong(2);
m68k_incpc(6);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel240: (void)0;
return 14;
}
unsigned long REGPARAM2 op_ab8_0(uae_u32 opcode) /* EOR */
{
{{	uae_s32 src = get_ilong(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 dst = get_long(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(8);
endlabel241: (void)0;
return 16;
}
unsigned long REGPARAM2 op_ab9_0(uae_u32 opcode) /* EOR */
{
{{	uae_s32 src = get_ilong(2);
	uaecptr dsta = get_ilong(6);
{	uae_s32 dst = get_long(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(10);
endlabel242: (void)0;
return 18;
}
unsigned long REGPARAM2 op_ad0_0(uae_u32 opcode) /* CAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s8)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(m68k_dreg(regs, rc))) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_byte(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}}m68k_incpc(4);
endlabel243: (void)0;
return 8;
}
unsigned long REGPARAM2 op_ad8_0(uae_u32 opcode) /* CAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s8)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(m68k_dreg(regs, rc))) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_byte(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}}m68k_incpc(4);
endlabel244: (void)0;
return 8;
}
unsigned long REGPARAM2 op_ae0_0(uae_u32 opcode) /* CAS */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s8)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(m68k_dreg(regs, rc))) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_byte(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}}m68k_incpc(4);
endlabel245: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_ae8_0(uae_u32 opcode) /* CAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s8)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(m68k_dreg(regs, rc))) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_byte(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}}m68k_incpc(6);
endlabel246: (void)0;
return 10;
}
unsigned long REGPARAM2 op_af0_0(uae_u32 opcode) /* CAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s8)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(m68k_dreg(regs, rc))) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_byte(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}}endlabel247: (void)0;
return 8;
}
unsigned long REGPARAM2 op_af8_0(uae_u32 opcode) /* CAS */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s8)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(m68k_dreg(regs, rc))) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_byte(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}m68k_incpc(6);
endlabel248: (void)0;
return 10;
}
unsigned long REGPARAM2 op_af9_0(uae_u32 opcode) /* CAS */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s8 dst = get_byte(dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s8)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(m68k_dreg(regs, rc))) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_byte(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}m68k_incpc(8);
endlabel249: (void)0;
return 12;
}
unsigned long REGPARAM2 op_c00_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(4);
endlabel250: (void)0;
return 4;
}
unsigned long REGPARAM2 op_c10_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel251: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c18_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel252: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c20_0(uae_u32 opcode) /* CMP */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel253: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_c28_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(6);
endlabel254: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c30_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = get_ibyte(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel255: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c38_0(uae_u32 opcode) /* CMP */
{
{{	uae_s8 src = get_ibyte(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(6);
endlabel256: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c39_0(uae_u32 opcode) /* CMP */
{
{{	uae_s8 src = get_ibyte(2);
	uaecptr dsta = get_ilong(4);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(8);
endlabel257: (void)0;
return 10;
}
unsigned long REGPARAM2 op_c3a_0(uae_u32 opcode) /* CMP */
{
	uae_u32 dstreg = 2;
{{	uae_s8 src = get_ibyte(2);
	uaecptr dsta = m68k_getpc () + 4;
	dsta += (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(6);
endlabel258: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c3b_0(uae_u32 opcode) /* CMP */
{
	uae_u32 dstreg = 3;
{{	uae_s8 src = get_ibyte(2);
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel259: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c40_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(4);
endlabel260: (void)0;
return 4;
}
unsigned long REGPARAM2 op_c50_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel261: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c58_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel262: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c60_0(uae_u32 opcode) /* CMP */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel263: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_c68_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(6);
endlabel264: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c70_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel265: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c78_0(uae_u32 opcode) /* CMP */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(6);
endlabel266: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c79_0(uae_u32 opcode) /* CMP */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(8);
endlabel267: (void)0;
return 10;
}
unsigned long REGPARAM2 op_c7a_0(uae_u32 opcode) /* CMP */
{
	uae_u32 dstreg = 2;
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = m68k_getpc () + 4;
	dsta += (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(6);
endlabel268: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c7b_0(uae_u32 opcode) /* CMP */
{
	uae_u32 dstreg = 3;
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel269: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c80_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(6);
endlabel270: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c90_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(6);
endlabel271: (void)0;
return 10;
}
unsigned long REGPARAM2 op_c98_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(6);
endlabel272: (void)0;
return 10;
}
unsigned long REGPARAM2 op_ca0_0(uae_u32 opcode) /* CMP */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(6);
endlabel273: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_ca8_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(8);
endlabel274: (void)0;
return 12;
}
unsigned long REGPARAM2 op_cb0_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = get_ilong(2);
m68k_incpc(6);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel275: (void)0;
return 10;
}
unsigned long REGPARAM2 op_cb8_0(uae_u32 opcode) /* CMP */
{
{{	uae_s32 src = get_ilong(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(8);
endlabel276: (void)0;
return 12;
}
unsigned long REGPARAM2 op_cb9_0(uae_u32 opcode) /* CMP */
{
{{	uae_s32 src = get_ilong(2);
	uaecptr dsta = get_ilong(6);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(10);
endlabel277: (void)0;
return 14;
}
unsigned long REGPARAM2 op_cba_0(uae_u32 opcode) /* CMP */
{
	uae_u32 dstreg = 2;
{{	uae_s32 src = get_ilong(2);
	uaecptr dsta = m68k_getpc () + 6;
	dsta += (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(8);
endlabel278: (void)0;
return 12;
}
unsigned long REGPARAM2 op_cbb_0(uae_u32 opcode) /* CMP */
{
	uae_u32 dstreg = 3;
{{	uae_s32 src = get_ilong(2);
m68k_incpc(6);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel279: (void)0;
return 10;
}
unsigned long REGPARAM2 op_cd0_0(uae_u32 opcode) /* CAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s16)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(m68k_dreg(regs, rc))) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_word(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}}m68k_incpc(4);
endlabel280: (void)0;
return 8;
}
unsigned long REGPARAM2 op_cd8_0(uae_u32 opcode) /* CAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s16)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(m68k_dreg(regs, rc))) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_word(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}}m68k_incpc(4);
endlabel281: (void)0;
return 8;
}
unsigned long REGPARAM2 op_ce0_0(uae_u32 opcode) /* CAS */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s16)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(m68k_dreg(regs, rc))) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_word(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}}m68k_incpc(4);
endlabel282: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_ce8_0(uae_u32 opcode) /* CAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s16)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(m68k_dreg(regs, rc))) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_word(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}}m68k_incpc(6);
endlabel283: (void)0;
return 10;
}
unsigned long REGPARAM2 op_cf0_0(uae_u32 opcode) /* CAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s16 dst = get_word(dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s16)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(m68k_dreg(regs, rc))) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_word(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}}endlabel284: (void)0;
return 8;
}
unsigned long REGPARAM2 op_cf8_0(uae_u32 opcode) /* CAS */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 dst = get_word(dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s16)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(m68k_dreg(regs, rc))) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_word(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}m68k_incpc(6);
endlabel285: (void)0;
return 10;
}
unsigned long REGPARAM2 op_cf9_0(uae_u32 opcode) /* CAS */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s16 dst = get_word(dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s16)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(m68k_dreg(regs, rc))) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_word(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}m68k_incpc(8);
endlabel286: (void)0;
return 12;
}
unsigned long REGPARAM2 op_cfc_0(uae_u32 opcode) /* CAS2 */
{
{{	uae_s32 extra = get_ilong(2);
	uae_u32 rn1 = regs.regs[(extra >> 28) & 7];
	uae_u32 rn2 = regs.regs[(extra >> 12) & 7];
	uae_u16 dst1 = get_word(rn1), dst2 = get_word(rn2);
{uae_u32 newv = ((uae_s16)(dst1)) - ((uae_s16)(m68k_dreg(regs, (extra >> 16) & 7)));
{	int flgs = ((uae_s16)(m68k_dreg(regs, (extra >> 16) & 7))) < 0;
	int flgo = ((uae_s16)(dst1)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(m68k_dreg(regs, (extra >> 16) & 7))) > ((uae_u16)(dst1));
	NFLG = flgn != 0;
	if (ZFLG) {
{uae_u32 newv = ((uae_s16)(dst2)) - ((uae_s16)(m68k_dreg(regs, extra & 7)));
{	int flgs = ((uae_s16)(m68k_dreg(regs, extra & 7))) < 0;
	int flgo = ((uae_s16)(dst2)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(m68k_dreg(regs, extra & 7))) > ((uae_u16)(dst2));
	NFLG = flgn != 0;
	if (ZFLG) {
	put_word(rn1, m68k_dreg(regs, (extra >> 22) & 7));
	put_word(rn1, m68k_dreg(regs, (extra >> 6) & 7));
	}}
}}}}	if (!ZFLG) {
	m68k_dreg(regs, (extra >> 22) & 7) = (m68k_dreg(regs, (extra >> 22) & 7) & ~0xffff) | (dst1 & 0xffff);
	m68k_dreg(regs, (extra >> 6) & 7) = (m68k_dreg(regs, (extra >> 6) & 7) & ~0xffff) | (dst2 & 0xffff);
	}
}}m68k_incpc(6);
endlabel287: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e10_0(uae_u32 opcode) /* MOVES */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{if (!regs.s) { Exception(8,0); goto endlabel288; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = m68k_areg(regs, dstreg);
	put_byte(dsta,src);
}}else{{	uaecptr srca = m68k_areg(regs, dstreg);
{	uae_s8 src = get_byte(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = (uae_s32)(uae_s8)src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (m68k_dreg(regs, (extra >> 12) & 7) & ~0xff) | ((src) & 0xff);
	}
}}}}}}m68k_incpc(4);
endlabel288: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e18_0(uae_u32 opcode) /* MOVES */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{if (!regs.s) { Exception(8,0); goto endlabel289; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
	put_byte(dsta,src);
}}else{{	uaecptr srca = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 src = get_byte(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = (uae_s32)(uae_s8)src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (m68k_dreg(regs, (extra >> 12) & 7) & ~0xff) | ((src) & 0xff);
	}
}}}}}}m68k_incpc(4);
endlabel289: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e20_0(uae_u32 opcode) /* MOVES */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{if (!regs.s) { Exception(8,0); goto endlabel290; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
	put_byte(dsta,src);
}}else{{	uaecptr srca = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = srca;
{	uae_s8 src = get_byte(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = (uae_s32)(uae_s8)src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (m68k_dreg(regs, (extra >> 12) & 7) & ~0xff) | ((src) & 0xff);
	}
}}}}}}m68k_incpc(4);
endlabel290: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_e28_0(uae_u32 opcode) /* MOVES */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{if (!regs.s) { Exception(8,0); goto endlabel291; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
	put_byte(dsta,src);
}}else{{	uaecptr srca = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(6);
{	uae_s8 src = get_byte(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = (uae_s32)(uae_s8)src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (m68k_dreg(regs, (extra >> 12) & 7) & ~0xff) | ((src) & 0xff);
	}
}}}}}}m68k_incpc(8);
endlabel291: (void)0;
return 12;
}
unsigned long REGPARAM2 op_e30_0(uae_u32 opcode) /* MOVES */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{if (!regs.s) { Exception(8,0); goto endlabel292; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	put_byte(dsta,src);
}}else{{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 src = get_byte(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = (uae_s32)(uae_s8)src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (m68k_dreg(regs, (extra >> 12) & 7) & ~0xff) | ((src) & 0xff);
	}
}}}}}}endlabel292: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e38_0(uae_u32 opcode) /* MOVES */
{
{if (!regs.s) { Exception(8,0); goto endlabel293; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	put_byte(dsta,src);
}}else{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(6);
{	uae_s8 src = get_byte(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = (uae_s32)(uae_s8)src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (m68k_dreg(regs, (extra >> 12) & 7) & ~0xff) | ((src) & 0xff);
	}
}}}}}}m68k_incpc(8);
endlabel293: (void)0;
return 12;
}
unsigned long REGPARAM2 op_e39_0(uae_u32 opcode) /* MOVES */
{
{if (!regs.s) { Exception(8,0); goto endlabel294; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = get_ilong(4);
	put_byte(dsta,src);
}}else{{	uaecptr srca = get_ilong(8);
{	uae_s8 src = get_byte(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = (uae_s32)(uae_s8)src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (m68k_dreg(regs, (extra >> 12) & 7) & ~0xff) | ((src) & 0xff);
	}
}}}}}}m68k_incpc(12);
endlabel294: (void)0;
return 16;
}
unsigned long REGPARAM2 op_e50_0(uae_u32 opcode) /* MOVES */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{if (!regs.s) { Exception(8,0); goto endlabel295; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = m68k_areg(regs, dstreg);
	put_word(dsta,src);
}}else{{	uaecptr srca = m68k_areg(regs, dstreg);
{	uae_s16 src = get_word(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = (uae_s32)(uae_s16)src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (m68k_dreg(regs, (extra >> 12) & 7) & ~0xffff) | ((src) & 0xffff);
	}
}}}}}}m68k_incpc(4);
endlabel295: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e58_0(uae_u32 opcode) /* MOVES */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{if (!regs.s) { Exception(8,0); goto endlabel296; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
	put_word(dsta,src);
}}else{{	uaecptr srca = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 src = get_word(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = (uae_s32)(uae_s16)src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (m68k_dreg(regs, (extra >> 12) & 7) & ~0xffff) | ((src) & 0xffff);
	}
}}}}}}m68k_incpc(4);
endlabel296: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e60_0(uae_u32 opcode) /* MOVES */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{if (!regs.s) { Exception(8,0); goto endlabel297; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
	put_word(dsta,src);
}}else{{	uaecptr srca = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = srca;
{	uae_s16 src = get_word(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = (uae_s32)(uae_s16)src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (m68k_dreg(regs, (extra >> 12) & 7) & ~0xffff) | ((src) & 0xffff);
	}
}}}}}}m68k_incpc(4);
endlabel297: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_e68_0(uae_u32 opcode) /* MOVES */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{if (!regs.s) { Exception(8,0); goto endlabel298; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
	put_word(dsta,src);
}}else{{	uaecptr srca = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(6);
{	uae_s16 src = get_word(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = (uae_s32)(uae_s16)src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (m68k_dreg(regs, (extra >> 12) & 7) & ~0xffff) | ((src) & 0xffff);
	}
}}}}}}m68k_incpc(8);
endlabel298: (void)0;
return 12;
}
unsigned long REGPARAM2 op_e70_0(uae_u32 opcode) /* MOVES */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{if (!regs.s) { Exception(8,0); goto endlabel299; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	put_word(dsta,src);
}}else{{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s16 src = get_word(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = (uae_s32)(uae_s16)src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (m68k_dreg(regs, (extra >> 12) & 7) & ~0xffff) | ((src) & 0xffff);
	}
}}}}}}endlabel299: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e78_0(uae_u32 opcode) /* MOVES */
{
{if (!regs.s) { Exception(8,0); goto endlabel300; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	put_word(dsta,src);
}}else{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(6);
{	uae_s16 src = get_word(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = (uae_s32)(uae_s16)src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (m68k_dreg(regs, (extra >> 12) & 7) & ~0xffff) | ((src) & 0xffff);
	}
}}}}}}m68k_incpc(8);
endlabel300: (void)0;
return 12;
}
unsigned long REGPARAM2 op_e79_0(uae_u32 opcode) /* MOVES */
{
{if (!regs.s) { Exception(8,0); goto endlabel301; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = get_ilong(4);
	put_word(dsta,src);
}}else{{	uaecptr srca = get_ilong(8);
{	uae_s16 src = get_word(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = (uae_s32)(uae_s16)src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (m68k_dreg(regs, (extra >> 12) & 7) & ~0xffff) | ((src) & 0xffff);
	}
}}}}}}m68k_incpc(12);
endlabel301: (void)0;
return 16;
}
unsigned long REGPARAM2 op_e90_0(uae_u32 opcode) /* MOVES */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{if (!regs.s) { Exception(8,0); goto endlabel302; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = m68k_areg(regs, dstreg);
	put_long(dsta,src);
}}else{{	uaecptr srca = m68k_areg(regs, dstreg);
{	uae_s32 src = get_long(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (src);
	}
}}}}}}m68k_incpc(4);
endlabel302: (void)0;
return 12;
}
unsigned long REGPARAM2 op_e98_0(uae_u32 opcode) /* MOVES */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{if (!regs.s) { Exception(8,0); goto endlabel303; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
	put_long(dsta,src);
}}else{{	uaecptr srca = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 src = get_long(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (src);
	}
}}}}}}m68k_incpc(4);
endlabel303: (void)0;
return 12;
}
unsigned long REGPARAM2 op_ea0_0(uae_u32 opcode) /* MOVES */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{if (!regs.s) { Exception(8,0); goto endlabel304; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
	put_long(dsta,src);
}}else{{	uaecptr srca = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = srca;
{	uae_s32 src = get_long(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (src);
	}
}}}}}}m68k_incpc(4);
endlabel304: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 12;
}
unsigned long REGPARAM2 op_ea8_0(uae_u32 opcode) /* MOVES */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{if (!regs.s) { Exception(8,0); goto endlabel305; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
	put_long(dsta,src);
}}else{{	uaecptr srca = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 src = get_long(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (src);
	}
}}}}}}m68k_incpc(8);
endlabel305: (void)0;
return 16;
}
unsigned long REGPARAM2 op_eb0_0(uae_u32 opcode) /* MOVES */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{if (!regs.s) { Exception(8,0); goto endlabel306; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	put_long(dsta,src);
}}else{{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 src = get_long(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (src);
	}
}}}}}}endlabel306: (void)0;
return 12;
}
unsigned long REGPARAM2 op_eb8_0(uae_u32 opcode) /* MOVES */
{
{if (!regs.s) { Exception(8,0); goto endlabel307; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	put_long(dsta,src);
}}else{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 src = get_long(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (src);
	}
}}}}}}m68k_incpc(8);
endlabel307: (void)0;
return 16;
}
unsigned long REGPARAM2 op_eb9_0(uae_u32 opcode) /* MOVES */
{
{if (!regs.s) { Exception(8,0); goto endlabel308; }
{{	uae_s16 extra = get_iword(2);
	if (extra & 0x800)
{	uae_u32 src = regs.regs[(extra >> 12) & 15];
{	uaecptr dsta = get_ilong(4);
	put_long(dsta,src);
}}else{{	uaecptr srca = get_ilong(8);
{	uae_s32 src = get_long(srca);
	if (extra & 0x8000) {
	m68k_areg(regs, (extra >> 12) & 7) = src;
	} else {
	m68k_dreg(regs, (extra >> 12) & 7) = (src);
	}
}}}}}}m68k_incpc(12);
endlabel308: (void)0;
return 20;
}
unsigned long REGPARAM2 op_ed0_0(uae_u32 opcode) /* CAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
{	uae_s16 src = get_iword(2);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s32)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(m68k_dreg(regs, rc))) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_long(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}}m68k_incpc(4);
endlabel309: (void)0;
return 12;
}
unsigned long REGPARAM2 op_ed8_0(uae_u32 opcode) /* CAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
{	uae_s16 src = get_iword(2);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s32)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(m68k_dreg(regs, rc))) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_long(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}}m68k_incpc(4);
endlabel310: (void)0;
return 12;
}
unsigned long REGPARAM2 op_ee0_0(uae_u32 opcode) /* CAS */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
{	uae_s16 src = get_iword(2);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s32)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(m68k_dreg(regs, rc))) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_long(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}}m68k_incpc(4);
endlabel311: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 12;
}
unsigned long REGPARAM2 op_ee8_0(uae_u32 opcode) /* CAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 dst = get_long(dsta);
{	uae_s16 src = get_iword(2);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s32)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(m68k_dreg(regs, rc))) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_long(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}}m68k_incpc(6);
endlabel312: (void)0;
return 14;
}
unsigned long REGPARAM2 op_ef0_0(uae_u32 opcode) /* CAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s32)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(m68k_dreg(regs, rc))) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_long(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}}endlabel313: (void)0;
return 12;
}
unsigned long REGPARAM2 op_ef8_0(uae_u32 opcode) /* CAS */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 dst = get_long(dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s32)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(m68k_dreg(regs, rc))) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_long(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}m68k_incpc(6);
endlabel314: (void)0;
return 14;
}
unsigned long REGPARAM2 op_ef9_0(uae_u32 opcode) /* CAS */
{
{{	uae_s16 src = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s32 dst = get_long(dsta);
{	int ru = (src >> 6) & 7;
	int rc = src & 7;
{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(m68k_dreg(regs, rc)));
{	int flgs = ((uae_s32)(m68k_dreg(regs, rc))) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(m68k_dreg(regs, rc))) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	if (ZFLG){	put_long(dsta,(m68k_dreg(regs, ru)));
}else{m68k_dreg(regs, rc) = dst;
}}}}}}}m68k_incpc(8);
endlabel315: (void)0;
return 16;
}
unsigned long REGPARAM2 op_efc_0(uae_u32 opcode) /* CAS2 */
{
{{	uae_s32 extra = get_ilong(2);
	uae_u32 rn1 = regs.regs[(extra >> 28) & 7];
	uae_u32 rn2 = regs.regs[(extra >> 12) & 7];
	uae_u32 dst1 = get_long(rn1), dst2 = get_long(rn2);
{uae_u32 newv = ((uae_s32)(dst1)) - ((uae_s32)(m68k_dreg(regs, (extra >> 16) & 7)));
{	int flgs = ((uae_s32)(m68k_dreg(regs, (extra >> 16) & 7))) < 0;
	int flgo = ((uae_s32)(dst1)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(m68k_dreg(regs, (extra >> 16) & 7))) > ((uae_u32)(dst1));
	NFLG = flgn != 0;
	if (ZFLG) {
{uae_u32 newv = ((uae_s32)(dst2)) - ((uae_s32)(m68k_dreg(regs, extra & 7)));
{	int flgs = ((uae_s32)(m68k_dreg(regs, extra & 7))) < 0;
	int flgo = ((uae_s32)(dst2)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(m68k_dreg(regs, extra & 7))) > ((uae_u32)(dst2));
	NFLG = flgn != 0;
	if (ZFLG) {
	put_long(rn1, m68k_dreg(regs, (extra >> 22) & 7));
	put_long(rn1, m68k_dreg(regs, (extra >> 6) & 7));
	}}
}}}}	if (!ZFLG) {
	m68k_dreg(regs, (extra >> 22) & 7) = dst1;
	m68k_dreg(regs, (extra >> 6) & 7) = dst2;
	}
}}m68k_incpc(6);
endlabel316: (void)0;
return 6;
}
unsigned long REGPARAM2 op_1000_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}m68k_incpc(2);
endlabel317: (void)0;
return 2;
}
unsigned long REGPARAM2 op_1010_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(2);
endlabel318: (void)0;
return 4;
}
unsigned long REGPARAM2 op_1018_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(2);
endlabel319: (void)0;
return 4;
}
unsigned long REGPARAM2 op_1020_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(2);
endlabel320: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_1028_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(4);
endlabel321: (void)0;
return 6;
}
unsigned long REGPARAM2 op_1030_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}endlabel322: (void)0;
return 4;
}
unsigned long REGPARAM2 op_1038_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(4);
endlabel323: (void)0;
return 6;
}
unsigned long REGPARAM2 op_1039_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(6);
endlabel324: (void)0;
return 8;
}
unsigned long REGPARAM2 op_103a_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(4);
endlabel325: (void)0;
return 6;
}
unsigned long REGPARAM2 op_103b_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 src = get_byte(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}endlabel326: (void)0;
return 4;
}
unsigned long REGPARAM2 op_103c_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uae_s8 src = get_ibyte(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}m68k_incpc(4);
endlabel327: (void)0;
return 4;
}
unsigned long REGPARAM2 op_1080_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(2);
endlabel328: (void)0;
return 4;
}
unsigned long REGPARAM2 op_1090_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel329: (void)0;
return 6;
}
unsigned long REGPARAM2 op_1098_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel330: (void)0;
return 6;
}
unsigned long REGPARAM2 op_10a0_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel331: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_10a8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel332: (void)0;
return 8;
}
unsigned long REGPARAM2 op_10b0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel333: (void)0;
return 6;
}
unsigned long REGPARAM2 op_10b8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel334: (void)0;
return 8;
}
unsigned long REGPARAM2 op_10b9_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel335: (void)0;
return 10;
}
unsigned long REGPARAM2 op_10ba_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel336: (void)0;
return 8;
}
unsigned long REGPARAM2 op_10bb_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel337: (void)0;
return 6;
}
unsigned long REGPARAM2 op_10bc_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 src = get_ibyte(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(4);
endlabel338: (void)0;
return 6;
}
unsigned long REGPARAM2 op_10c0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(2);
endlabel339: (void)0;
return 4;
}
unsigned long REGPARAM2 op_10d0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel340: (void)0;
return 6;
}
unsigned long REGPARAM2 op_10d8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel341: (void)0;
return 6;
}
unsigned long REGPARAM2 op_10e0_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel342: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_10e8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel343: (void)0;
return 8;
}
unsigned long REGPARAM2 op_10f0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel344: (void)0;
return 6;
}
unsigned long REGPARAM2 op_10f8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel345: (void)0;
return 8;
}
unsigned long REGPARAM2 op_10f9_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel346: (void)0;
return 10;
}
unsigned long REGPARAM2 op_10fa_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel347: (void)0;
return 8;
}
unsigned long REGPARAM2 op_10fb_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel348: (void)0;
return 6;
}
unsigned long REGPARAM2 op_10fc_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 src = get_ibyte(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(4);
endlabel349: (void)0;
return 6;
}
unsigned long REGPARAM2 op_1100_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(2);
endlabel350: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_1110_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel351: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_1118_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel352: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_1120_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel353: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_1128_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel354: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_1130_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel355: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_1138_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel356: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_1139_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel357: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_113a_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel358: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_113b_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel359: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_113c_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 src = get_ibyte(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(4);
endlabel360: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_1140_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(4);
endlabel361: (void)0;
return 6;
}
unsigned long REGPARAM2 op_1150_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel362: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1158_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel363: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1160_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel364: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_1168_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel365: (void)0;
return 10;
}
unsigned long REGPARAM2 op_1170_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel366: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1178_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel367: (void)0;
return 10;
}
unsigned long REGPARAM2 op_1179_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(6);
{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(8);
endlabel368: (void)0;
return 12;
}
unsigned long REGPARAM2 op_117a_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel369: (void)0;
return 10;
}
unsigned long REGPARAM2 op_117b_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel370: (void)0;
return 8;
}
unsigned long REGPARAM2 op_117c_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s8 src = get_ibyte(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(6);
endlabel371: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1180_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}endlabel372: (void)0;
return 4;
}
unsigned long REGPARAM2 op_1190_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel373: (void)0;
return 6;
}
unsigned long REGPARAM2 op_1198_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel374: (void)0;
return 6;
}
unsigned long REGPARAM2 op_11a0_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel375: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_11a8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel376: (void)0;
return 8;
}
unsigned long REGPARAM2 op_11b0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel377: (void)0;
return 6;
}
unsigned long REGPARAM2 op_11b8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel378: (void)0;
return 8;
}
unsigned long REGPARAM2 op_11b9_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
m68k_incpc(6);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel379: (void)0;
return 10;
}
unsigned long REGPARAM2 op_11ba_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel380: (void)0;
return 8;
}
unsigned long REGPARAM2 op_11bb_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel381: (void)0;
return 6;
}
unsigned long REGPARAM2 op_11bc_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = get_ibyte(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}endlabel382: (void)0;
return 6;
}
unsigned long REGPARAM2 op_11c0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(4);
endlabel383: (void)0;
return 6;
}
unsigned long REGPARAM2 op_11d0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel384: (void)0;
return 8;
}
unsigned long REGPARAM2 op_11d8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel385: (void)0;
return 8;
}
unsigned long REGPARAM2 op_11e0_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel386: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_11e8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel387: (void)0;
return 10;
}
unsigned long REGPARAM2 op_11f0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel388: (void)0;
return 8;
}
unsigned long REGPARAM2 op_11f8_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(6);
endlabel389: (void)0;
return 10;
}
unsigned long REGPARAM2 op_11f9_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(6);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(8);
endlabel390: (void)0;
return 12;
}
unsigned long REGPARAM2 op_11fa_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(6);
endlabel391: (void)0;
return 10;
}
unsigned long REGPARAM2 op_11fb_0(uae_u32 opcode) /* MOVE */
{
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel392: (void)0;
return 8;
}
unsigned long REGPARAM2 op_11fc_0(uae_u32 opcode) /* MOVE */
{
{{	uae_s8 src = get_ibyte(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}m68k_incpc(6);
endlabel393: (void)0;
return 8;
}
unsigned long REGPARAM2 op_13c0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(6);
endlabel394: (void)0;
return 8;
}
unsigned long REGPARAM2 op_13d0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel395: (void)0;
return 10;
}
unsigned long REGPARAM2 op_13d8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel396: (void)0;
return 10;
}
unsigned long REGPARAM2 op_13e0_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel397: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_13e8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(8);
endlabel398: (void)0;
return 12;
}
unsigned long REGPARAM2 op_13f0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = get_ilong(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel399: (void)0;
return 10;
}
unsigned long REGPARAM2 op_13f8_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(8);
endlabel400: (void)0;
return 12;
}
unsigned long REGPARAM2 op_13f9_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
	uaecptr dsta = get_ilong(6);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(10);
endlabel401: (void)0;
return 14;
}
unsigned long REGPARAM2 op_13fa_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(8);
endlabel402: (void)0;
return 12;
}
unsigned long REGPARAM2 op_13fb_0(uae_u32 opcode) /* MOVE */
{
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = get_ilong(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel403: (void)0;
return 10;
}
unsigned long REGPARAM2 op_13fc_0(uae_u32 opcode) /* MOVE */
{
{{	uae_s8 src = get_ibyte(2);
	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}m68k_incpc(8);
endlabel404: (void)0;
return 10;
}
unsigned long REGPARAM2 op_2000_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}m68k_incpc(2);
endlabel405: (void)0;
return 2;
}
unsigned long REGPARAM2 op_2008_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}m68k_incpc(2);
endlabel406: (void)0;
return 2;
}
unsigned long REGPARAM2 op_2010_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(2);
endlabel407: (void)0;
return 6;
}
unsigned long REGPARAM2 op_2018_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(2);
endlabel408: (void)0;
return 6;
}
unsigned long REGPARAM2 op_2020_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(2);
endlabel409: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_2028_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(4);
endlabel410: (void)0;
return 8;
}
unsigned long REGPARAM2 op_2030_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}endlabel411: (void)0;
return 6;
}
unsigned long REGPARAM2 op_2038_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(4);
endlabel412: (void)0;
return 8;
}
unsigned long REGPARAM2 op_2039_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(6);
endlabel413: (void)0;
return 10;
}
unsigned long REGPARAM2 op_203a_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(4);
endlabel414: (void)0;
return 8;
}
unsigned long REGPARAM2 op_203b_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}endlabel415: (void)0;
return 6;
}
unsigned long REGPARAM2 op_203c_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uae_s32 src = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}m68k_incpc(6);
endlabel416: (void)0;
return 6;
}
unsigned long REGPARAM2 op_2040_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_u32 val = src;
	m68k_areg(regs, dstreg) = (val);
}}}m68k_incpc(2);
endlabel417: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 2;
}
unsigned long REGPARAM2 op_2048_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	uae_u32 val = src;
	m68k_areg(regs, dstreg) = (val);
}}}m68k_incpc(2);
endlabel418: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 2;
}
unsigned long REGPARAM2 op_2050_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uae_u32 val = src;
	m68k_areg(regs, dstreg) = (val);
}}}}m68k_incpc(2);
endlabel419: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 6;
}
unsigned long REGPARAM2 op_2058_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uae_u32 val = src;
	m68k_areg(regs, dstreg) = (val);
}}}}m68k_incpc(2);
endlabel420: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 6;
}
unsigned long REGPARAM2 op_2060_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uae_u32 val = src;
	m68k_areg(regs, dstreg) = (val);
}}}}m68k_incpc(2);
endlabel421: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 6;
}
unsigned long REGPARAM2 op_2068_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_u32 val = src;
	m68k_areg(regs, dstreg) = (val);
}}}}m68k_incpc(4);
endlabel422: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 8;
}
unsigned long REGPARAM2 op_2070_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uae_u32 val = src;
	m68k_areg(regs, dstreg) = (val);
}}}}endlabel423: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 6;
}
unsigned long REGPARAM2 op_2078_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	uae_u32 val = src;
	m68k_areg(regs, dstreg) = (val);
}}}}m68k_incpc(4);
endlabel424: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 8;
}
unsigned long REGPARAM2 op_2079_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
	uae_u32 val = src;
	m68k_areg(regs, dstreg) = (val);
}}}}m68k_incpc(6);
endlabel425: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 10;
}
unsigned long REGPARAM2 op_207a_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	uae_u32 val = src;
	m68k_areg(regs, dstreg) = (val);
}}}}}m68k_incpc(4);
endlabel426: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 8;
}
unsigned long REGPARAM2 op_207b_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uae_u32 val = src;
	m68k_areg(regs, dstreg) = (val);
}}}}endlabel427: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 6;
}
unsigned long REGPARAM2 op_207c_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uae_s32 src = get_ilong(2);
	uae_u32 val = src;
	m68k_areg(regs, dstreg) = (val);
}}}m68k_incpc(6);
endlabel428: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 6;
}
unsigned long REGPARAM2 op_2080_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(2);
endlabel429: (void)0;
return 6;
}
unsigned long REGPARAM2 op_2088_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(2);
endlabel430: (void)0;
return 6;
}
unsigned long REGPARAM2 op_2090_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel431: (void)0;
return 10;
}
unsigned long REGPARAM2 op_2098_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel432: (void)0;
return 10;
}
unsigned long REGPARAM2 op_20a0_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel433: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_20a8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel434: (void)0;
return 12;
}
unsigned long REGPARAM2 op_20b0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel435: (void)0;
return 10;
}
unsigned long REGPARAM2 op_20b8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel436: (void)0;
return 12;
}
unsigned long REGPARAM2 op_20b9_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel437: (void)0;
return 14;
}
unsigned long REGPARAM2 op_20ba_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel438: (void)0;
return 12;
}
unsigned long REGPARAM2 op_20bb_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel439: (void)0;
return 10;
}
unsigned long REGPARAM2 op_20bc_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(6);
endlabel440: (void)0;
return 10;
}
unsigned long REGPARAM2 op_20c0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(2);
endlabel441: (void)0;
return 6;
}
unsigned long REGPARAM2 op_20c8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(2);
endlabel442: (void)0;
return 6;
}
unsigned long REGPARAM2 op_20d0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel443: (void)0;
return 10;
}
unsigned long REGPARAM2 op_20d8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel444: (void)0;
return 10;
}
unsigned long REGPARAM2 op_20e0_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel445: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_20e8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel446: (void)0;
return 12;
}
unsigned long REGPARAM2 op_20f0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel447: (void)0;
return 10;
}
unsigned long REGPARAM2 op_20f8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel448: (void)0;
return 12;
}
unsigned long REGPARAM2 op_20f9_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel449: (void)0;
return 14;
}
unsigned long REGPARAM2 op_20fa_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel450: (void)0;
return 12;
}
unsigned long REGPARAM2 op_20fb_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel451: (void)0;
return 10;
}
unsigned long REGPARAM2 op_20fc_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 src = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(6);
endlabel452: (void)0;
return 10;
}
unsigned long REGPARAM2 op_2100_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(2);
endlabel453: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_2108_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(2);
endlabel454: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_2110_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel455: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_2118_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel456: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_2120_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel457: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_2128_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel458: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 12;
}
unsigned long REGPARAM2 op_2130_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel459: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_2138_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel460: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 12;
}
unsigned long REGPARAM2 op_2139_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel461: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 14;
}
unsigned long REGPARAM2 op_213a_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}}m68k_incpc(4);
endlabel462: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 12;
}
unsigned long REGPARAM2 op_213b_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel463: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
#endif

#ifdef PART_3
unsigned long REGPARAM2 op_213c_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 src = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(6);
endlabel464: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_2140_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(4);
endlabel465: (void)0;
return 8;
}
unsigned long REGPARAM2 op_2148_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(4);
endlabel466: (void)0;
return 8;
}
unsigned long REGPARAM2 op_2150_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel467: (void)0;
return 12;
}
unsigned long REGPARAM2 op_2158_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel468: (void)0;
return 12;
}
unsigned long REGPARAM2 op_2160_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel469: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 12;
}
unsigned long REGPARAM2 op_2168_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel470: (void)0;
return 14;
}
unsigned long REGPARAM2 op_2170_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel471: (void)0;
return 12;
}
unsigned long REGPARAM2 op_2178_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel472: (void)0;
return 14;
}
unsigned long REGPARAM2 op_2179_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(6);
{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(8);
endlabel473: (void)0;
return 16;
}
unsigned long REGPARAM2 op_217a_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel474: (void)0;
return 14;
}
unsigned long REGPARAM2 op_217b_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel475: (void)0;
return 12;
}
unsigned long REGPARAM2 op_217c_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(6);
{	uae_s32 src = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(8);
endlabel476: (void)0;
return 12;
}
unsigned long REGPARAM2 op_2180_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}endlabel477: (void)0;
return 6;
}
unsigned long REGPARAM2 op_2188_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}endlabel478: (void)0;
return 6;
}
unsigned long REGPARAM2 op_2190_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel479: (void)0;
return 10;
}
unsigned long REGPARAM2 op_2198_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel480: (void)0;
return 10;
}
unsigned long REGPARAM2 op_21a0_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel481: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_21a8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel482: (void)0;
return 12;
}
unsigned long REGPARAM2 op_21b0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel483: (void)0;
return 10;
}
unsigned long REGPARAM2 op_21b8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel484: (void)0;
return 12;
}
unsigned long REGPARAM2 op_21b9_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
m68k_incpc(6);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel485: (void)0;
return 14;
}
unsigned long REGPARAM2 op_21ba_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel486: (void)0;
return 12;
}
unsigned long REGPARAM2 op_21bb_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel487: (void)0;
return 10;
}
unsigned long REGPARAM2 op_21bc_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = get_ilong(2);
m68k_incpc(6);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}endlabel488: (void)0;
return 10;
}
unsigned long REGPARAM2 op_21c0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(4);
endlabel489: (void)0;
return 8;
}
unsigned long REGPARAM2 op_21c8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(4);
endlabel490: (void)0;
return 8;
}
unsigned long REGPARAM2 op_21d0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel491: (void)0;
return 12;
}
unsigned long REGPARAM2 op_21d8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel492: (void)0;
return 12;
}
unsigned long REGPARAM2 op_21e0_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel493: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 12;
}
unsigned long REGPARAM2 op_21e8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel494: (void)0;
return 14;
}
unsigned long REGPARAM2 op_21f0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel495: (void)0;
return 12;
}
unsigned long REGPARAM2 op_21f8_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(6);
endlabel496: (void)0;
return 14;
}
unsigned long REGPARAM2 op_21f9_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(6);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(8);
endlabel497: (void)0;
return 16;
}
unsigned long REGPARAM2 op_21fa_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(6);
endlabel498: (void)0;
return 14;
}
unsigned long REGPARAM2 op_21fb_0(uae_u32 opcode) /* MOVE */
{
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel499: (void)0;
return 12;
}
unsigned long REGPARAM2 op_21fc_0(uae_u32 opcode) /* MOVE */
{
{{	uae_s32 src = get_ilong(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(6);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}m68k_incpc(8);
endlabel500: (void)0;
return 12;
}
unsigned long REGPARAM2 op_23c0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(6);
endlabel501: (void)0;
return 10;
}
unsigned long REGPARAM2 op_23c8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(6);
endlabel502: (void)0;
return 10;
}
unsigned long REGPARAM2 op_23d0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel503: (void)0;
return 14;
}
unsigned long REGPARAM2 op_23d8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel504: (void)0;
return 14;
}
unsigned long REGPARAM2 op_23e0_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel505: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 14;
}
unsigned long REGPARAM2 op_23e8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(8);
endlabel506: (void)0;
return 16;
}
unsigned long REGPARAM2 op_23f0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = get_ilong(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel507: (void)0;
return 14;
}
unsigned long REGPARAM2 op_23f8_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(8);
endlabel508: (void)0;
return 16;
}
unsigned long REGPARAM2 op_23f9_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
	uaecptr dsta = get_ilong(6);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(10);
endlabel509: (void)0;
return 18;
}
unsigned long REGPARAM2 op_23fa_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(8);
endlabel510: (void)0;
return 16;
}
unsigned long REGPARAM2 op_23fb_0(uae_u32 opcode) /* MOVE */
{
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = get_ilong(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel511: (void)0;
return 14;
}
unsigned long REGPARAM2 op_23fc_0(uae_u32 opcode) /* MOVE */
{
{{	uae_s32 src = get_ilong(2);
	uaecptr dsta = get_ilong(6);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}m68k_incpc(10);
endlabel512: (void)0;
return 14;
}
unsigned long REGPARAM2 op_3000_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}m68k_incpc(2);
endlabel513: (void)0;
return 2;
}
unsigned long REGPARAM2 op_3008_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}m68k_incpc(2);
endlabel514: (void)0;
return 2;
}
unsigned long REGPARAM2 op_3010_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(2);
endlabel515: (void)0;
return 4;
}
unsigned long REGPARAM2 op_3018_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(2);
endlabel516: (void)0;
return 4;
}
unsigned long REGPARAM2 op_3020_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(2);
endlabel517: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_3028_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(4);
endlabel518: (void)0;
return 6;
}
unsigned long REGPARAM2 op_3030_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}endlabel519: (void)0;
return 4;
}
unsigned long REGPARAM2 op_3038_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(4);
endlabel520: (void)0;
return 6;
}
unsigned long REGPARAM2 op_3039_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(6);
endlabel521: (void)0;
return 8;
}
unsigned long REGPARAM2 op_303a_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(4);
endlabel522: (void)0;
return 6;
}
unsigned long REGPARAM2 op_303b_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}endlabel523: (void)0;
return 4;
}
unsigned long REGPARAM2 op_303c_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uae_s16 src = get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}m68k_incpc(4);
endlabel524: (void)0;
return 4;
}
unsigned long REGPARAM2 op_3040_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_u32 val = (uae_s32)(uae_s16)src;
	m68k_areg(regs, dstreg) = (val);
}}}m68k_incpc(2);
endlabel525: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 2;
}
unsigned long REGPARAM2 op_3048_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
{	uae_u32 val = (uae_s32)(uae_s16)src;
	m68k_areg(regs, dstreg) = (val);
}}}m68k_incpc(2);
endlabel526: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 2;
}
unsigned long REGPARAM2 op_3050_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_u32 val = (uae_s32)(uae_s16)src;
	m68k_areg(regs, dstreg) = (val);
}}}}m68k_incpc(2);
endlabel527: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 4;
}
unsigned long REGPARAM2 op_3058_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_u32 val = (uae_s32)(uae_s16)src;
	m68k_areg(regs, dstreg) = (val);
}}}}m68k_incpc(2);
endlabel528: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 4;
}
unsigned long REGPARAM2 op_3060_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_u32 val = (uae_s32)(uae_s16)src;
	m68k_areg(regs, dstreg) = (val);
}}}}m68k_incpc(2);
endlabel529: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 4;
}
unsigned long REGPARAM2 op_3068_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 val = (uae_s32)(uae_s16)src;
	m68k_areg(regs, dstreg) = (val);
}}}}m68k_incpc(4);
endlabel530: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 6;
}
unsigned long REGPARAM2 op_3070_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_u32 val = (uae_s32)(uae_s16)src;
	m68k_areg(regs, dstreg) = (val);
}}}}endlabel531: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 4;
}
unsigned long REGPARAM2 op_3078_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	uae_u32 val = (uae_s32)(uae_s16)src;
	m68k_areg(regs, dstreg) = (val);
}}}}m68k_incpc(4);
endlabel532: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 6;
}
unsigned long REGPARAM2 op_3079_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	uae_u32 val = (uae_s32)(uae_s16)src;
	m68k_areg(regs, dstreg) = (val);
}}}}m68k_incpc(6);
endlabel533: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 8;
}
unsigned long REGPARAM2 op_307a_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	uae_u32 val = (uae_s32)(uae_s16)src;
	m68k_areg(regs, dstreg) = (val);
}}}}m68k_incpc(4);
endlabel534: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 6;
}
unsigned long REGPARAM2 op_307b_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uae_u32 val = (uae_s32)(uae_s16)src;
	m68k_areg(regs, dstreg) = (val);
}}}}endlabel535: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 4;
}
unsigned long REGPARAM2 op_307c_0(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uae_s16 src = get_iword(2);
	uae_u32 val = (uae_s32)(uae_s16)src;
	m68k_areg(regs, dstreg) = (val);
}}}m68k_incpc(4);
endlabel536: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 4;
}
unsigned long REGPARAM2 op_3080_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(2);
endlabel537: (void)0;
return 4;
}
unsigned long REGPARAM2 op_3088_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(2);
endlabel538: (void)0;
return 4;
}
unsigned long REGPARAM2 op_3090_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel539: (void)0;
return 6;
}
unsigned long REGPARAM2 op_3098_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel540: (void)0;
return 6;
}
unsigned long REGPARAM2 op_30a0_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel541: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_30a8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel542: (void)0;
return 8;
}
unsigned long REGPARAM2 op_30b0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel543: (void)0;
return 6;
}
unsigned long REGPARAM2 op_30b8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel544: (void)0;
return 8;
}
unsigned long REGPARAM2 op_30b9_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel545: (void)0;
return 10;
}
unsigned long REGPARAM2 op_30ba_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}}m68k_incpc(4);
endlabel546: (void)0;
return 8;
}
unsigned long REGPARAM2 op_30bb_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel547: (void)0;
return 6;
}
unsigned long REGPARAM2 op_30bc_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 src = get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(4);
endlabel548: (void)0;
return 6;
}
unsigned long REGPARAM2 op_30c0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(2);
endlabel549: (void)0;
return 4;
}
unsigned long REGPARAM2 op_30c8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(2);
endlabel550: (void)0;
return 4;
}
unsigned long REGPARAM2 op_30d0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel551: (void)0;
return 6;
}
unsigned long REGPARAM2 op_30d8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel552: (void)0;
return 6;
}
unsigned long REGPARAM2 op_30e0_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel553: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_30e8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel554: (void)0;
return 8;
}
unsigned long REGPARAM2 op_30f0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel555: (void)0;
return 6;
}
unsigned long REGPARAM2 op_30f8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel556: (void)0;
return 8;
}
unsigned long REGPARAM2 op_30f9_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel557: (void)0;
return 10;
}
unsigned long REGPARAM2 op_30fa_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}}m68k_incpc(4);
endlabel558: (void)0;
return 8;
}
unsigned long REGPARAM2 op_30fb_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel559: (void)0;
return 6;
}
unsigned long REGPARAM2 op_30fc_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 src = get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(4);
endlabel560: (void)0;
return 6;
}
unsigned long REGPARAM2 op_3100_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(2);
endlabel561: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_3108_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(2);
endlabel562: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_3110_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel563: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_3118_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel564: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_3120_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel565: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_3128_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel566: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_3130_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel567: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_3138_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel568: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_3139_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel569: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_313a_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}}m68k_incpc(4);
endlabel570: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_313b_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel571: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_313c_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 src = get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(4);
endlabel572: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_3140_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(4);
endlabel573: (void)0;
return 6;
}
unsigned long REGPARAM2 op_3148_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(4);
endlabel574: (void)0;
return 6;
}
unsigned long REGPARAM2 op_3150_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel575: (void)0;
return 8;
}
unsigned long REGPARAM2 op_3158_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel576: (void)0;
return 8;
}
unsigned long REGPARAM2 op_3160_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel577: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_3168_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel578: (void)0;
return 10;
}
unsigned long REGPARAM2 op_3170_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel579: (void)0;
return 8;
}
unsigned long REGPARAM2 op_3178_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel580: (void)0;
return 10;
}
unsigned long REGPARAM2 op_3179_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(6);
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(8);
endlabel581: (void)0;
return 12;
}
unsigned long REGPARAM2 op_317a_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}}m68k_incpc(6);
endlabel582: (void)0;
return 10;
}
unsigned long REGPARAM2 op_317b_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel583: (void)0;
return 8;
}
unsigned long REGPARAM2 op_317c_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 src = get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(6);
endlabel584: (void)0;
return 8;
}
unsigned long REGPARAM2 op_3180_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}endlabel585: (void)0;
return 4;
}
unsigned long REGPARAM2 op_3188_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}endlabel586: (void)0;
return 4;
}
unsigned long REGPARAM2 op_3190_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel587: (void)0;
return 6;
}
unsigned long REGPARAM2 op_3198_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel588: (void)0;
return 6;
}
unsigned long REGPARAM2 op_31a0_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel589: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_31a8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel590: (void)0;
return 8;
}
unsigned long REGPARAM2 op_31b0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel591: (void)0;
return 6;
}
unsigned long REGPARAM2 op_31b8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel592: (void)0;
return 8;
}
unsigned long REGPARAM2 op_31b9_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
m68k_incpc(6);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel593: (void)0;
return 10;
}
unsigned long REGPARAM2 op_31ba_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}}endlabel594: (void)0;
return 8;
}
unsigned long REGPARAM2 op_31bb_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel595: (void)0;
return 6;
}
unsigned long REGPARAM2 op_31bc_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}endlabel596: (void)0;
return 6;
}
unsigned long REGPARAM2 op_31c0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(4);
endlabel597: (void)0;
return 6;
}
unsigned long REGPARAM2 op_31c8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(4);
endlabel598: (void)0;
return 6;
}
unsigned long REGPARAM2 op_31d0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel599: (void)0;
return 8;
}
unsigned long REGPARAM2 op_31d8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel600: (void)0;
return 8;
}
unsigned long REGPARAM2 op_31e0_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel601: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_31e8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel602: (void)0;
return 10;
}
unsigned long REGPARAM2 op_31f0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel603: (void)0;
return 8;
}
unsigned long REGPARAM2 op_31f8_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(6);
endlabel604: (void)0;
return 10;
}
unsigned long REGPARAM2 op_31f9_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(6);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(8);
endlabel605: (void)0;
return 12;
}
unsigned long REGPARAM2 op_31fa_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel606: (void)0;
return 10;
}
unsigned long REGPARAM2 op_31fb_0(uae_u32 opcode) /* MOVE */
{
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel607: (void)0;
return 8;
}
unsigned long REGPARAM2 op_31fc_0(uae_u32 opcode) /* MOVE */
{
{{	uae_s16 src = get_iword(2);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(6);
endlabel608: (void)0;
return 8;
}
unsigned long REGPARAM2 op_33c0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(6);
endlabel609: (void)0;
return 8;
}
unsigned long REGPARAM2 op_33c8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(6);
endlabel610: (void)0;
return 8;
}
unsigned long REGPARAM2 op_33d0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel611: (void)0;
return 10;
}
unsigned long REGPARAM2 op_33d8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel612: (void)0;
return 10;
}
unsigned long REGPARAM2 op_33e0_0(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel613: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_33e8_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(8);
endlabel614: (void)0;
return 12;
}
unsigned long REGPARAM2 op_33f0_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = get_ilong(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel615: (void)0;
return 10;
}
unsigned long REGPARAM2 op_33f8_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(8);
endlabel616: (void)0;
return 12;
}
unsigned long REGPARAM2 op_33f9_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	uaecptr dsta = get_ilong(6);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(10);
endlabel617: (void)0;
return 14;
}
unsigned long REGPARAM2 op_33fa_0(uae_u32 opcode) /* MOVE */
{
{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(8);
endlabel618: (void)0;
return 12;
}
unsigned long REGPARAM2 op_33fb_0(uae_u32 opcode) /* MOVE */
{
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = get_ilong(0);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel619: (void)0;
return 10;
}
unsigned long REGPARAM2 op_33fc_0(uae_u32 opcode) /* MOVE */
{
{{	uae_s16 src = get_iword(2);
{	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(8);
endlabel620: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4000_0(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((newv) & 0xff);
}}}}m68k_incpc(2);
endlabel621: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4010_0(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}}m68k_incpc(2);
endlabel622: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4018_0(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}}m68k_incpc(2);
endlabel623: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4020_0(uae_u32 opcode) /* NEGX */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}}m68k_incpc(2);
endlabel624: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_4028_0(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}}m68k_incpc(4);
endlabel625: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4030_0(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}}endlabel626: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4038_0(uae_u32 opcode) /* NEGX */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}}m68k_incpc(4);
endlabel627: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4039_0(uae_u32 opcode) /* NEGX */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}}m68k_incpc(6);
endlabel628: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4040_0(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s16)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s16)(newv)) < 0;
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | ((newv) & 0xffff);
}}}}m68k_incpc(2);
endlabel629: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4050_0(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s16)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s16)(newv)) < 0;
	put_word(srca,newv);
}}}}}m68k_incpc(2);
endlabel630: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4058_0(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s16)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s16)(newv)) < 0;
	put_word(srca,newv);
}}}}}m68k_incpc(2);
endlabel631: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4060_0(uae_u32 opcode) /* NEGX */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s16)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s16)(newv)) < 0;
	put_word(srca,newv);
}}}}}m68k_incpc(2);
endlabel632: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_4068_0(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s16)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s16)(newv)) < 0;
	put_word(srca,newv);
}}}}}m68k_incpc(4);
endlabel633: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4070_0(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s16)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s16)(newv)) < 0;
	put_word(srca,newv);
}}}}}endlabel634: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4078_0(uae_u32 opcode) /* NEGX */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s16)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s16)(newv)) < 0;
	put_word(srca,newv);
}}}}}m68k_incpc(4);
endlabel635: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4079_0(uae_u32 opcode) /* NEGX */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s16)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s16)(newv)) < 0;
	put_word(srca,newv);
}}}}}m68k_incpc(6);
endlabel636: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4080_0(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s32)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, srcreg) = (newv);
}}}}m68k_incpc(2);
endlabel637: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4090_0(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s32)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s32)(newv)) < 0;
	put_long(srca,newv);
}}}}}m68k_incpc(2);
endlabel638: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4098_0(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s32)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s32)(newv)) < 0;
	put_long(srca,newv);
}}}}}m68k_incpc(2);
endlabel639: (void)0;
return 10;
}
unsigned long REGPARAM2 op_40a0_0(uae_u32 opcode) /* NEGX */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s32)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s32)(newv)) < 0;
	put_long(srca,newv);
}}}}}m68k_incpc(2);
endlabel640: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_40a8_0(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s32)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s32)(newv)) < 0;
	put_long(srca,newv);
}}}}}m68k_incpc(4);
endlabel641: (void)0;
return 12;
}
unsigned long REGPARAM2 op_40b0_0(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s32)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s32)(newv)) < 0;
	put_long(srca,newv);
}}}}}endlabel642: (void)0;
return 10;
}
unsigned long REGPARAM2 op_40b8_0(uae_u32 opcode) /* NEGX */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s32)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s32)(newv)) < 0;
	put_long(srca,newv);
}}}}}m68k_incpc(4);
endlabel643: (void)0;
return 12;
}
unsigned long REGPARAM2 op_40b9_0(uae_u32 opcode) /* NEGX */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s32)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s32)(newv)) < 0;
	put_long(srca,newv);
}}}}}m68k_incpc(6);
endlabel644: (void)0;
return 14;
}
unsigned long REGPARAM2 op_40c0_0(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel645; }
{{	MakeSR();
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | ((regs.sr) & 0xffff);
}}}m68k_incpc(2);
endlabel645: (void)0;
return 2;
}
unsigned long REGPARAM2 op_40d0_0(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel646; }
{{	uaecptr srca = m68k_areg(regs, srcreg);
	MakeSR();
	put_word(srca,regs.sr);
}}}m68k_incpc(2);
endlabel646: (void)0;
return 4;
}
unsigned long REGPARAM2 op_40d8_0(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel647; }
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
	MakeSR();
	put_word(srca,regs.sr);
}}}m68k_incpc(2);
endlabel647: (void)0;
return 4;
}
unsigned long REGPARAM2 op_40e0_0(uae_u32 opcode) /* MVSR2 */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel648; }
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
	MakeSR();
	put_word(srca,regs.sr);
}}}m68k_incpc(2);
endlabel648: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_40e8_0(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel649; }
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
	MakeSR();
	put_word(srca,regs.sr);
}}}m68k_incpc(4);
endlabel649: (void)0;
return 6;
}
unsigned long REGPARAM2 op_40f0_0(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel650; }
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
	MakeSR();
	put_word(srca,regs.sr);
}}}endlabel650: (void)0;
return 4;
}
unsigned long REGPARAM2 op_40f8_0(uae_u32 opcode) /* MVSR2 */
{
{if (!regs.s) { Exception(8,0); goto endlabel651; }
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
	MakeSR();
	put_word(srca,regs.sr);
}}}m68k_incpc(4);
endlabel651: (void)0;
return 6;
}
unsigned long REGPARAM2 op_40f9_0(uae_u32 opcode) /* MVSR2 */
{
{if (!regs.s) { Exception(8,0); goto endlabel652; }
{{	uaecptr srca = get_ilong(2);
	MakeSR();
	put_word(srca,regs.sr);
}}}m68k_incpc(6);
endlabel652: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4100_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel653; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel653; }
}}}m68k_incpc(2);
endlabel653: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4110_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel654; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel654; }
}}}}m68k_incpc(2);
endlabel654: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4118_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel655; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel655; }
}}}}m68k_incpc(2);
endlabel655: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4120_0(uae_u32 opcode) /* CHK */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel656; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel656; }
}}}}m68k_incpc(2);
endlabel656: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_4128_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel657; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel657; }
}}}}m68k_incpc(4);
endlabel657: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4130_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel658; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel658; }
}}}}endlabel658: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4138_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel659; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel659; }
}}}}m68k_incpc(4);
endlabel659: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4139_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel660; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel660; }
}}}}m68k_incpc(6);
endlabel660: (void)0;
return 10;
}
unsigned long REGPARAM2 op_413a_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel661; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel661; }
}}}}m68k_incpc(4);
endlabel661: (void)0;
return 8;
}
unsigned long REGPARAM2 op_413b_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel662; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel662; }
}}}}endlabel662: (void)0;
return 6;
}
unsigned long REGPARAM2 op_413c_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel663; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel663; }
}}}m68k_incpc(6);
endlabel663: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4180_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel664; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel664; }
}}}m68k_incpc(2);
endlabel664: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4190_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel665; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel665; }
}}}}m68k_incpc(2);
endlabel665: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4198_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel666; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel666; }
}}}}m68k_incpc(2);
endlabel666: (void)0;
return 4;
}
unsigned long REGPARAM2 op_41a0_0(uae_u32 opcode) /* CHK */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel667; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel667; }
}}}}m68k_incpc(2);
endlabel667: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_41a8_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel668; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel668; }
}}}}m68k_incpc(4);
endlabel668: (void)0;
return 6;
}
unsigned long REGPARAM2 op_41b0_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel669; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel669; }
}}}}endlabel669: (void)0;
return 4;
}
unsigned long REGPARAM2 op_41b8_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel670; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel670; }
}}}}m68k_incpc(4);
endlabel670: (void)0;
return 6;
}
unsigned long REGPARAM2 op_41b9_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel671; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel671; }
}}}}m68k_incpc(6);
endlabel671: (void)0;
return 8;
}
unsigned long REGPARAM2 op_41ba_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel672; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel672; }
}}}}}m68k_incpc(4);
endlabel672: (void)0;
return 6;
}
unsigned long REGPARAM2 op_41bb_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel673; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel673; }
}}}}endlabel673: (void)0;
return 4;
}
unsigned long REGPARAM2 op_41bc_0(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel674; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel674; }
}}}m68k_incpc(4);
endlabel674: (void)0;
return 4;
}
unsigned long REGPARAM2 op_41d0_0(uae_u32 opcode) /* LEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	m68k_areg(regs, dstreg) = (srca);
}}}m68k_incpc(2);
endlabel675: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (srcreg == 7 ? kLEA7Opcode : kLEAOpcode, oldA7);
return 2;
}
unsigned long REGPARAM2 op_41e8_0(uae_u32 opcode) /* LEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	m68k_areg(regs, dstreg) = (srca);
}}}m68k_incpc(4);
endlabel676: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (srcreg == 7 ? kLEA7Opcode : kLEAOpcode, oldA7);
return 4;
}
unsigned long REGPARAM2 op_41f0_0(uae_u32 opcode) /* LEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	m68k_areg(regs, dstreg) = (srca);
}}}endlabel677: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (srcreg == 7 ? kLEA7Opcode : kLEAOpcode, oldA7);
return 2;
}
unsigned long REGPARAM2 op_41f8_0(uae_u32 opcode) /* LEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
	m68k_areg(regs, dstreg) = (srca);
}}}m68k_incpc(4);
endlabel678: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kLEAOpcode, oldA7);
return 4;
}
unsigned long REGPARAM2 op_41f9_0(uae_u32 opcode) /* LEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = get_ilong(2);
	m68k_areg(regs, dstreg) = (srca);
}}}m68k_incpc(6);
endlabel679: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kLEAOpcode, oldA7);
return 6;
}
unsigned long REGPARAM2 op_41fa_0(uae_u32 opcode) /* LEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
	m68k_areg(regs, dstreg) = (srca);
}}}m68k_incpc(4);
endlabel680: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kLEAOpcode, oldA7);
return 4;
}
unsigned long REGPARAM2 op_41fb_0(uae_u32 opcode) /* LEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	m68k_areg(regs, dstreg) = (srca);
}}}endlabel681: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kLEAOpcode, oldA7);
return 2;
}
unsigned long REGPARAM2 op_4200_0(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(0)) == 0;
	NFLG = ((uae_s8)(0)) < 0;
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((0) & 0xff);
}}m68k_incpc(2);
endlabel682: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4210_0(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(0)) == 0;
	NFLG = ((uae_s8)(0)) < 0;
	put_byte(srca,0);
}}m68k_incpc(2);
endlabel683: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4218_0(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(0)) == 0;
	NFLG = ((uae_s8)(0)) < 0;
	put_byte(srca,0);
}}m68k_incpc(2);
endlabel684: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4220_0(uae_u32 opcode) /* CLR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(0)) == 0;
	NFLG = ((uae_s8)(0)) < 0;
	put_byte(srca,0);
}}m68k_incpc(2);
endlabel685: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_4228_0(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(0)) == 0;
	NFLG = ((uae_s8)(0)) < 0;
	put_byte(srca,0);
}}m68k_incpc(4);
endlabel686: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4230_0(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(0)) == 0;
	NFLG = ((uae_s8)(0)) < 0;
	put_byte(srca,0);
}}endlabel687: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4238_0(uae_u32 opcode) /* CLR */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(0)) == 0;
	NFLG = ((uae_s8)(0)) < 0;
	put_byte(srca,0);
}}m68k_incpc(4);
endlabel688: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4239_0(uae_u32 opcode) /* CLR */
{
{{	uaecptr srca = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(0)) == 0;
	NFLG = ((uae_s8)(0)) < 0;
	put_byte(srca,0);
}}m68k_incpc(6);
endlabel689: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4240_0(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(0)) == 0;
	NFLG = ((uae_s16)(0)) < 0;
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | ((0) & 0xffff);
}}m68k_incpc(2);
endlabel690: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4250_0(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(0)) == 0;
	NFLG = ((uae_s16)(0)) < 0;
	put_word(srca,0);
}}m68k_incpc(2);
endlabel691: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4258_0(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(0)) == 0;
	NFLG = ((uae_s16)(0)) < 0;
	put_word(srca,0);
}}m68k_incpc(2);
endlabel692: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4260_0(uae_u32 opcode) /* CLR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(0)) == 0;
	NFLG = ((uae_s16)(0)) < 0;
	put_word(srca,0);
}}m68k_incpc(2);
endlabel693: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_4268_0(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(0)) == 0;
	NFLG = ((uae_s16)(0)) < 0;
	put_word(srca,0);
}}m68k_incpc(4);
endlabel694: (void)0;
return 6;
}
#endif

#ifdef PART_4
unsigned long REGPARAM2 op_4270_0(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(0)) == 0;
	NFLG = ((uae_s16)(0)) < 0;
	put_word(srca,0);
}}endlabel695: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4278_0(uae_u32 opcode) /* CLR */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(0)) == 0;
	NFLG = ((uae_s16)(0)) < 0;
	put_word(srca,0);
}}m68k_incpc(4);
endlabel696: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4279_0(uae_u32 opcode) /* CLR */
{
{{	uaecptr srca = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(0)) == 0;
	NFLG = ((uae_s16)(0)) < 0;
	put_word(srca,0);
}}m68k_incpc(6);
endlabel697: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4280_0(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(0)) == 0;
	NFLG = ((uae_s32)(0)) < 0;
	m68k_dreg(regs, srcreg) = (0);
}}m68k_incpc(2);
endlabel698: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4290_0(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(0)) == 0;
	NFLG = ((uae_s32)(0)) < 0;
	put_long(srca,0);
}}m68k_incpc(2);
endlabel699: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4298_0(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(0)) == 0;
	NFLG = ((uae_s32)(0)) < 0;
	put_long(srca,0);
}}m68k_incpc(2);
endlabel700: (void)0;
return 6;
}
unsigned long REGPARAM2 op_42a0_0(uae_u32 opcode) /* CLR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(0)) == 0;
	NFLG = ((uae_s32)(0)) < 0;
	put_long(srca,0);
}}m68k_incpc(2);
endlabel701: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_42a8_0(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(0)) == 0;
	NFLG = ((uae_s32)(0)) < 0;
	put_long(srca,0);
}}m68k_incpc(4);
endlabel702: (void)0;
return 8;
}
unsigned long REGPARAM2 op_42b0_0(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(0)) == 0;
	NFLG = ((uae_s32)(0)) < 0;
	put_long(srca,0);
}}endlabel703: (void)0;
return 6;
}
unsigned long REGPARAM2 op_42b8_0(uae_u32 opcode) /* CLR */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(0)) == 0;
	NFLG = ((uae_s32)(0)) < 0;
	put_long(srca,0);
}}m68k_incpc(4);
endlabel704: (void)0;
return 8;
}
unsigned long REGPARAM2 op_42b9_0(uae_u32 opcode) /* CLR */
{
{{	uaecptr srca = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(0)) == 0;
	NFLG = ((uae_s32)(0)) < 0;
	put_long(srca,0);
}}m68k_incpc(6);
endlabel705: (void)0;
return 10;
}
unsigned long REGPARAM2 op_42c0_0(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	MakeSR();
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | ((regs.sr & 0xff) & 0xffff);
}}m68k_incpc(2);
endlabel706: (void)0;
return 2;
}
unsigned long REGPARAM2 op_42d0_0(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	MakeSR();
	put_word(srca,regs.sr & 0xff);
}}m68k_incpc(2);
endlabel707: (void)0;
return 4;
}
unsigned long REGPARAM2 op_42d8_0(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
	MakeSR();
	put_word(srca,regs.sr & 0xff);
}}m68k_incpc(2);
endlabel708: (void)0;
return 4;
}
unsigned long REGPARAM2 op_42e0_0(uae_u32 opcode) /* MVSR2 */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
	MakeSR();
	put_word(srca,regs.sr & 0xff);
}}m68k_incpc(2);
endlabel709: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_42e8_0(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
	MakeSR();
	put_word(srca,regs.sr & 0xff);
}}m68k_incpc(4);
endlabel710: (void)0;
return 6;
}
unsigned long REGPARAM2 op_42f0_0(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
	MakeSR();
	put_word(srca,regs.sr & 0xff);
}}endlabel711: (void)0;
return 4;
}
unsigned long REGPARAM2 op_42f8_0(uae_u32 opcode) /* MVSR2 */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
	MakeSR();
	put_word(srca,regs.sr & 0xff);
}}m68k_incpc(4);
endlabel712: (void)0;
return 6;
}
unsigned long REGPARAM2 op_42f9_0(uae_u32 opcode) /* MVSR2 */
{
{{	uaecptr srca = get_ilong(2);
	MakeSR();
	put_word(srca,regs.sr & 0xff);
}}m68k_incpc(6);
endlabel713: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4400_0(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{{uae_u32 dst = ((uae_s8)(0)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(0));
	NFLG = flgn != 0;
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((dst) & 0xff);
}}}}}m68k_incpc(2);
endlabel714: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4410_0(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{{uae_u32 dst = ((uae_s8)(0)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(0));
	NFLG = flgn != 0;
	put_byte(srca,dst);
}}}}}}m68k_incpc(2);
endlabel715: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4418_0(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{{uae_u32 dst = ((uae_s8)(0)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(0));
	NFLG = flgn != 0;
	put_byte(srca,dst);
}}}}}}m68k_incpc(2);
endlabel716: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4420_0(uae_u32 opcode) /* NEG */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{{uae_u32 dst = ((uae_s8)(0)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(0));
	NFLG = flgn != 0;
	put_byte(srca,dst);
}}}}}}m68k_incpc(2);
endlabel717: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_4428_0(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{{uae_u32 dst = ((uae_s8)(0)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(0));
	NFLG = flgn != 0;
	put_byte(srca,dst);
}}}}}}m68k_incpc(4);
endlabel718: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4430_0(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{{uae_u32 dst = ((uae_s8)(0)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(0));
	NFLG = flgn != 0;
	put_byte(srca,dst);
}}}}}}endlabel719: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4438_0(uae_u32 opcode) /* NEG */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{{uae_u32 dst = ((uae_s8)(0)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(0));
	NFLG = flgn != 0;
	put_byte(srca,dst);
}}}}}}m68k_incpc(4);
endlabel720: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4439_0(uae_u32 opcode) /* NEG */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
{{uae_u32 dst = ((uae_s8)(0)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(0));
	NFLG = flgn != 0;
	put_byte(srca,dst);
}}}}}}m68k_incpc(6);
endlabel721: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4440_0(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{{uae_u32 dst = ((uae_s16)(0)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(0));
	NFLG = flgn != 0;
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | ((dst) & 0xffff);
}}}}}m68k_incpc(2);
endlabel722: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4450_0(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{{uae_u32 dst = ((uae_s16)(0)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(0));
	NFLG = flgn != 0;
	put_word(srca,dst);
}}}}}}m68k_incpc(2);
endlabel723: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4458_0(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{{uae_u32 dst = ((uae_s16)(0)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(0));
	NFLG = flgn != 0;
	put_word(srca,dst);
}}}}}}m68k_incpc(2);
endlabel724: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4460_0(uae_u32 opcode) /* NEG */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{{uae_u32 dst = ((uae_s16)(0)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(0));
	NFLG = flgn != 0;
	put_word(srca,dst);
}}}}}}m68k_incpc(2);
endlabel725: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_4468_0(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{{uae_u32 dst = ((uae_s16)(0)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(0));
	NFLG = flgn != 0;
	put_word(srca,dst);
}}}}}}m68k_incpc(4);
endlabel726: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4470_0(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{{uae_u32 dst = ((uae_s16)(0)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(0));
	NFLG = flgn != 0;
	put_word(srca,dst);
}}}}}}endlabel727: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4478_0(uae_u32 opcode) /* NEG */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{{uae_u32 dst = ((uae_s16)(0)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(0));
	NFLG = flgn != 0;
	put_word(srca,dst);
}}}}}}m68k_incpc(4);
endlabel728: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4479_0(uae_u32 opcode) /* NEG */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
{{uae_u32 dst = ((uae_s16)(0)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(0));
	NFLG = flgn != 0;
	put_word(srca,dst);
}}}}}}m68k_incpc(6);
endlabel729: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4480_0(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{{uae_u32 dst = ((uae_s32)(0)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(0));
	NFLG = flgn != 0;
	m68k_dreg(regs, srcreg) = (dst);
}}}}}m68k_incpc(2);
endlabel730: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4490_0(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{{uae_u32 dst = ((uae_s32)(0)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(0));
	NFLG = flgn != 0;
	put_long(srca,dst);
}}}}}}m68k_incpc(2);
endlabel731: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4498_0(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{{uae_u32 dst = ((uae_s32)(0)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(0));
	NFLG = flgn != 0;
	put_long(srca,dst);
}}}}}}m68k_incpc(2);
endlabel732: (void)0;
return 10;
}
unsigned long REGPARAM2 op_44a0_0(uae_u32 opcode) /* NEG */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{{uae_u32 dst = ((uae_s32)(0)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(0));
	NFLG = flgn != 0;
	put_long(srca,dst);
}}}}}}m68k_incpc(2);
endlabel733: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_44a8_0(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{{uae_u32 dst = ((uae_s32)(0)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(0));
	NFLG = flgn != 0;
	put_long(srca,dst);
}}}}}}m68k_incpc(4);
endlabel734: (void)0;
return 12;
}
unsigned long REGPARAM2 op_44b0_0(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{{uae_u32 dst = ((uae_s32)(0)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(0));
	NFLG = flgn != 0;
	put_long(srca,dst);
}}}}}}endlabel735: (void)0;
return 10;
}
unsigned long REGPARAM2 op_44b8_0(uae_u32 opcode) /* NEG */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{{uae_u32 dst = ((uae_s32)(0)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(0));
	NFLG = flgn != 0;
	put_long(srca,dst);
}}}}}}m68k_incpc(4);
endlabel736: (void)0;
return 12;
}
unsigned long REGPARAM2 op_44b9_0(uae_u32 opcode) /* NEG */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
{{uae_u32 dst = ((uae_s32)(0)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(0));
	NFLG = flgn != 0;
	put_long(srca,dst);
}}}}}}m68k_incpc(6);
endlabel737: (void)0;
return 14;
}
unsigned long REGPARAM2 op_44c0_0(uae_u32 opcode) /* MV2SR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
	MakeSR();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR();
}}m68k_incpc(2);
endlabel738: (void)0;
return 2;
}
unsigned long REGPARAM2 op_44d0_0(uae_u32 opcode) /* MV2SR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
	MakeSR();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR();
}}}m68k_incpc(2);
endlabel739: (void)0;
return 4;
}
unsigned long REGPARAM2 op_44d8_0(uae_u32 opcode) /* MV2SR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
	MakeSR();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR();
}}}m68k_incpc(2);
endlabel740: (void)0;
return 4;
}
unsigned long REGPARAM2 op_44e0_0(uae_u32 opcode) /* MV2SR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
	MakeSR();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR();
}}}m68k_incpc(2);
endlabel741: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_44e8_0(uae_u32 opcode) /* MV2SR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	MakeSR();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR();
}}}m68k_incpc(4);
endlabel742: (void)0;
return 6;
}
unsigned long REGPARAM2 op_44f0_0(uae_u32 opcode) /* MV2SR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
	MakeSR();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR();
}}}endlabel743: (void)0;
return 4;
}
unsigned long REGPARAM2 op_44f8_0(uae_u32 opcode) /* MV2SR */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	MakeSR();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR();
}}}m68k_incpc(4);
endlabel744: (void)0;
return 6;
}
unsigned long REGPARAM2 op_44f9_0(uae_u32 opcode) /* MV2SR */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	MakeSR();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR();
}}}m68k_incpc(6);
endlabel745: (void)0;
return 8;
}
unsigned long REGPARAM2 op_44fa_0(uae_u32 opcode) /* MV2SR */
{
{{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	MakeSR();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR();
}}}}m68k_incpc(4);
endlabel746: (void)0;
return 6;
}
unsigned long REGPARAM2 op_44fb_0(uae_u32 opcode) /* MV2SR */
{
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
	MakeSR();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR();
}}}endlabel747: (void)0;
return 4;
}
unsigned long REGPARAM2 op_44fc_0(uae_u32 opcode) /* MV2SR */
{
{{	uae_s16 src = get_iword(2);
	MakeSR();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR();
}}m68k_incpc(4);
endlabel748: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4600_0(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	NFLG = ((uae_s8)(dst)) < 0;
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((dst) & 0xff);
}}}m68k_incpc(2);
endlabel749: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4610_0(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	NFLG = ((uae_s8)(dst)) < 0;
	put_byte(srca,dst);
}}}}m68k_incpc(2);
endlabel750: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4618_0(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	NFLG = ((uae_s8)(dst)) < 0;
	put_byte(srca,dst);
}}}}m68k_incpc(2);
endlabel751: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4620_0(uae_u32 opcode) /* NOT */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	NFLG = ((uae_s8)(dst)) < 0;
	put_byte(srca,dst);
}}}}m68k_incpc(2);
endlabel752: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_4628_0(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	NFLG = ((uae_s8)(dst)) < 0;
	put_byte(srca,dst);
}}}}m68k_incpc(4);
endlabel753: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4630_0(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	NFLG = ((uae_s8)(dst)) < 0;
	put_byte(srca,dst);
}}}}endlabel754: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4638_0(uae_u32 opcode) /* NOT */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	NFLG = ((uae_s8)(dst)) < 0;
	put_byte(srca,dst);
}}}}m68k_incpc(4);
endlabel755: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4639_0(uae_u32 opcode) /* NOT */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	NFLG = ((uae_s8)(dst)) < 0;
	put_byte(srca,dst);
}}}}m68k_incpc(6);
endlabel756: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4640_0(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	NFLG = ((uae_s16)(dst)) < 0;
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | ((dst) & 0xffff);
}}}m68k_incpc(2);
endlabel757: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4650_0(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	NFLG = ((uae_s16)(dst)) < 0;
	put_word(srca,dst);
}}}}m68k_incpc(2);
endlabel758: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4658_0(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	NFLG = ((uae_s16)(dst)) < 0;
	put_word(srca,dst);
}}}}m68k_incpc(2);
endlabel759: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4660_0(uae_u32 opcode) /* NOT */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	NFLG = ((uae_s16)(dst)) < 0;
	put_word(srca,dst);
}}}}m68k_incpc(2);
endlabel760: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_4668_0(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	NFLG = ((uae_s16)(dst)) < 0;
	put_word(srca,dst);
}}}}m68k_incpc(4);
endlabel761: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4670_0(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	NFLG = ((uae_s16)(dst)) < 0;
	put_word(srca,dst);
}}}}endlabel762: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4678_0(uae_u32 opcode) /* NOT */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	NFLG = ((uae_s16)(dst)) < 0;
	put_word(srca,dst);
}}}}m68k_incpc(4);
endlabel763: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4679_0(uae_u32 opcode) /* NOT */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	NFLG = ((uae_s16)(dst)) < 0;
	put_word(srca,dst);
}}}}m68k_incpc(6);
endlabel764: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4680_0(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	NFLG = ((uae_s32)(dst)) < 0;
	m68k_dreg(regs, srcreg) = (dst);
}}}m68k_incpc(2);
endlabel765: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4690_0(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	NFLG = ((uae_s32)(dst)) < 0;
	put_long(srca,dst);
}}}}m68k_incpc(2);
endlabel766: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4698_0(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	NFLG = ((uae_s32)(dst)) < 0;
	put_long(srca,dst);
}}}}m68k_incpc(2);
endlabel767: (void)0;
return 10;
}
unsigned long REGPARAM2 op_46a0_0(uae_u32 opcode) /* NOT */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	NFLG = ((uae_s32)(dst)) < 0;
	put_long(srca,dst);
}}}}m68k_incpc(2);
endlabel768: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_46a8_0(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	NFLG = ((uae_s32)(dst)) < 0;
	put_long(srca,dst);
}}}}m68k_incpc(4);
endlabel769: (void)0;
return 12;
}
unsigned long REGPARAM2 op_46b0_0(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	NFLG = ((uae_s32)(dst)) < 0;
	put_long(srca,dst);
}}}}endlabel770: (void)0;
return 10;
}
unsigned long REGPARAM2 op_46b8_0(uae_u32 opcode) /* NOT */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	NFLG = ((uae_s32)(dst)) < 0;
	put_long(srca,dst);
}}}}m68k_incpc(4);
endlabel771: (void)0;
return 12;
}
unsigned long REGPARAM2 op_46b9_0(uae_u32 opcode) /* NOT */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	NFLG = ((uae_s32)(dst)) < 0;
	put_long(srca,dst);
}}}}m68k_incpc(6);
endlabel772: (void)0;
return 14;
}
unsigned long REGPARAM2 op_46c0_0(uae_u32 opcode) /* MV2SR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel773; }
{{	uae_s16 src = m68k_dreg(regs, srcreg);
	regs.sr = src;
	MakeFromSR();
}}}m68k_incpc(2);
endlabel773: (void)0;
return 2;
}
unsigned long REGPARAM2 op_46d0_0(uae_u32 opcode) /* MV2SR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel774; }
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
	regs.sr = src;
	MakeFromSR();
}}}}m68k_incpc(2);
endlabel774: (void)0;
return 4;
}
unsigned long REGPARAM2 op_46d8_0(uae_u32 opcode) /* MV2SR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel775; }
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
	regs.sr = src;
	MakeFromSR();
}}}}m68k_incpc(2);
endlabel775: (void)0;
return 4;
}
unsigned long REGPARAM2 op_46e0_0(uae_u32 opcode) /* MV2SR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel776; }
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
	regs.sr = src;
	MakeFromSR();
}}}}m68k_incpc(2);
endlabel776: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_46e8_0(uae_u32 opcode) /* MV2SR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel777; }
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	regs.sr = src;
	MakeFromSR();
}}}}m68k_incpc(4);
endlabel777: (void)0;
return 6;
}
unsigned long REGPARAM2 op_46f0_0(uae_u32 opcode) /* MV2SR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel778; }
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
	regs.sr = src;
	MakeFromSR();
}}}}endlabel778: (void)0;
return 4;
}
unsigned long REGPARAM2 op_46f8_0(uae_u32 opcode) /* MV2SR */
{
{if (!regs.s) { Exception(8,0); goto endlabel779; }
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	regs.sr = src;
	MakeFromSR();
}}}}m68k_incpc(4);
endlabel779: (void)0;
return 6;
}
unsigned long REGPARAM2 op_46f9_0(uae_u32 opcode) /* MV2SR */
{
{if (!regs.s) { Exception(8,0); goto endlabel780; }
{{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	regs.sr = src;
	MakeFromSR();
}}}}m68k_incpc(6);
endlabel780: (void)0;
return 8;
}
unsigned long REGPARAM2 op_46fa_0(uae_u32 opcode) /* MV2SR */
{
{if (!regs.s) { Exception(8,0); goto endlabel781; }
{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	regs.sr = src;
	MakeFromSR();
}}}}m68k_incpc(4);
endlabel781: (void)0;
return 6;
}
unsigned long REGPARAM2 op_46fb_0(uae_u32 opcode) /* MV2SR */
{
{if (!regs.s) { Exception(8,0); goto endlabel782; }
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
	regs.sr = src;
	MakeFromSR();
}}}}endlabel782: (void)0;
return 4;
}
unsigned long REGPARAM2 op_46fc_0(uae_u32 opcode) /* MV2SR */
{
{if (!regs.s) { Exception(8,0); goto endlabel783; }
{{	uae_s16 src = get_iword(2);
	regs.sr = src;
	MakeFromSR();
}}}m68k_incpc(4);
endlabel783: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4800_0(uae_u32 opcode) /* NBCD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uae_u16 newv_lo = - (src & 0xF) - (XFLG ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	if (newv_lo > 9) { newv_lo-=6; newv_hi-=0x10; }
	newv = newv_hi + (newv_lo & 0xF);	CFLG = XFLG = (newv_hi & 0x1F0) > 0x90;
	if (CFLG) newv -= 0x60;
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((newv) & 0xff);
}}}m68k_incpc(2);
endlabel784: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4808_0(uae_u32 opcode) /* LINK */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr olda = m68k_areg(regs, 7) - 4;
	m68k_areg (regs, 7) = olda;
{	uae_s32 src = m68k_areg(regs, srcreg);
	put_long(olda,src);
	m68k_areg(regs, srcreg) = (m68k_areg(regs, 7));
{	uae_s32 offs = get_ilong(2);
	m68k_areg(regs, 7) += offs;
	Software_ProcessLINK (offs);
}}}}m68k_incpc(6);
endlabel785: (void)0;
	Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_4810_0(uae_u32 opcode) /* NBCD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	uae_u16 newv_lo = - (src & 0xF) - (XFLG ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	if (newv_lo > 9) { newv_lo-=6; newv_hi-=0x10; }
	newv = newv_hi + (newv_lo & 0xF);	CFLG = XFLG = (newv_hi & 0x1F0) > 0x90;
	if (CFLG) newv -= 0x60;
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}m68k_incpc(2);
endlabel786: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4818_0(uae_u32 opcode) /* NBCD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uae_u16 newv_lo = - (src & 0xF) - (XFLG ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	if (newv_lo > 9) { newv_lo-=6; newv_hi-=0x10; }
	newv = newv_hi + (newv_lo & 0xF);	CFLG = XFLG = (newv_hi & 0x1F0) > 0x90;
	if (CFLG) newv -= 0x60;
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}m68k_incpc(2);
endlabel787: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4820_0(uae_u32 opcode) /* NBCD */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uae_u16 newv_lo = - (src & 0xF) - (XFLG ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	if (newv_lo > 9) { newv_lo-=6; newv_hi-=0x10; }
	newv = newv_hi + (newv_lo & 0xF);	CFLG = XFLG = (newv_hi & 0x1F0) > 0x90;
	if (CFLG) newv -= 0x60;
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}m68k_incpc(2);
endlabel788: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_4828_0(uae_u32 opcode) /* NBCD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uae_u16 newv_lo = - (src & 0xF) - (XFLG ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	if (newv_lo > 9) { newv_lo-=6; newv_hi-=0x10; }
	newv = newv_hi + (newv_lo & 0xF);	CFLG = XFLG = (newv_hi & 0x1F0) > 0x90;
	if (CFLG) newv -= 0x60;
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}m68k_incpc(4);
endlabel789: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4830_0(uae_u32 opcode) /* NBCD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	uae_u16 newv_lo = - (src & 0xF) - (XFLG ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	if (newv_lo > 9) { newv_lo-=6; newv_hi-=0x10; }
	newv = newv_hi + (newv_lo & 0xF);	CFLG = XFLG = (newv_hi & 0x1F0) > 0x90;
	if (CFLG) newv -= 0x60;
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}endlabel790: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4838_0(uae_u32 opcode) /* NBCD */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uae_u16 newv_lo = - (src & 0xF) - (XFLG ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	if (newv_lo > 9) { newv_lo-=6; newv_hi-=0x10; }
	newv = newv_hi + (newv_lo & 0xF);	CFLG = XFLG = (newv_hi & 0x1F0) > 0x90;
	if (CFLG) newv -= 0x60;
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}m68k_incpc(4);
endlabel791: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4839_0(uae_u32 opcode) /* NBCD */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
{	uae_u16 newv_lo = - (src & 0xF) - (XFLG ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	if (newv_lo > 9) { newv_lo-=6; newv_hi-=0x10; }
	newv = newv_hi + (newv_lo & 0xF);	CFLG = XFLG = (newv_hi & 0x1F0) > 0x90;
	if (CFLG) newv -= 0x60;
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}m68k_incpc(6);
endlabel792: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4840_0(uae_u32 opcode) /* SWAP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_u32 dst = ((src >> 16)&0xFFFF) | ((src&0xFFFF)<<16);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	NFLG = ((uae_s32)(dst)) < 0;
	m68k_dreg(regs, srcreg) = (dst);
}}}m68k_incpc(2);
endlabel793: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4848_0(uae_u32 opcode) /* BKPT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
	op_illg(opcode);
}endlabel794: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4850_0(uae_u32 opcode) /* PEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, 7) - 4;
	m68k_areg (regs, 7) = dsta;
	put_long(dsta,srca);
}}}m68k_incpc(2);
endlabel795: (void)0;
	Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_4868_0(uae_u32 opcode) /* PEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uaecptr dsta = m68k_areg(regs, 7) - 4;
	m68k_areg (regs, 7) = dsta;
	put_long(dsta,srca);
}}}m68k_incpc(4);
endlabel796: (void)0;
	Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_4870_0(uae_u32 opcode) /* PEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uaecptr dsta = m68k_areg(regs, 7) - 4;
	m68k_areg (regs, 7) = dsta;
	put_long(dsta,srca);
}}}endlabel797: (void)0;
	Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_4878_0(uae_u32 opcode) /* PEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
{{	uaecptr dsta = m68k_areg(regs, 7) - 4;
	m68k_areg (regs, 7) = dsta;
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
	put_long(dsta,srca);
}}}m68k_incpc(4);
endlabel798: (void)0;
	Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_4879_0(uae_u32 opcode) /* PEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
{{	uaecptr dsta = m68k_areg(regs, 7) - 4;
	m68k_areg (regs, 7) = dsta;
{	uaecptr srca = get_ilong(2);
	put_long(dsta,srca);
}}}m68k_incpc(6);
endlabel799: (void)0;
	Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_487a_0(uae_u32 opcode) /* PEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
{{	uaecptr dsta = m68k_areg(regs, 7) - 4;
	m68k_areg (regs, 7) = dsta;
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
	put_long(dsta,srca);
}}}m68k_incpc(4);
endlabel800: (void)0;
	Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_487b_0(uae_u32 opcode) /* PEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uaecptr dsta = m68k_areg(regs, 7) - 4;
	m68k_areg (regs, 7) = dsta;
	put_long(dsta,srca);
}}}endlabel801: (void)0;
	Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_4880_0(uae_u32 opcode) /* EXT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_u16 dst = (uae_s16)(uae_s8)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	NFLG = ((uae_s16)(dst)) < 0;
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | ((dst) & 0xffff);
}}}m68k_incpc(2);
endlabel802: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4890_0(uae_u32 opcode) /* MVMLE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
{	uaecptr srca = m68k_areg(regs, dstreg);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	while (dmask) { put_word(srca, m68k_dreg(regs, movem_index1[dmask])); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { put_word(srca, m68k_areg(regs, movem_index1[amask])); srca += 2; amask = movem_next[amask]; }
}}}m68k_incpc(4);
endlabel803: (void)0;
return 4;
}
unsigned long REGPARAM2 op_48a0_0(uae_u32 opcode) /* MVMLE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
{	uaecptr srca = m68k_areg(regs, dstreg) - 0;
{	uae_u16 amask = mask & 0xff, dmask = (mask >> 8) & 0xff;
	while (amask) { srca -= 2; m68k_areg(regs, dstreg) = srca; put_word(srca, m68k_areg(regs, movem_index2[amask])); amask = movem_next[amask]; }
	while (dmask) { srca -= 2; m68k_areg(regs, dstreg) = srca; put_word(srca, m68k_dreg(regs, movem_index2[dmask])); dmask = movem_next[dmask]; }
	m68k_areg(regs, dstreg) = srca;
}}}m68k_incpc(4);
endlabel804: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_48a8_0(uae_u32 opcode) /* MVMLE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
{	uaecptr srca = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	while (dmask) { put_word(srca, m68k_dreg(regs, movem_index1[dmask])); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { put_word(srca, m68k_areg(regs, movem_index1[amask])); srca += 2; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel805: (void)0;
return 6;
}
unsigned long REGPARAM2 op_48b0_0(uae_u32 opcode) /* MVMLE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
m68k_incpc(4);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	while (dmask) { put_word(srca, m68k_dreg(regs, movem_index1[dmask])); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { put_word(srca, m68k_areg(regs, movem_index1[amask])); srca += 2; amask = movem_next[amask]; }
}}}endlabel806: (void)0;
return 4;
}
unsigned long REGPARAM2 op_48b8_0(uae_u32 opcode) /* MVMLE */
{
{	uae_u16 mask = get_iword(2);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(4);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	while (dmask) { put_word(srca, m68k_dreg(regs, movem_index1[dmask])); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { put_word(srca, m68k_areg(regs, movem_index1[amask])); srca += 2; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel807: (void)0;
return 6;
}
unsigned long REGPARAM2 op_48b9_0(uae_u32 opcode) /* MVMLE */
{
{	uae_u16 mask = get_iword(2);
{	uaecptr srca = get_ilong(4);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	while (dmask) { put_word(srca, m68k_dreg(regs, movem_index1[dmask])); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { put_word(srca, m68k_areg(regs, movem_index1[amask])); srca += 2; amask = movem_next[amask]; }
}}}m68k_incpc(8);
endlabel808: (void)0;
return 8;
}
unsigned long REGPARAM2 op_48c0_0(uae_u32 opcode) /* EXT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_u32 dst = (uae_s32)(uae_s16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	NFLG = ((uae_s32)(dst)) < 0;
	m68k_dreg(regs, srcreg) = (dst);
}}}m68k_incpc(2);
endlabel809: (void)0;
return 2;
}
unsigned long REGPARAM2 op_48d0_0(uae_u32 opcode) /* MVMLE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
{	uaecptr srca = m68k_areg(regs, dstreg);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	while (dmask) { put_long(srca, m68k_dreg(regs, movem_index1[dmask])); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { put_long(srca, m68k_areg(regs, movem_index1[amask])); srca += 4; amask = movem_next[amask]; }
}}}m68k_incpc(4);
endlabel810: (void)0;
return 4;
}
unsigned long REGPARAM2 op_48e0_0(uae_u32 opcode) /* MVMLE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
{	uaecptr srca = m68k_areg(regs, dstreg) - 0;
{	uae_u16 amask = mask & 0xff, dmask = (mask >> 8) & 0xff;
	while (amask) { srca -= 4; m68k_areg(regs, dstreg) = srca; put_long(srca, m68k_areg(regs, movem_index2[amask])); amask = movem_next[amask]; }
	while (dmask) { srca -= 4; m68k_areg(regs, dstreg) = srca; put_long(srca, m68k_dreg(regs, movem_index2[dmask])); dmask = movem_next[dmask]; }
	m68k_areg(regs, dstreg) = srca;
}}}m68k_incpc(4);
endlabel811: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_48e8_0(uae_u32 opcode) /* MVMLE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
{	uaecptr srca = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	while (dmask) { put_long(srca, m68k_dreg(regs, movem_index1[dmask])); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { put_long(srca, m68k_areg(regs, movem_index1[amask])); srca += 4; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel812: (void)0;
return 6;
}
unsigned long REGPARAM2 op_48f0_0(uae_u32 opcode) /* MVMLE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
m68k_incpc(4);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	while (dmask) { put_long(srca, m68k_dreg(regs, movem_index1[dmask])); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { put_long(srca, m68k_areg(regs, movem_index1[amask])); srca += 4; amask = movem_next[amask]; }
}}}endlabel813: (void)0;
return 4;
}
unsigned long REGPARAM2 op_48f8_0(uae_u32 opcode) /* MVMLE */
{
{	uae_u16 mask = get_iword(2);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(4);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	while (dmask) { put_long(srca, m68k_dreg(regs, movem_index1[dmask])); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { put_long(srca, m68k_areg(regs, movem_index1[amask])); srca += 4; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel814: (void)0;
return 6;
}
unsigned long REGPARAM2 op_48f9_0(uae_u32 opcode) /* MVMLE */
{
{	uae_u16 mask = get_iword(2);
{	uaecptr srca = get_ilong(4);
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	while (dmask) { put_long(srca, m68k_dreg(regs, movem_index1[dmask])); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { put_long(srca, m68k_areg(regs, movem_index1[amask])); srca += 4; amask = movem_next[amask]; }
}}}m68k_incpc(8);
endlabel815: (void)0;
return 8;
}
unsigned long REGPARAM2 op_49c0_0(uae_u32 opcode) /* EXT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_u32 dst = (uae_s32)(uae_s8)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	NFLG = ((uae_s32)(dst)) < 0;
	m68k_dreg(regs, srcreg) = (dst);
}}}m68k_incpc(2);
endlabel816: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4a00_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
}}m68k_incpc(2);
endlabel817: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4a10_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
}}}m68k_incpc(2);
endlabel818: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4a18_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
}}}m68k_incpc(2);
endlabel819: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4a20_0(uae_u32 opcode) /* TST */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
}}}m68k_incpc(2);
endlabel820: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_4a28_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
}}}m68k_incpc(4);
endlabel821: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4a30_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
}}}endlabel822: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4a38_0(uae_u32 opcode) /* TST */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
}}}m68k_incpc(4);
endlabel823: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4a39_0(uae_u32 opcode) /* TST */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
}}}m68k_incpc(6);
endlabel824: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4a3a_0(uae_u32 opcode) /* TST */
{
{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
}}}m68k_incpc(4);
endlabel825: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4a3b_0(uae_u32 opcode) /* TST */
{
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
}}}endlabel826: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4a3c_0(uae_u32 opcode) /* TST */
{
{{	uae_s8 src = get_ibyte(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
}}m68k_incpc(4);
endlabel827: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4a40_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
}}m68k_incpc(2);
endlabel828: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4a48_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
}}m68k_incpc(2);
endlabel829: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4a50_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
}}}m68k_incpc(2);
endlabel830: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4a58_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
}}}m68k_incpc(2);
endlabel831: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4a60_0(uae_u32 opcode) /* TST */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
}}}m68k_incpc(2);
endlabel832: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_4a68_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
}}}m68k_incpc(4);
endlabel833: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4a70_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
}}}endlabel834: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4a78_0(uae_u32 opcode) /* TST */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
}}}m68k_incpc(4);
endlabel835: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4a79_0(uae_u32 opcode) /* TST */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
}}}m68k_incpc(6);
endlabel836: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4a7a_0(uae_u32 opcode) /* TST */
{
{{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
}}}}m68k_incpc(4);
endlabel837: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4a7b_0(uae_u32 opcode) /* TST */
{
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
}}}endlabel838: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4a7c_0(uae_u32 opcode) /* TST */
{
{{	uae_s16 src = get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
}}m68k_incpc(4);
endlabel839: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4a80_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
}}m68k_incpc(2);
endlabel840: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4a88_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
}}m68k_incpc(2);
endlabel841: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4a90_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
}}}m68k_incpc(2);
endlabel842: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4a98_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
}}}m68k_incpc(2);
endlabel843: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4aa0_0(uae_u32 opcode) /* TST */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
}}}m68k_incpc(2);
endlabel844: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_4aa8_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
}}}m68k_incpc(4);
endlabel845: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4ab0_0(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
}}}endlabel846: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4ab8_0(uae_u32 opcode) /* TST */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
}}}m68k_incpc(4);
endlabel847: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4ab9_0(uae_u32 opcode) /* TST */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
}}}m68k_incpc(6);
endlabel848: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4aba_0(uae_u32 opcode) /* TST */
{
{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
}}}m68k_incpc(4);
endlabel849: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4abb_0(uae_u32 opcode) /* TST */
{
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
}}}endlabel850: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4abc_0(uae_u32 opcode) /* TST */
{
{{	uae_s32 src = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
}}m68k_incpc(6);
endlabel851: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4ac0_0(uae_u32 opcode) /* TAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	src |= 0x80;
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((src) & 0xff);
}}m68k_incpc(2);
endlabel852: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4ad0_0(uae_u32 opcode) /* TAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	src |= 0x80;
	put_byte(srca,src);
}}}m68k_incpc(2);
endlabel853: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4ad8_0(uae_u32 opcode) /* TAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	src |= 0x80;
	put_byte(srca,src);
}}}m68k_incpc(2);
endlabel854: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4ae0_0(uae_u32 opcode) /* TAS */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	src |= 0x80;
	put_byte(srca,src);
}}}m68k_incpc(2);
endlabel855: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_4ae8_0(uae_u32 opcode) /* TAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	src |= 0x80;
	put_byte(srca,src);
}}}m68k_incpc(4);
endlabel856: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4af0_0(uae_u32 opcode) /* TAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	src |= 0x80;
	put_byte(srca,src);
}}}endlabel857: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4af8_0(uae_u32 opcode) /* TAS */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	src |= 0x80;
	put_byte(srca,src);
}}}m68k_incpc(4);
endlabel858: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4af9_0(uae_u32 opcode) /* TAS */
{
{{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	src |= 0x80;
	put_byte(srca,src);
}}}m68k_incpc(6);
endlabel859: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4c00_0(uae_u32 opcode) /* MULL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	m68k_mull(opcode, dst, extra);
}}}endlabel860: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4c10_0(uae_u32 opcode) /* MULL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	m68k_mull(opcode, dst, extra);
}}}}endlabel861: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4c18_0(uae_u32 opcode) /* MULL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	m68k_mull(opcode, dst, extra);
}}}}endlabel862: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4c20_0(uae_u32 opcode) /* MULL */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	m68k_mull(opcode, dst, extra);
}}}}endlabel863: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_4c28_0(uae_u32 opcode) /* MULL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 dst = get_long(dsta);
{	uae_s16 extra = get_iword(2);
m68k_incpc(6);
	m68k_mull(opcode, dst, extra);
}}}}endlabel864: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4c30_0(uae_u32 opcode) /* MULL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
	m68k_mull(opcode, dst, extra);
}}}}endlabel865: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4c38_0(uae_u32 opcode) /* MULL */
{
{{	uae_s16 extra = get_iword(2);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 dst = get_long(dsta);
m68k_incpc(6);
	m68k_mull(opcode, dst, extra);
}}}}endlabel866: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4c39_0(uae_u32 opcode) /* MULL */
{
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s32 dst = get_long(dsta);
m68k_incpc(8);
	m68k_mull(opcode, dst, extra);
}}}endlabel867: (void)0;
return 12;
}
unsigned long REGPARAM2 op_4c3a_0(uae_u32 opcode) /* MULL */
{
	uae_u32 dstreg = 2;
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = m68k_getpc () + 4;
	dsta += (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 dst = get_long(dsta);
m68k_incpc(6);
	m68k_mull(opcode, dst, extra);
}}}endlabel868: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4c3b_0(uae_u32 opcode) /* MULL */
{
	uae_u32 dstreg = 3;
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 dst = get_long(dsta);
	m68k_mull(opcode, dst, extra);
}}}}endlabel869: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4c3c_0(uae_u32 opcode) /* MULL */
{
{{	uae_s16 extra = get_iword(2);
	uae_s32 dst = get_ilong(4);
m68k_incpc(8);
	m68k_mull(opcode, dst, extra);
}}endlabel870: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4c40_0(uae_u32 opcode) /* DIVL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{m68k_incpc(2);
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s16 extra = get_iword(0);
m68k_incpc(2);
	m68k_divl(opcode, dst, extra, oldpc);
}}}}endlabel871: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4c50_0(uae_u32 opcode) /* DIVL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{m68k_incpc(2);
{	uaecptr oldpc = m68k_getpc();
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
{	uae_s16 extra = get_iword(0);
m68k_incpc(2);
	m68k_divl(opcode, dst, extra, oldpc);
}}}}}endlabel872: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4c58_0(uae_u32 opcode) /* DIVL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{m68k_incpc(2);
{	uaecptr oldpc = m68k_getpc();
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
{	uae_s16 extra = get_iword(0);
m68k_incpc(2);
	m68k_divl(opcode, dst, extra, oldpc);
}}}}}endlabel873: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4c60_0(uae_u32 opcode) /* DIVL */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{m68k_incpc(2);
{	uaecptr oldpc = m68k_getpc();
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
{	uae_s16 extra = get_iword(0);
m68k_incpc(2);
	m68k_divl(opcode, dst, extra, oldpc);
}}}}}endlabel874: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_4c68_0(uae_u32 opcode) /* DIVL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{m68k_incpc(2);
{	uaecptr oldpc = m68k_getpc();
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
{	uae_s16 extra = get_iword(0);
m68k_incpc(4);
	m68k_divl(opcode, dst, extra, oldpc);
}}}}}endlabel875: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4c70_0(uae_u32 opcode) /* DIVL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{m68k_incpc(2);
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(0);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
	m68k_divl(opcode, dst, extra, oldpc);
}}}}}endlabel876: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4c78_0(uae_u32 opcode) /* DIVL */
{
{m68k_incpc(2);
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(0);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
m68k_incpc(4);
	m68k_divl(opcode, dst, extra, oldpc);
}}}}}endlabel877: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4c79_0(uae_u32 opcode) /* DIVL */
{
{m68k_incpc(2);
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(0);
	uaecptr dsta = get_ilong(2);
{	uae_s32 dst = get_long(dsta);
m68k_incpc(6);
	m68k_divl(opcode, dst, extra, oldpc);
}}}}endlabel878: (void)0;
return 12;
}
unsigned long REGPARAM2 op_4c7a_0(uae_u32 opcode) /* DIVL */
{
	uae_u32 dstreg = 2;
{m68k_incpc(2);
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(0);
	uaecptr dsta = m68k_getpc () + 2;
	dsta += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
m68k_incpc(4);
	m68k_divl(opcode, dst, extra, oldpc);
}}}}endlabel879: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4c7b_0(uae_u32 opcode) /* DIVL */
{
	uae_u32 dstreg = 3;
{m68k_incpc(2);
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(0);
m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 dst = get_long(dsta);
	m68k_divl(opcode, dst, extra, oldpc);
}}}}}endlabel880: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4c7c_0(uae_u32 opcode) /* DIVL */
{
{m68k_incpc(2);
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 extra = get_iword(0);
	uae_s32 dst = get_ilong(2);
m68k_incpc(6);
	m68k_divl(opcode, dst, extra, oldpc);
}}}endlabel881: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4c90_0(uae_u32 opcode) /* MVMEL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca = m68k_areg(regs, dstreg);
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; amask = movem_next[amask]; }
}}}m68k_incpc(4);
endlabel882: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4c98_0(uae_u32 opcode) /* MVMEL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca = m68k_areg(regs, dstreg);
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; amask = movem_next[amask]; }
	m68k_areg(regs, dstreg) = srca;
}}}m68k_incpc(4);
endlabel883: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4ca8_0(uae_u32 opcode) /* MVMEL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel884: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4cb0_0(uae_u32 opcode) /* MVMEL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
m68k_incpc(4);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; amask = movem_next[amask]; }
}}}endlabel885: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4cb8_0(uae_u32 opcode) /* MVMEL */
{
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(4);
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel886: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4cb9_0(uae_u32 opcode) /* MVMEL */
{
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca = get_ilong(4);
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; amask = movem_next[amask]; }
}}}m68k_incpc(8);
endlabel887: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4cba_0(uae_u32 opcode) /* MVMEL */
{
	uae_u32 dstreg = 2;
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca = m68k_getpc () + 4;
	srca += (uae_s32)(uae_s16)get_iword(4);
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel888: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4cbb_0(uae_u32 opcode) /* MVMEL */
{
	uae_u32 dstreg = 3;
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; amask = movem_next[amask]; }
}}}endlabel889: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4cd0_0(uae_u32 opcode) /* MVMEL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca = m68k_areg(regs, dstreg);
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = get_long(srca); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = get_long(srca); srca += 4; amask = movem_next[amask]; }
}}}m68k_incpc(4);
endlabel890: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4cd8_0(uae_u32 opcode) /* MVMEL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca = m68k_areg(regs, dstreg);
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = get_long(srca); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = get_long(srca); srca += 4; amask = movem_next[amask]; }
	m68k_areg(regs, dstreg) = srca;
}}}m68k_incpc(4);
endlabel891: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4ce8_0(uae_u32 opcode) /* MVMEL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = get_long(srca); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = get_long(srca); srca += 4; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel892: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4cf0_0(uae_u32 opcode) /* MVMEL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
m68k_incpc(4);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = get_long(srca); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = get_long(srca); srca += 4; amask = movem_next[amask]; }
}}}endlabel893: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4cf8_0(uae_u32 opcode) /* MVMEL */
{
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(4);
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = get_long(srca); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = get_long(srca); srca += 4; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel894: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4cf9_0(uae_u32 opcode) /* MVMEL */
{
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca = get_ilong(4);
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = get_long(srca); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = get_long(srca); srca += 4; amask = movem_next[amask]; }
}}}m68k_incpc(8);
endlabel895: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4cfa_0(uae_u32 opcode) /* MVMEL */
{
	uae_u32 dstreg = 2;
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca = m68k_getpc () + 4;
	srca += (uae_s32)(uae_s16)get_iword(4);
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = get_long(srca); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = get_long(srca); srca += 4; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel896: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4cfb_0(uae_u32 opcode) /* MVMEL */
{
	uae_u32 dstreg = 3;
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = get_long(srca); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = get_long(srca); srca += 4; amask = movem_next[amask]; }
}}}endlabel897: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4e40_0(uae_u32 opcode) /* TRAP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 15);
#else
	uae_u32 srcreg = (opcode & 15);
#endif
{	uae_u32 src = srcreg;
m68k_incpc(2);
	Exception(src+32,0);
}endlabel898: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4e50_0(uae_u32 opcode) /* LINK */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr olda = m68k_areg(regs, 7) - 4;
	m68k_areg (regs, 7) = olda;
{	uae_s32 src = m68k_areg(regs, srcreg);
	put_long(olda,src);
	m68k_areg(regs, srcreg) = (m68k_areg(regs, 7));
{	uae_s16 offs = get_iword(2);
	m68k_areg(regs, 7) += offs;
	Software_ProcessLINK (offs);
}}}}m68k_incpc(4);
endlabel899: (void)0;
	Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_4e58_0(uae_u32 opcode) /* UNLK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
	m68k_areg(regs, 7) = src;
{	uaecptr olda = m68k_areg(regs, 7);
	m68k_areg(regs, 7) += 4;
{	uae_s32 old = get_long(olda);
	m68k_areg(regs, srcreg) = (old);
}}}}m68k_incpc(2);
endlabel900: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4e60_0(uae_u32 opcode) /* MVR2USP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel901; }
{{	uae_s32 src = m68k_areg(regs, srcreg);
	regs.usp = src;
}}}m68k_incpc(2);
endlabel901: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4e68_0(uae_u32 opcode) /* MVUSP2R */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel902; }
{{	m68k_areg(regs, srcreg) = (regs.usp);
}}}m68k_incpc(2);
endlabel902: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4e70_0(uae_u32 opcode) /* RESET */
{
{if (!regs.s) { Exception(8,0); goto endlabel903; }
{	customreset();
}}m68k_incpc(2);
endlabel903: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4e71_0(uae_u32 opcode) /* NOP */
{
{}m68k_incpc(2);
endlabel904: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4e72_0(uae_u32 opcode) /* STOP */
{
{if (!regs.s) { Exception(8,0); goto endlabel905; }
{{	uae_s16 src = get_iword(2);
	regs.sr = src;
	MakeFromSR();
	m68k_setstopped(1);
}}}m68k_incpc(4);
endlabel905: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4e73_0(uae_u32 opcode) /* RTE */
{
{if (!regs.s) { Exception(8,0); goto endlabel906; }
{	uae_u16 newsr; uae_u32 newpc; for (;;) {
{	uaecptr sra = m68k_areg(regs, 7);
	m68k_areg(regs, 7) += 2;
{	uae_s16 sr = get_word(sra);
{	uaecptr pca = m68k_areg(regs, 7);
	m68k_areg(regs, 7) += 4;
{	uae_s32 pc = get_long(pca);
{	uaecptr formata = m68k_areg(regs, 7);
	m68k_areg(regs, 7) += 2;
{	uae_s16 format = get_word(formata);
	newsr = sr; newpc = pc;
	if ((format & 0xF000) == 0x0000) { break; }
	else if ((format & 0xF000) == 0x1000) { ; }
	else if ((format & 0xF000) == 0x2000) { m68k_areg(regs, 7) += 4; break; }
	else if ((format & 0xF000) == 0x8000) { m68k_areg(regs, 7) += 50; break; }
	else if ((format & 0xF000) == 0x9000) { m68k_areg(regs, 7) += 12; break; }
	else if ((format & 0xF000) == 0xa000) { m68k_areg(regs, 7) += 24; break; }
	else if ((format & 0xF000) == 0xb000) { m68k_areg(regs, 7) += 84; break; }
	else { Exception(14,0); goto endlabel906; }
	regs.sr = newsr; MakeFromSR();
}
}}}}}}	regs.sr = newsr; MakeFromSR();
	m68k_setpc_rte(newpc);
}}endlabel906: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4e74_0(uae_u32 opcode) /* RTD */
{
{	compiler_flush_jsr_stack();
{	uaecptr pca = m68k_areg(regs, 7);
	m68k_areg(regs, 7) += 4;
{	uae_s32 pc = get_long(pca);
{	uae_s16 offs = get_iword(2);
	m68k_areg(regs, 7) += offs;
	m68k_setpc_rte(pc);
}}}}endlabel907: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4e75_0(uae_u32 opcode) /* RTS */
{
{	m68k_do_rts();
}endlabel908: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4e76_0(uae_u32 opcode) /* TRAPV */
{
{m68k_incpc(2);
	if(VFLG) { Exception(7,m68k_getpc()); goto endlabel909; }
}endlabel909: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4e77_0(uae_u32 opcode) /* RTR */
{
{	compiler_flush_jsr_stack();
	MakeSR();
{	uaecptr sra = m68k_areg(regs, 7);
	m68k_areg(regs, 7) += 2;
{	uae_s16 sr = get_word(sra);
{	uaecptr pca = m68k_areg(regs, 7);
	m68k_areg(regs, 7) += 4;
{	uae_s32 pc = get_long(pca);
	regs.sr &= 0xFF00; sr &= 0xFF;
	regs.sr |= sr; m68k_setpc(pc);
	MakeFromSR();
}}}}}endlabel910: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4e7a_0(uae_u32 opcode) /* MOVEC2 */
{
{if (!regs.s) { Exception(8,0); goto endlabel911; }
{{	uae_s16 src = get_iword(2);
{	int regno = (src >> 12) & 15;
	uae_u32 *regp = regs.regs + regno;
	m68k_movec2(src & 0xFFF, regp);
}}}}m68k_incpc(4);
endlabel911: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4e7b_0(uae_u32 opcode) /* MOVE2C */
{
{if (!regs.s) { Exception(8,0); goto endlabel912; }
{{	uae_s16 src = get_iword(2);
{	int regno = (src >> 12) & 15;
	uae_u32 *regp = regs.regs + regno;
	m68k_move2c(src & 0xFFF, regp);
}}}}m68k_incpc(4);
endlabel912: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4e90_0(uae_u32 opcode) /* JSR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	if (!Software_ProcessJSR_Ind (m68k_getpc()))
		m68k_do_jsr(m68k_getpc() + 2, srca);
}}endlabel913: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4ea8_0(uae_u32 opcode) /* JSR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
	m68k_do_jsr(m68k_getpc() + 4, srca);
}}endlabel914: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4eb0_0(uae_u32 opcode) /* JSR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
	m68k_do_jsr(m68k_getpc() + 0, srca);
}}endlabel915: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4eb8_0(uae_u32 opcode) /* JSR */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
	m68k_do_jsr(m68k_getpc() + 4, srca);
}}endlabel916: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4eb9_0(uae_u32 opcode) /* JSR */
{
{{	uaecptr srca = get_ilong(2);
	m68k_do_jsr(m68k_getpc() + 6, srca);
}}endlabel917: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4eba_0(uae_u32 opcode) /* JSR */
{
{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
	m68k_do_jsr(m68k_getpc() + 4, srca);
}}endlabel918: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4ebb_0(uae_u32 opcode) /* JSR */
{
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
	m68k_do_jsr(m68k_getpc() + 0, srca);
}}endlabel919: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4ed0_0(uae_u32 opcode) /* JMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_setpc(srca);
}}endlabel920: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4ee8_0(uae_u32 opcode) /* JMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
	m68k_setpc(srca);
}}endlabel921: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4ef0_0(uae_u32 opcode) /* JMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
	m68k_setpc(srca);
}}endlabel922: (void)0;
return 2;
}
unsigned long REGPARAM2 op_4ef8_0(uae_u32 opcode) /* JMP */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
	m68k_setpc(srca);
}}endlabel923: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4ef9_0(uae_u32 opcode) /* JMP */
{
{{	uaecptr srca = get_ilong(2);
	m68k_setpc(srca);
}}endlabel924: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4efa_0(uae_u32 opcode) /* JMP */
{
{{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
	m68k_setpc(srca);
}}endlabel925: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4efb_0(uae_u32 opcode) /* JMP */
{
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
	m68k_setpc(srca);
}}endlabel926: (void)0;
return 2;
}
#endif

#ifdef PART_5
unsigned long REGPARAM2 op_5000_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}m68k_incpc(2);
endlabel927: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5010_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel928: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5018_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel929: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5020_0(uae_u32 opcode) /* ADD */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel930: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_5028_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel931: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5030_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}endlabel932: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5038_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel933: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5039_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = get_ilong(2);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(6);
endlabel934: (void)0;
return 10;
}
unsigned long REGPARAM2 op_5040_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}m68k_incpc(2);
endlabel935: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5048_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}m68k_incpc(2);
endlabel936: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 2;
}
unsigned long REGPARAM2 op_5050_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel937: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5058_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel938: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5060_0(uae_u32 opcode) /* ADD */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel939: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_5068_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel940: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5070_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}endlabel941: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5078_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel942: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5079_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = get_ilong(2);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(6);
endlabel943: (void)0;
return 10;
}
unsigned long REGPARAM2 op_5080_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel944: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5088_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}m68k_incpc(2);
endlabel945: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 2;
}
unsigned long REGPARAM2 op_5090_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel946: (void)0;
return 10;
}
unsigned long REGPARAM2 op_5098_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel947: (void)0;
return 10;
}
unsigned long REGPARAM2 op_50a0_0(uae_u32 opcode) /* ADD */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel948: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_50a8_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel949: (void)0;
return 12;
}
unsigned long REGPARAM2 op_50b0_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}endlabel950: (void)0;
return 10;
}
unsigned long REGPARAM2 op_50b8_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel951: (void)0;
return 12;
}
unsigned long REGPARAM2 op_50b9_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = get_ilong(2);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(6);
endlabel952: (void)0;
return 14;
}
unsigned long REGPARAM2 op_50c0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(0) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel953: (void)0;
return 2;
}
unsigned long REGPARAM2 op_50c8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(0)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel954;
		}
	}
}}}m68k_incpc(4);
endlabel954: (void)0;
return 4;
}
unsigned long REGPARAM2 op_50d0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(0) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel955: (void)0;
return 4;
}
unsigned long REGPARAM2 op_50d8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(0) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel956: (void)0;
return 4;
}
unsigned long REGPARAM2 op_50e0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(0) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel957: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_50e8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(0) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel958: (void)0;
return 6;
}
unsigned long REGPARAM2 op_50f0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(0) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel959: (void)0;
return 4;
}
unsigned long REGPARAM2 op_50f8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(0) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel960: (void)0;
return 6;
}
unsigned long REGPARAM2 op_50f9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(0) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel961: (void)0;
return 8;
}
unsigned long REGPARAM2 op_50fa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(0)) { Exception(7,m68k_getpc()); goto endlabel962; }
}}m68k_incpc(4);
endlabel962: (void)0;
return 4;
}
unsigned long REGPARAM2 op_50fb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(0)) { Exception(7,m68k_getpc()); goto endlabel963; }
}}m68k_incpc(6);
endlabel963: (void)0;
return 6;
}
unsigned long REGPARAM2 op_50fc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(0)) { Exception(7,m68k_getpc()); goto endlabel964; }
}m68k_incpc(2);
endlabel964: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5100_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}m68k_incpc(2);
endlabel965: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5110_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel966: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5118_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel967: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5120_0(uae_u32 opcode) /* SUB */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel968: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_5128_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel969: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5130_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}endlabel970: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5138_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel971: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5139_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = get_ilong(2);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(6);
endlabel972: (void)0;
return 10;
}
unsigned long REGPARAM2 op_5140_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}m68k_incpc(2);
endlabel973: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5148_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}m68k_incpc(2);
endlabel974: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 2;
}
unsigned long REGPARAM2 op_5150_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel975: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5158_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel976: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5160_0(uae_u32 opcode) /* SUB */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel977: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_5168_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel978: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5170_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}endlabel979: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5178_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel980: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5179_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = get_ilong(2);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(6);
endlabel981: (void)0;
return 10;
}
unsigned long REGPARAM2 op_5180_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel982: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5188_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}m68k_incpc(2);
endlabel983: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 2;
}
unsigned long REGPARAM2 op_5190_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel984: (void)0;
return 10;
}
unsigned long REGPARAM2 op_5198_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel985: (void)0;
return 10;
}
unsigned long REGPARAM2 op_51a0_0(uae_u32 opcode) /* SUB */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(2);
endlabel986: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_51a8_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel987: (void)0;
return 12;
}
unsigned long REGPARAM2 op_51b0_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}endlabel988: (void)0;
return 10;
}
unsigned long REGPARAM2 op_51b8_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel989: (void)0;
return 12;
}
unsigned long REGPARAM2 op_51b9_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = get_ilong(2);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(6);
endlabel990: (void)0;
return 14;
}
unsigned long REGPARAM2 op_51c0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(1) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel991: (void)0;
return 2;
}
unsigned long REGPARAM2 op_51c8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(1)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel992;
		}
	}
}}}m68k_incpc(4);
endlabel992: (void)0;
return 4;
}
unsigned long REGPARAM2 op_51d0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(1) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel993: (void)0;
return 4;
}
unsigned long REGPARAM2 op_51d8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(1) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel994: (void)0;
return 4;
}
unsigned long REGPARAM2 op_51e0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(1) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel995: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_51e8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(1) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel996: (void)0;
return 6;
}
unsigned long REGPARAM2 op_51f0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(1) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel997: (void)0;
return 4;
}
unsigned long REGPARAM2 op_51f8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(1) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel998: (void)0;
return 6;
}
unsigned long REGPARAM2 op_51f9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(1) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel999: (void)0;
return 8;
}
unsigned long REGPARAM2 op_51fa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(1)) { Exception(7,m68k_getpc()); goto endlabel1000; }
}}m68k_incpc(4);
endlabel1000: (void)0;
return 4;
}
unsigned long REGPARAM2 op_51fb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(1)) { Exception(7,m68k_getpc()); goto endlabel1001; }
}}m68k_incpc(6);
endlabel1001: (void)0;
return 6;
}
unsigned long REGPARAM2 op_51fc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(1)) { Exception(7,m68k_getpc()); goto endlabel1002; }
}m68k_incpc(2);
endlabel1002: (void)0;
return 2;
}
unsigned long REGPARAM2 op_52c0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(2) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel1003: (void)0;
return 2;
}
unsigned long REGPARAM2 op_52c8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(2)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel1004;
		}
	}
}}}m68k_incpc(4);
endlabel1004: (void)0;
return 4;
}
unsigned long REGPARAM2 op_52d0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(2) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1005: (void)0;
return 4;
}
unsigned long REGPARAM2 op_52d8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(2) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1006: (void)0;
return 4;
}
unsigned long REGPARAM2 op_52e0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(2) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1007: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_52e8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(2) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1008: (void)0;
return 6;
}
unsigned long REGPARAM2 op_52f0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(2) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel1009: (void)0;
return 4;
}
unsigned long REGPARAM2 op_52f8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(2) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1010: (void)0;
return 6;
}
unsigned long REGPARAM2 op_52f9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(2) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel1011: (void)0;
return 8;
}
unsigned long REGPARAM2 op_52fa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(2)) { Exception(7,m68k_getpc()); goto endlabel1012; }
}}m68k_incpc(4);
endlabel1012: (void)0;
return 4;
}
unsigned long REGPARAM2 op_52fb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(2)) { Exception(7,m68k_getpc()); goto endlabel1013; }
}}m68k_incpc(6);
endlabel1013: (void)0;
return 6;
}
unsigned long REGPARAM2 op_52fc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(2)) { Exception(7,m68k_getpc()); goto endlabel1014; }
}m68k_incpc(2);
endlabel1014: (void)0;
return 2;
}
unsigned long REGPARAM2 op_53c0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(3) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel1015: (void)0;
return 2;
}
unsigned long REGPARAM2 op_53c8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(3)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel1016;
		}
	}
}}}m68k_incpc(4);
endlabel1016: (void)0;
return 4;
}
unsigned long REGPARAM2 op_53d0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(3) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1017: (void)0;
return 4;
}
unsigned long REGPARAM2 op_53d8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(3) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1018: (void)0;
return 4;
}
unsigned long REGPARAM2 op_53e0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(3) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1019: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_53e8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(3) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1020: (void)0;
return 6;
}
unsigned long REGPARAM2 op_53f0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(3) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel1021: (void)0;
return 4;
}
unsigned long REGPARAM2 op_53f8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(3) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1022: (void)0;
return 6;
}
unsigned long REGPARAM2 op_53f9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(3) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel1023: (void)0;
return 8;
}
unsigned long REGPARAM2 op_53fa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(3)) { Exception(7,m68k_getpc()); goto endlabel1024; }
}}m68k_incpc(4);
endlabel1024: (void)0;
return 4;
}
unsigned long REGPARAM2 op_53fb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(3)) { Exception(7,m68k_getpc()); goto endlabel1025; }
}}m68k_incpc(6);
endlabel1025: (void)0;
return 6;
}
unsigned long REGPARAM2 op_53fc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(3)) { Exception(7,m68k_getpc()); goto endlabel1026; }
}m68k_incpc(2);
endlabel1026: (void)0;
return 2;
}
unsigned long REGPARAM2 op_54c0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(4) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel1027: (void)0;
return 2;
}
unsigned long REGPARAM2 op_54c8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(4)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel1028;
		}
	}
}}}m68k_incpc(4);
endlabel1028: (void)0;
return 4;
}
unsigned long REGPARAM2 op_54d0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(4) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1029: (void)0;
return 4;
}
unsigned long REGPARAM2 op_54d8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(4) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1030: (void)0;
return 4;
}
unsigned long REGPARAM2 op_54e0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(4) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1031: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_54e8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(4) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1032: (void)0;
return 6;
}
unsigned long REGPARAM2 op_54f0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(4) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel1033: (void)0;
return 4;
}
unsigned long REGPARAM2 op_54f8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(4) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1034: (void)0;
return 6;
}
unsigned long REGPARAM2 op_54f9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(4) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel1035: (void)0;
return 8;
}
unsigned long REGPARAM2 op_54fa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(4)) { Exception(7,m68k_getpc()); goto endlabel1036; }
}}m68k_incpc(4);
endlabel1036: (void)0;
return 4;
}
unsigned long REGPARAM2 op_54fb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(4)) { Exception(7,m68k_getpc()); goto endlabel1037; }
}}m68k_incpc(6);
endlabel1037: (void)0;
return 6;
}
unsigned long REGPARAM2 op_54fc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(4)) { Exception(7,m68k_getpc()); goto endlabel1038; }
}m68k_incpc(2);
endlabel1038: (void)0;
return 2;
}
unsigned long REGPARAM2 op_55c0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(5) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel1039: (void)0;
return 2;
}
unsigned long REGPARAM2 op_55c8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(5)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel1040;
		}
	}
}}}m68k_incpc(4);
endlabel1040: (void)0;
return 4;
}
unsigned long REGPARAM2 op_55d0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(5) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1041: (void)0;
return 4;
}
unsigned long REGPARAM2 op_55d8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(5) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1042: (void)0;
return 4;
}
unsigned long REGPARAM2 op_55e0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(5) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1043: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_55e8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(5) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1044: (void)0;
return 6;
}
unsigned long REGPARAM2 op_55f0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(5) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel1045: (void)0;
return 4;
}
unsigned long REGPARAM2 op_55f8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(5) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1046: (void)0;
return 6;
}
unsigned long REGPARAM2 op_55f9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(5) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel1047: (void)0;
return 8;
}
unsigned long REGPARAM2 op_55fa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(5)) { Exception(7,m68k_getpc()); goto endlabel1048; }
}}m68k_incpc(4);
endlabel1048: (void)0;
return 4;
}
unsigned long REGPARAM2 op_55fb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(5)) { Exception(7,m68k_getpc()); goto endlabel1049; }
}}m68k_incpc(6);
endlabel1049: (void)0;
return 6;
}
unsigned long REGPARAM2 op_55fc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(5)) { Exception(7,m68k_getpc()); goto endlabel1050; }
}m68k_incpc(2);
endlabel1050: (void)0;
return 2;
}
unsigned long REGPARAM2 op_56c0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(6) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel1051: (void)0;
return 2;
}
unsigned long REGPARAM2 op_56c8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(6)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel1052;
		}
	}
}}}m68k_incpc(4);
endlabel1052: (void)0;
return 4;
}
unsigned long REGPARAM2 op_56d0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(6) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1053: (void)0;
return 4;
}
unsigned long REGPARAM2 op_56d8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(6) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1054: (void)0;
return 4;
}
unsigned long REGPARAM2 op_56e0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(6) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1055: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_56e8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(6) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1056: (void)0;
return 6;
}
unsigned long REGPARAM2 op_56f0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(6) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel1057: (void)0;
return 4;
}
unsigned long REGPARAM2 op_56f8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(6) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1058: (void)0;
return 6;
}
unsigned long REGPARAM2 op_56f9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(6) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel1059: (void)0;
return 8;
}
unsigned long REGPARAM2 op_56fa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(6)) { Exception(7,m68k_getpc()); goto endlabel1060; }
}}m68k_incpc(4);
endlabel1060: (void)0;
return 4;
}
unsigned long REGPARAM2 op_56fb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(6)) { Exception(7,m68k_getpc()); goto endlabel1061; }
}}m68k_incpc(6);
endlabel1061: (void)0;
return 6;
}
unsigned long REGPARAM2 op_56fc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(6)) { Exception(7,m68k_getpc()); goto endlabel1062; }
}m68k_incpc(2);
endlabel1062: (void)0;
return 2;
}
unsigned long REGPARAM2 op_57c0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(7) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel1063: (void)0;
return 2;
}
unsigned long REGPARAM2 op_57c8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(7)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel1064;
		}
	}
}}}m68k_incpc(4);
endlabel1064: (void)0;
return 4;
}
unsigned long REGPARAM2 op_57d0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(7) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1065: (void)0;
return 4;
}
unsigned long REGPARAM2 op_57d8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(7) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1066: (void)0;
return 4;
}
unsigned long REGPARAM2 op_57e0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(7) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1067: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_57e8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(7) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1068: (void)0;
return 6;
}
unsigned long REGPARAM2 op_57f0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(7) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel1069: (void)0;
return 4;
}
unsigned long REGPARAM2 op_57f8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(7) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1070: (void)0;
return 6;
}
unsigned long REGPARAM2 op_57f9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(7) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel1071: (void)0;
return 8;
}
unsigned long REGPARAM2 op_57fa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(7)) { Exception(7,m68k_getpc()); goto endlabel1072; }
}}m68k_incpc(4);
endlabel1072: (void)0;
return 4;
}
unsigned long REGPARAM2 op_57fb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(7)) { Exception(7,m68k_getpc()); goto endlabel1073; }
}}m68k_incpc(6);
endlabel1073: (void)0;
return 6;
}
unsigned long REGPARAM2 op_57fc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(7)) { Exception(7,m68k_getpc()); goto endlabel1074; }
}m68k_incpc(2);
endlabel1074: (void)0;
return 2;
}
unsigned long REGPARAM2 op_58c0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(8) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel1075: (void)0;
return 2;
}
unsigned long REGPARAM2 op_58c8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(8)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel1076;
		}
	}
}}}m68k_incpc(4);
endlabel1076: (void)0;
return 4;
}
unsigned long REGPARAM2 op_58d0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(8) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1077: (void)0;
return 4;
}
unsigned long REGPARAM2 op_58d8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(8) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1078: (void)0;
return 4;
}
unsigned long REGPARAM2 op_58e0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(8) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1079: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_58e8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(8) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1080: (void)0;
return 6;
}
unsigned long REGPARAM2 op_58f0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(8) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel1081: (void)0;
return 4;
}
unsigned long REGPARAM2 op_58f8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(8) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1082: (void)0;
return 6;
}
unsigned long REGPARAM2 op_58f9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(8) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel1083: (void)0;
return 8;
}
unsigned long REGPARAM2 op_58fa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(8)) { Exception(7,m68k_getpc()); goto endlabel1084; }
}}m68k_incpc(4);
endlabel1084: (void)0;
return 4;
}
unsigned long REGPARAM2 op_58fb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(8)) { Exception(7,m68k_getpc()); goto endlabel1085; }
}}m68k_incpc(6);
endlabel1085: (void)0;
return 6;
}
unsigned long REGPARAM2 op_58fc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(8)) { Exception(7,m68k_getpc()); goto endlabel1086; }
}m68k_incpc(2);
endlabel1086: (void)0;
return 2;
}
unsigned long REGPARAM2 op_59c0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(9) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel1087: (void)0;
return 2;
}
unsigned long REGPARAM2 op_59c8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(9)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel1088;
		}
	}
}}}m68k_incpc(4);
endlabel1088: (void)0;
return 4;
}
unsigned long REGPARAM2 op_59d0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(9) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1089: (void)0;
return 4;
}
unsigned long REGPARAM2 op_59d8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(9) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1090: (void)0;
return 4;
}
unsigned long REGPARAM2 op_59e0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(9) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1091: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_59e8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(9) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1092: (void)0;
return 6;
}
unsigned long REGPARAM2 op_59f0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(9) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel1093: (void)0;
return 4;
}
unsigned long REGPARAM2 op_59f8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(9) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1094: (void)0;
return 6;
}
unsigned long REGPARAM2 op_59f9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(9) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel1095: (void)0;
return 8;
}
unsigned long REGPARAM2 op_59fa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(9)) { Exception(7,m68k_getpc()); goto endlabel1096; }
}}m68k_incpc(4);
endlabel1096: (void)0;
return 4;
}
unsigned long REGPARAM2 op_59fb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(9)) { Exception(7,m68k_getpc()); goto endlabel1097; }
}}m68k_incpc(6);
endlabel1097: (void)0;
return 6;
}
unsigned long REGPARAM2 op_59fc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(9)) { Exception(7,m68k_getpc()); goto endlabel1098; }
}m68k_incpc(2);
endlabel1098: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5ac0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(10) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel1099: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5ac8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(10)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel1100;
		}
	}
}}}m68k_incpc(4);
endlabel1100: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5ad0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(10) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1101: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5ad8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(10) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1102: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5ae0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(10) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1103: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_5ae8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(10) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1104: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5af0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(10) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel1105: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5af8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(10) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1106: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5af9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(10) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel1107: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5afa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(10)) { Exception(7,m68k_getpc()); goto endlabel1108; }
}}m68k_incpc(4);
endlabel1108: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5afb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(10)) { Exception(7,m68k_getpc()); goto endlabel1109; }
}}m68k_incpc(6);
endlabel1109: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5afc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(10)) { Exception(7,m68k_getpc()); goto endlabel1110; }
}m68k_incpc(2);
endlabel1110: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5bc0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(11) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel1111: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5bc8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(11)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel1112;
		}
	}
}}}m68k_incpc(4);
endlabel1112: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5bd0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(11) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1113: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5bd8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(11) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1114: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5be0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(11) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1115: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_5be8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(11) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1116: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5bf0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(11) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel1117: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5bf8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(11) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1118: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5bf9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(11) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel1119: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5bfa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(11)) { Exception(7,m68k_getpc()); goto endlabel1120; }
}}m68k_incpc(4);
endlabel1120: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5bfb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(11)) { Exception(7,m68k_getpc()); goto endlabel1121; }
}}m68k_incpc(6);
endlabel1121: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5bfc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(11)) { Exception(7,m68k_getpc()); goto endlabel1122; }
}m68k_incpc(2);
endlabel1122: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5cc0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(12) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel1123: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5cc8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(12)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel1124;
		}
	}
}}}m68k_incpc(4);
endlabel1124: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5cd0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(12) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1125: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5cd8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(12) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1126: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5ce0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(12) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1127: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_5ce8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(12) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1128: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5cf0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(12) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel1129: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5cf8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(12) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1130: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5cf9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(12) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel1131: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5cfa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(12)) { Exception(7,m68k_getpc()); goto endlabel1132; }
}}m68k_incpc(4);
endlabel1132: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5cfb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(12)) { Exception(7,m68k_getpc()); goto endlabel1133; }
}}m68k_incpc(6);
endlabel1133: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5cfc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(12)) { Exception(7,m68k_getpc()); goto endlabel1134; }
}m68k_incpc(2);
endlabel1134: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5dc0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(13) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel1135: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5dc8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(13)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel1136;
		}
	}
}}}m68k_incpc(4);
endlabel1136: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5dd0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(13) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1137: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5dd8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(13) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1138: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5de0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(13) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1139: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_5de8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(13) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1140: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5df0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(13) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel1141: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5df8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(13) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1142: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5df9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(13) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel1143: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5dfa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(13)) { Exception(7,m68k_getpc()); goto endlabel1144; }
}}m68k_incpc(4);
endlabel1144: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5dfb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(13)) { Exception(7,m68k_getpc()); goto endlabel1145; }
}}m68k_incpc(6);
endlabel1145: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5dfc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(13)) { Exception(7,m68k_getpc()); goto endlabel1146; }
}m68k_incpc(2);
endlabel1146: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5ec0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(14) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel1147: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5ec8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(14)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel1148;
		}
	}
}}}m68k_incpc(4);
endlabel1148: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5ed0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(14) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1149: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5ed8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(14) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1150: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5ee0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(14) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1151: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_5ee8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(14) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1152: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5ef0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(14) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel1153: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5ef8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(14) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1154: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5ef9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(14) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel1155: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5efa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(14)) { Exception(7,m68k_getpc()); goto endlabel1156; }
}}m68k_incpc(4);
endlabel1156: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5efb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(14)) { Exception(7,m68k_getpc()); goto endlabel1157; }
}}m68k_incpc(6);
endlabel1157: (void)0;
return 6;
}
#endif

#ifdef PART_6
unsigned long REGPARAM2 op_5efc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(14)) { Exception(7,m68k_getpc()); goto endlabel1158; }
}m68k_incpc(2);
endlabel1158: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5fc0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{{	int val = cctrue(15) ? 0xff : 0;
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xff) | ((val) & 0xff);
}}}m68k_incpc(2);
endlabel1159: (void)0;
return 2;
}
unsigned long REGPARAM2 op_5fc8_0(uae_u32 opcode) /* DBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 offs = get_iword(2);
	if (!cctrue(15)) {
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | (((src-1)) & 0xffff);
		if (src) {
			m68k_incpc((uae_s32)offs + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
		goto endlabel1160;
		}
	}
}}}m68k_incpc(4);
endlabel1160: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5fd0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	int val = cctrue(15) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1161: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5fd8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	int val = cctrue(15) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1162: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5fe0_0(uae_u32 opcode) /* Scc */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	int val = cctrue(15) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(2);
endlabel1163: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_5fe8_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(15) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1164: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5ff0_0(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	int val = cctrue(15) ? 0xff : 0;
	put_byte(srca,val);
}}}endlabel1165: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5ff8_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	int val = cctrue(15) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel1166: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5ff9_0(uae_u32 opcode) /* Scc */
{
{{	uaecptr srca = get_ilong(2);
{	int val = cctrue(15) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(6);
endlabel1167: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5ffa_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s16 dummy = get_iword(2);
	if (cctrue(15)) { Exception(7,m68k_getpc()); goto endlabel1168; }
}}m68k_incpc(4);
endlabel1168: (void)0;
return 4;
}
unsigned long REGPARAM2 op_5ffb_0(uae_u32 opcode) /* TRAPcc */
{
{{	uae_s32 dummy = get_ilong(2);
	if (cctrue(15)) { Exception(7,m68k_getpc()); goto endlabel1169; }
}}m68k_incpc(6);
endlabel1169: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5ffc_0(uae_u32 opcode) /* TRAPcc */
{
{	if (cctrue(15)) { Exception(7,m68k_getpc()); goto endlabel1170; }
}m68k_incpc(2);
endlabel1170: (void)0;
return 2;
}
unsigned long REGPARAM2 op_6000_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s16 src = get_iword(2);
	if (!cctrue(0)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1171;
didnt_jump:;
}}m68k_incpc(4);
endlabel1171: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6001_0(uae_u32 opcode) /* Bcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	if (!cctrue(0)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1172;
didnt_jump:;
}m68k_incpc(2);
endlabel1172: (void)0;
return 2;
}
unsigned long REGPARAM2 op_60ff_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s32 src = get_ilong(2);
	if (!cctrue(0)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1173;
didnt_jump:;
}}m68k_incpc(6);
endlabel1173: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6100_0(uae_u32 opcode) /* BSR */
{
{{	uae_s16 src = get_iword(2);
	uae_s32 s = (uae_s32)src + 2;
	m68k_do_bsr(m68k_getpc() + 4, s);
}}endlabel1174: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6101_0(uae_u32 opcode) /* BSR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	uae_s32 s = (uae_s32)src + 2;
	m68k_do_bsr(m68k_getpc() + 2, s);
}endlabel1175: (void)0;
return 2;
}
unsigned long REGPARAM2 op_61ff_0(uae_u32 opcode) /* BSR */
{
{{	uae_s32 src = get_ilong(2);
	uae_s32 s = (uae_s32)src + 2;
	m68k_do_bsr(m68k_getpc() + 6, s);
}}endlabel1176: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6200_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s16 src = get_iword(2);
	if (!cctrue(2)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1177;
didnt_jump:;
}}m68k_incpc(4);
endlabel1177: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6201_0(uae_u32 opcode) /* Bcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	if (!cctrue(2)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1178;
didnt_jump:;
}m68k_incpc(2);
endlabel1178: (void)0;
return 2;
}
unsigned long REGPARAM2 op_62ff_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s32 src = get_ilong(2);
	if (!cctrue(2)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1179;
didnt_jump:;
}}m68k_incpc(6);
endlabel1179: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6300_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s16 src = get_iword(2);
	if (!cctrue(3)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1180;
didnt_jump:;
}}m68k_incpc(4);
endlabel1180: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6301_0(uae_u32 opcode) /* Bcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	if (!cctrue(3)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1181;
didnt_jump:;
}m68k_incpc(2);
endlabel1181: (void)0;
return 2;
}
unsigned long REGPARAM2 op_63ff_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s32 src = get_ilong(2);
	if (!cctrue(3)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1182;
didnt_jump:;
}}m68k_incpc(6);
endlabel1182: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6400_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s16 src = get_iword(2);
	if (!cctrue(4)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1183;
didnt_jump:;
}}m68k_incpc(4);
endlabel1183: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6401_0(uae_u32 opcode) /* Bcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	if (!cctrue(4)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1184;
didnt_jump:;
}m68k_incpc(2);
endlabel1184: (void)0;
return 2;
}
unsigned long REGPARAM2 op_64ff_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s32 src = get_ilong(2);
	if (!cctrue(4)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1185;
didnt_jump:;
}}m68k_incpc(6);
endlabel1185: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6500_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s16 src = get_iword(2);
	if (!cctrue(5)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1186;
didnt_jump:;
}}m68k_incpc(4);
endlabel1186: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6501_0(uae_u32 opcode) /* Bcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	if (!cctrue(5)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1187;
didnt_jump:;
}m68k_incpc(2);
endlabel1187: (void)0;
return 2;
}
unsigned long REGPARAM2 op_65ff_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s32 src = get_ilong(2);
	if (!cctrue(5)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1188;
didnt_jump:;
}}m68k_incpc(6);
endlabel1188: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6600_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s16 src = get_iword(2);
	if (!cctrue(6)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1189;
didnt_jump:;
}}m68k_incpc(4);
endlabel1189: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6601_0(uae_u32 opcode) /* Bcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	if (!cctrue(6)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1190;
didnt_jump:;
}m68k_incpc(2);
endlabel1190: (void)0;
return 2;
}
unsigned long REGPARAM2 op_66ff_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s32 src = get_ilong(2);
	if (!cctrue(6)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1191;
didnt_jump:;
}}m68k_incpc(6);
endlabel1191: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6700_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s16 src = get_iword(2);
	if (!cctrue(7)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1192;
didnt_jump:;
}}m68k_incpc(4);
endlabel1192: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6701_0(uae_u32 opcode) /* Bcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	if (!cctrue(7)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1193;
didnt_jump:;
}m68k_incpc(2);
endlabel1193: (void)0;
return 2;
}
unsigned long REGPARAM2 op_67ff_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s32 src = get_ilong(2);
	if (!cctrue(7)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1194;
didnt_jump:;
}}m68k_incpc(6);
endlabel1194: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6800_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s16 src = get_iword(2);
	if (!cctrue(8)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1195;
didnt_jump:;
}}m68k_incpc(4);
endlabel1195: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6801_0(uae_u32 opcode) /* Bcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	if (!cctrue(8)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1196;
didnt_jump:;
}m68k_incpc(2);
endlabel1196: (void)0;
return 2;
}
unsigned long REGPARAM2 op_68ff_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s32 src = get_ilong(2);
	if (!cctrue(8)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1197;
didnt_jump:;
}}m68k_incpc(6);
endlabel1197: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6900_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s16 src = get_iword(2);
	if (!cctrue(9)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1198;
didnt_jump:;
}}m68k_incpc(4);
endlabel1198: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6901_0(uae_u32 opcode) /* Bcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	if (!cctrue(9)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1199;
didnt_jump:;
}m68k_incpc(2);
endlabel1199: (void)0;
return 2;
}
unsigned long REGPARAM2 op_69ff_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s32 src = get_ilong(2);
	if (!cctrue(9)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1200;
didnt_jump:;
}}m68k_incpc(6);
endlabel1200: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6a00_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s16 src = get_iword(2);
	if (!cctrue(10)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1201;
didnt_jump:;
}}m68k_incpc(4);
endlabel1201: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6a01_0(uae_u32 opcode) /* Bcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	if (!cctrue(10)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1202;
didnt_jump:;
}m68k_incpc(2);
endlabel1202: (void)0;
return 2;
}
unsigned long REGPARAM2 op_6aff_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s32 src = get_ilong(2);
	if (!cctrue(10)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1203;
didnt_jump:;
}}m68k_incpc(6);
endlabel1203: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6b00_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s16 src = get_iword(2);
	if (!cctrue(11)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1204;
didnt_jump:;
}}m68k_incpc(4);
endlabel1204: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6b01_0(uae_u32 opcode) /* Bcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	if (!cctrue(11)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1205;
didnt_jump:;
}m68k_incpc(2);
endlabel1205: (void)0;
return 2;
}
unsigned long REGPARAM2 op_6bff_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s32 src = get_ilong(2);
	if (!cctrue(11)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1206;
didnt_jump:;
}}m68k_incpc(6);
endlabel1206: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6c00_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s16 src = get_iword(2);
	if (!cctrue(12)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1207;
didnt_jump:;
}}m68k_incpc(4);
endlabel1207: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6c01_0(uae_u32 opcode) /* Bcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	if (!cctrue(12)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1208;
didnt_jump:;
}m68k_incpc(2);
endlabel1208: (void)0;
return 2;
}
unsigned long REGPARAM2 op_6cff_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s32 src = get_ilong(2);
	if (!cctrue(12)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1209;
didnt_jump:;
}}m68k_incpc(6);
endlabel1209: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6d00_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s16 src = get_iword(2);
	if (!cctrue(13)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1210;
didnt_jump:;
}}m68k_incpc(4);
endlabel1210: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6d01_0(uae_u32 opcode) /* Bcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	if (!cctrue(13)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1211;
didnt_jump:;
}m68k_incpc(2);
endlabel1211: (void)0;
return 2;
}
unsigned long REGPARAM2 op_6dff_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s32 src = get_ilong(2);
	if (!cctrue(13)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1212;
didnt_jump:;
}}m68k_incpc(6);
endlabel1212: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6e00_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s16 src = get_iword(2);
	if (!cctrue(14)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1213;
didnt_jump:;
}}m68k_incpc(4);
endlabel1213: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6e01_0(uae_u32 opcode) /* Bcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	if (!cctrue(14)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1214;
didnt_jump:;
}m68k_incpc(2);
endlabel1214: (void)0;
return 2;
}
unsigned long REGPARAM2 op_6eff_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s32 src = get_ilong(2);
	if (!cctrue(14)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1215;
didnt_jump:;
}}m68k_incpc(6);
endlabel1215: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6f00_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s16 src = get_iword(2);
	if (!cctrue(15)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1216;
didnt_jump:;
}}m68k_incpc(4);
endlabel1216: (void)0;
return 4;
}
unsigned long REGPARAM2 op_6f01_0(uae_u32 opcode) /* Bcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
{	uae_u32 src = srcreg;
	if (!cctrue(15)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1217;
didnt_jump:;
}m68k_incpc(2);
endlabel1217: (void)0;
return 2;
}
unsigned long REGPARAM2 op_6fff_0(uae_u32 opcode) /* Bcc */
{
{{	uae_s32 src = get_ilong(2);
	if (!cctrue(15)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel1218;
didnt_jump:;
}}m68k_incpc(6);
endlabel1218: (void)0;
return 6;
}
unsigned long REGPARAM2 op_7000_0(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = (uae_s32)(uae_s8)((opcode >> 8) & 255);
#else
	uae_u32 srcreg = (uae_s32)(uae_s8)(opcode & 255);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uae_u32 src = srcreg;
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}m68k_incpc(2);
endlabel1219: (void)0;
return 2;
}
unsigned long REGPARAM2 op_8000_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}m68k_incpc(2);
endlabel1220: (void)0;
return 2;
}
unsigned long REGPARAM2 op_8010_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(2);
endlabel1221: (void)0;
return 4;
}
unsigned long REGPARAM2 op_8018_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(2);
endlabel1222: (void)0;
return 4;
}
unsigned long REGPARAM2 op_8020_0(uae_u32 opcode) /* OR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(2);
endlabel1223: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_8028_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(4);
endlabel1224: (void)0;
return 6;
}
unsigned long REGPARAM2 op_8030_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}endlabel1225: (void)0;
return 4;
}
unsigned long REGPARAM2 op_8038_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(4);
endlabel1226: (void)0;
return 6;
}
unsigned long REGPARAM2 op_8039_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(6);
endlabel1227: (void)0;
return 8;
}
unsigned long REGPARAM2 op_803a_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(4);
endlabel1228: (void)0;
return 6;
}
unsigned long REGPARAM2 op_803b_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}endlabel1229: (void)0;
return 4;
}
unsigned long REGPARAM2 op_803c_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uae_s8 src = get_ibyte(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}m68k_incpc(4);
endlabel1230: (void)0;
return 4;
}
unsigned long REGPARAM2 op_8040_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}m68k_incpc(2);
endlabel1231: (void)0;
return 2;
}
unsigned long REGPARAM2 op_8050_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(2);
endlabel1232: (void)0;
return 4;
}
unsigned long REGPARAM2 op_8058_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(2);
endlabel1233: (void)0;
return 4;
}
unsigned long REGPARAM2 op_8060_0(uae_u32 opcode) /* OR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(2);
endlabel1234: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_8068_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(4);
endlabel1235: (void)0;
return 6;
}
unsigned long REGPARAM2 op_8070_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}endlabel1236: (void)0;
return 4;
}
unsigned long REGPARAM2 op_8078_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(4);
endlabel1237: (void)0;
return 6;
}
unsigned long REGPARAM2 op_8079_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(6);
endlabel1238: (void)0;
return 8;
}
unsigned long REGPARAM2 op_807a_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}}m68k_incpc(4);
endlabel1239: (void)0;
return 6;
}
unsigned long REGPARAM2 op_807b_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}endlabel1240: (void)0;
return 4;
}
unsigned long REGPARAM2 op_807c_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}m68k_incpc(4);
endlabel1241: (void)0;
return 4;
}
unsigned long REGPARAM2 op_8080_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}m68k_incpc(2);
endlabel1242: (void)0;
return 2;
}
unsigned long REGPARAM2 op_8090_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(2);
endlabel1243: (void)0;
return 6;
}
unsigned long REGPARAM2 op_8098_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(2);
endlabel1244: (void)0;
return 6;
}
unsigned long REGPARAM2 op_80a0_0(uae_u32 opcode) /* OR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(2);
endlabel1245: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_80a8_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(4);
endlabel1246: (void)0;
return 8;
}
unsigned long REGPARAM2 op_80b0_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}endlabel1247: (void)0;
return 6;
}
unsigned long REGPARAM2 op_80b8_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(4);
endlabel1248: (void)0;
return 8;
}
unsigned long REGPARAM2 op_80b9_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(6);
endlabel1249: (void)0;
return 10;
}
unsigned long REGPARAM2 op_80ba_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(4);
endlabel1250: (void)0;
return 8;
}
unsigned long REGPARAM2 op_80bb_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}endlabel1251: (void)0;
return 6;
}
unsigned long REGPARAM2 op_80bc_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}m68k_incpc(6);
endlabel1252: (void)0;
return 6;
}
unsigned long REGPARAM2 op_80c0_0(uae_u32 opcode) /* DIVU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel1253; } else {
	uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
	uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
	if (newv > 0xffff) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}m68k_incpc(2);
endlabel1253: (void)0;
return 70;
}
unsigned long REGPARAM2 op_80d0_0(uae_u32 opcode) /* DIVU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel1254; } else {
	uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
	uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
	if (newv > 0xffff) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(2);
endlabel1254: (void)0;
return 72;
}
unsigned long REGPARAM2 op_80d8_0(uae_u32 opcode) /* DIVU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel1255; } else {
	uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
	uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
	if (newv > 0xffff) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(2);
endlabel1255: (void)0;
return 72;
}
unsigned long REGPARAM2 op_80e0_0(uae_u32 opcode) /* DIVU */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel1256; } else {
	uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
	uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
	if (newv > 0xffff) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(2);
endlabel1256: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 72;
}
unsigned long REGPARAM2 op_80e8_0(uae_u32 opcode) /* DIVU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel1257; } else {
	uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
	uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
	if (newv > 0xffff) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(4);
endlabel1257: (void)0;
return 74;
}
unsigned long REGPARAM2 op_80f0_0(uae_u32 opcode) /* DIVU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel1258; } else {
	uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
	uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
	if (newv > 0xffff) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}endlabel1258: (void)0;
return 72;
}
unsigned long REGPARAM2 op_80f8_0(uae_u32 opcode) /* DIVU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	if(src == 0) { Exception(5,oldpc); goto endlabel1259; } else {
	uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
	uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
	if (newv > 0xffff) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(4);
endlabel1259: (void)0;
return 74;
}
unsigned long REGPARAM2 op_80f9_0(uae_u32 opcode) /* DIVU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	if(src == 0) { Exception(5,oldpc); goto endlabel1260; } else {
	uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
	uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
	if (newv > 0xffff) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(6);
endlabel1260: (void)0;
return 76;
}
unsigned long REGPARAM2 op_80fa_0(uae_u32 opcode) /* DIVU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	if(src == 0) { Exception(5,oldpc); goto endlabel1261; } else {
	uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
	uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
	if (newv > 0xffff) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}}m68k_incpc(4);
endlabel1261: (void)0;
return 74;
}
unsigned long REGPARAM2 op_80fb_0(uae_u32 opcode) /* DIVU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel1262; } else {
	uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
	uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
	if (newv > 0xffff) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}endlabel1262: (void)0;
return 72;
}
unsigned long REGPARAM2 op_80fc_0(uae_u32 opcode) /* DIVU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
	if(src == 0) { Exception(5,oldpc); goto endlabel1263; } else {
	uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
	uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
	if (newv > 0xffff) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}m68k_incpc(4);
endlabel1263: (void)0;
return 72;
}
unsigned long REGPARAM2 op_8100_0(uae_u32 opcode) /* SBCD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uae_u16 newv_lo = (dst & 0xF) - (src & 0xF) - (XFLG ? 1 : 0);
	uae_u16 newv_hi = (dst & 0xF0) - (src & 0xF0);
	uae_u16 newv;
	if (newv_lo > 9) { newv_lo-=6; newv_hi-=0x10; }
	newv = newv_hi + (newv_lo & 0xF);	CFLG = XFLG = (newv_hi & 0x1F0) > 0x90;
	if (CFLG) newv -= 0x60;
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}m68k_incpc(2);
endlabel1264: (void)0;
return 2;
}
unsigned long REGPARAM2 op_8108_0(uae_u32 opcode) /* SBCD */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{	uae_u16 newv_lo = (dst & 0xF) - (src & 0xF) - (XFLG ? 1 : 0);
	uae_u16 newv_hi = (dst & 0xF0) - (src & 0xF0);
	uae_u16 newv;
	if (newv_lo > 9) { newv_lo-=6; newv_hi-=0x10; }
	newv = newv_hi + (newv_lo & 0xF);	CFLG = XFLG = (newv_hi & 0x1F0) > 0x90;
	if (CFLG) newv -= 0x60;
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1265: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_8110_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel1266: (void)0;
return 6;
}
unsigned long REGPARAM2 op_8118_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel1267: (void)0;
return 6;
}
unsigned long REGPARAM2 op_8120_0(uae_u32 opcode) /* OR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel1268: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_8128_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel1269: (void)0;
return 8;
}
unsigned long REGPARAM2 op_8130_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel1270: (void)0;
return 6;
}
unsigned long REGPARAM2 op_8138_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel1271: (void)0;
return 8;
}
unsigned long REGPARAM2 op_8139_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s8 dst = get_byte(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel1272: (void)0;
return 10;
}
unsigned long REGPARAM2 op_8140_0(uae_u32 opcode) /* PACK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uae_u16 val = m68k_dreg(regs, srcreg) + get_iword(2);
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & 0xffffff00) | ((val >> 4) & 0xf0) | (val & 0xf);
}m68k_incpc(4);
endlabel1273: (void)0;
return 4;
}
unsigned long REGPARAM2 op_8148_0(uae_u32 opcode) /* PACK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uae_u16 val;
	m68k_areg(regs, srcreg) -= areg_byteinc[srcreg];
	val = (uae_u16)get_byte(m68k_areg(regs, srcreg));
	m68k_areg(regs, srcreg) -= areg_byteinc[srcreg];
	val = (val | ((uae_u16)get_byte(m68k_areg(regs, srcreg)) << 8)) + get_iword(2);
	m68k_areg(regs, dstreg) -= areg_byteinc[dstreg];
	put_byte(m68k_areg(regs, dstreg),((val >> 4) & 0xf0) | (val & 0xf));
}m68k_incpc(4);
endlabel1274: (void)0;
return 4;
}
unsigned long REGPARAM2 op_8150_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 dst = get_word(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel1275: (void)0;
return 6;
}
unsigned long REGPARAM2 op_8158_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 dst = get_word(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel1276: (void)0;
return 6;
}
unsigned long REGPARAM2 op_8160_0(uae_u32 opcode) /* OR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel1277: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_8168_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 dst = get_word(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel1278: (void)0;
return 8;
}
unsigned long REGPARAM2 op_8170_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s16 dst = get_word(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel1279: (void)0;
return 6;
}
unsigned long REGPARAM2 op_8178_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 dst = get_word(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel1280: (void)0;
return 8;
}
unsigned long REGPARAM2 op_8179_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s16 dst = get_word(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel1281: (void)0;
return 10;
}
unsigned long REGPARAM2 op_8180_0(uae_u32 opcode) /* UNPK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uae_u16 val = m68k_dreg(regs, srcreg);
	val = (((val << 4) & 0xf00) | (val & 0xf)) + get_iword(2);
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & 0xffff0000) | (val & 0xffff);
}m68k_incpc(4);
endlabel1282: (void)0;
return 4;
}
unsigned long REGPARAM2 op_8188_0(uae_u32 opcode) /* UNPK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uae_u16 val;
	m68k_areg(regs, srcreg) -= areg_byteinc[srcreg];
	val = (uae_u16)get_byte(m68k_areg(regs, srcreg));
	val = (((val << 4) & 0xf00) | (val & 0xf)) + get_iword(2);
	m68k_areg(regs, dstreg) -= areg_byteinc[dstreg];
	put_byte(m68k_areg(regs, dstreg),val);
	m68k_areg(regs, dstreg) -= areg_byteinc[dstreg];
	put_byte(m68k_areg(regs, dstreg),val >> 8);
}m68k_incpc(4);
endlabel1283: (void)0;
return 4;
}
unsigned long REGPARAM2 op_8190_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel1284: (void)0;
return 10;
}
unsigned long REGPARAM2 op_8198_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel1285: (void)0;
return 10;
}
unsigned long REGPARAM2 op_81a0_0(uae_u32 opcode) /* OR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel1286: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_81a8_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel1287: (void)0;
return 12;
}
unsigned long REGPARAM2 op_81b0_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel1288: (void)0;
return 10;
}
unsigned long REGPARAM2 op_81b8_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel1289: (void)0;
return 12;
}
unsigned long REGPARAM2 op_81b9_0(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s32 dst = get_long(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel1290: (void)0;
return 14;
}
unsigned long REGPARAM2 op_81c0_0(uae_u32 opcode) /* DIVS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel1291; } else {
	uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
	uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
	if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}m68k_incpc(2);
endlabel1291: (void)0;
return 74;
}
unsigned long REGPARAM2 op_81d0_0(uae_u32 opcode) /* DIVS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel1292; } else {
	uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
	uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
	if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(2);
endlabel1292: (void)0;
return 76;
}
unsigned long REGPARAM2 op_81d8_0(uae_u32 opcode) /* DIVS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel1293; } else {
	uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
	uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
	if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(2);
endlabel1293: (void)0;
return 76;
}
unsigned long REGPARAM2 op_81e0_0(uae_u32 opcode) /* DIVS */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel1294; } else {
	uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
	uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
	if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(2);
endlabel1294: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 76;
}
unsigned long REGPARAM2 op_81e8_0(uae_u32 opcode) /* DIVS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel1295; } else {
	uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
	uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
	if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(4);
endlabel1295: (void)0;
return 78;
}
unsigned long REGPARAM2 op_81f0_0(uae_u32 opcode) /* DIVS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel1296; } else {
	uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
	uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
	if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}endlabel1296: (void)0;
return 76;
}
unsigned long REGPARAM2 op_81f8_0(uae_u32 opcode) /* DIVS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	if(src == 0) { Exception(5,oldpc); goto endlabel1297; } else {
	uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
	uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
	if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(4);
endlabel1297: (void)0;
return 78;
}
unsigned long REGPARAM2 op_81f9_0(uae_u32 opcode) /* DIVS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	if(src == 0) { Exception(5,oldpc); goto endlabel1298; } else {
	uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
	uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
	if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(6);
endlabel1298: (void)0;
return 80;
}
unsigned long REGPARAM2 op_81fa_0(uae_u32 opcode) /* DIVS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	if(src == 0) { Exception(5,oldpc); goto endlabel1299; } else {
	uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
	uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
	if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(4);
endlabel1299: (void)0;
return 78;
}
unsigned long REGPARAM2 op_81fb_0(uae_u32 opcode) /* DIVS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel1300; } else {
	uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
	uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
	if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}endlabel1300: (void)0;
return 76;
}
unsigned long REGPARAM2 op_81fc_0(uae_u32 opcode) /* DIVS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
	if(src == 0) { Exception(5,oldpc); goto endlabel1301; } else {
	uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
	uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
	if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}m68k_incpc(4);
endlabel1301: (void)0;
return 76;
}
unsigned long REGPARAM2 op_9000_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}m68k_incpc(2);
endlabel1302: (void)0;
return 2;
}
unsigned long REGPARAM2 op_9010_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(2);
endlabel1303: (void)0;
return 4;
}
unsigned long REGPARAM2 op_9018_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(2);
endlabel1304: (void)0;
return 4;
}
unsigned long REGPARAM2 op_9020_0(uae_u32 opcode) /* SUB */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(2);
endlabel1305: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_9028_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(4);
endlabel1306: (void)0;
return 6;
}
unsigned long REGPARAM2 op_9030_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}endlabel1307: (void)0;
return 4;
}
unsigned long REGPARAM2 op_9038_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(4);
endlabel1308: (void)0;
return 6;
}
unsigned long REGPARAM2 op_9039_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(6);
endlabel1309: (void)0;
return 8;
}
unsigned long REGPARAM2 op_903a_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}}m68k_incpc(4);
endlabel1310: (void)0;
return 6;
}
unsigned long REGPARAM2 op_903b_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}endlabel1311: (void)0;
return 4;
}
unsigned long REGPARAM2 op_903c_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}m68k_incpc(4);
endlabel1312: (void)0;
return 4;
}
unsigned long REGPARAM2 op_9040_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}m68k_incpc(2);
endlabel1313: (void)0;
return 2;
}
unsigned long REGPARAM2 op_9048_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}m68k_incpc(2);
endlabel1314: (void)0;
return 2;
}
unsigned long REGPARAM2 op_9050_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(2);
endlabel1315: (void)0;
return 4;
}
unsigned long REGPARAM2 op_9058_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(2);
endlabel1316: (void)0;
return 4;
}
unsigned long REGPARAM2 op_9060_0(uae_u32 opcode) /* SUB */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(2);
endlabel1317: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_9068_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(4);
endlabel1318: (void)0;
return 6;
}
unsigned long REGPARAM2 op_9070_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}endlabel1319: (void)0;
return 4;
}
unsigned long REGPARAM2 op_9078_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(4);
endlabel1320: (void)0;
return 6;
}
unsigned long REGPARAM2 op_9079_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(6);
endlabel1321: (void)0;
return 8;
}
unsigned long REGPARAM2 op_907a_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(4);
endlabel1322: (void)0;
return 6;
}
unsigned long REGPARAM2 op_907b_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}endlabel1323: (void)0;
return 4;
}
unsigned long REGPARAM2 op_907c_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}m68k_incpc(4);
endlabel1324: (void)0;
return 4;
}
unsigned long REGPARAM2 op_9080_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}m68k_incpc(2);
endlabel1325: (void)0;
return 2;
}
unsigned long REGPARAM2 op_9088_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}m68k_incpc(2);
endlabel1326: (void)0;
return 2;
}
unsigned long REGPARAM2 op_9090_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(2);
endlabel1327: (void)0;
return 6;
}
unsigned long REGPARAM2 op_9098_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(2);
endlabel1328: (void)0;
return 6;
}
unsigned long REGPARAM2 op_90a0_0(uae_u32 opcode) /* SUB */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(2);
endlabel1329: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_90a8_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(4);
endlabel1330: (void)0;
return 8;
}
unsigned long REGPARAM2 op_90b0_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}endlabel1331: (void)0;
return 6;
}
unsigned long REGPARAM2 op_90b8_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(4);
endlabel1332: (void)0;
return 8;
}
unsigned long REGPARAM2 op_90b9_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(6);
endlabel1333: (void)0;
return 10;
}
unsigned long REGPARAM2 op_90ba_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(4);
endlabel1334: (void)0;
return 8;
}
unsigned long REGPARAM2 op_90bb_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}endlabel1335: (void)0;
return 6;
}
unsigned long REGPARAM2 op_90bc_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}m68k_incpc(6);
endlabel1336: (void)0;
return 6;
}
unsigned long REGPARAM2 op_90c0_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}m68k_incpc(2);
endlabel1337: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 2;
}
unsigned long REGPARAM2 op_90c8_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}m68k_incpc(2);
endlabel1338: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 2;
}
unsigned long REGPARAM2 op_90d0_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1339: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_90d8_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1340: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_90e0_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1341: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_90e8_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1342: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_90f0_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}endlabel1343: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_90f8_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1344: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_90f9_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(6);
endlabel1345: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_90fa_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}}m68k_incpc(4);
endlabel1346: (void)0;
return 6;
}
unsigned long REGPARAM2 op_90fb_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}endlabel1347: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_90fc_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_s16 src = get_iword(2);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}m68k_incpc(4);
endlabel1348: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_9100_0(uae_u32 opcode) /* SUBX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = dst - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}m68k_incpc(2);
endlabel1349: (void)0;
return 2;
}
unsigned long REGPARAM2 op_9108_0(uae_u32 opcode) /* SUBX */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{	uae_u32 newv = dst - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1350: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_9110_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1351: (void)0;
return 6;
}
unsigned long REGPARAM2 op_9118_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1352: (void)0;
return 6;
}
unsigned long REGPARAM2 op_9120_0(uae_u32 opcode) /* SUB */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1353: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_9128_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel1354: (void)0;
return 8;
}
unsigned long REGPARAM2 op_9130_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}endlabel1355: (void)0;
return 6;
}
unsigned long REGPARAM2 op_9138_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel1356: (void)0;
return 8;
}
unsigned long REGPARAM2 op_9139_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel1357: (void)0;
return 10;
}
unsigned long REGPARAM2 op_9140_0(uae_u32 opcode) /* SUBX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = dst - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s16)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s16)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}m68k_incpc(2);
endlabel1358: (void)0;
return 2;
}
unsigned long REGPARAM2 op_9148_0(uae_u32 opcode) /* SUBX */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
{	uae_u32 newv = dst - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s16)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s16)(newv)) < 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1359: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_9150_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1360: (void)0;
return 6;
}
unsigned long REGPARAM2 op_9158_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1361: (void)0;
return 6;
}
unsigned long REGPARAM2 op_9160_0(uae_u32 opcode) /* SUB */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1362: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_9168_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel1363: (void)0;
return 8;
}
unsigned long REGPARAM2 op_9170_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}endlabel1364: (void)0;
return 6;
}
unsigned long REGPARAM2 op_9178_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel1365: (void)0;
return 8;
}
unsigned long REGPARAM2 op_9179_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel1366: (void)0;
return 10;
}
unsigned long REGPARAM2 op_9180_0(uae_u32 opcode) /* SUBX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = dst - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s32)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1367: (void)0;
return 2;
}
unsigned long REGPARAM2 op_9188_0(uae_u32 opcode) /* SUBX */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
{	uae_u32 newv = dst - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s32)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s32)(newv)) < 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1368: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 14;
}
unsigned long REGPARAM2 op_9190_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1369: (void)0;
return 10;
}
unsigned long REGPARAM2 op_9198_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1370: (void)0;
return 10;
}
unsigned long REGPARAM2 op_91a0_0(uae_u32 opcode) /* SUB */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1371: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_91a8_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel1372: (void)0;
return 12;
}
unsigned long REGPARAM2 op_91b0_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}endlabel1373: (void)0;
return 10;
}
unsigned long REGPARAM2 op_91b8_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel1374: (void)0;
return 12;
}
unsigned long REGPARAM2 op_91b9_0(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel1375: (void)0;
return 14;
}
unsigned long REGPARAM2 op_91c0_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}m68k_incpc(2);
endlabel1376: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 2;
}
unsigned long REGPARAM2 op_91c8_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}m68k_incpc(2);
endlabel1377: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 2;
}
unsigned long REGPARAM2 op_91d0_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1378: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_91d8_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1379: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_91e0_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1380: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_91e8_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1381: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_91f0_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}endlabel1382: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_91f8_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1383: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_91f9_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(6);
endlabel1384: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_91fa_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}}m68k_incpc(4);
endlabel1385: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_91fb_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}endlabel1386: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_91fc_0(uae_u32 opcode) /* SUBA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}m68k_incpc(6);
endlabel1387: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_b000_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(2);
endlabel1388: (void)0;
return 2;
}
unsigned long REGPARAM2 op_b010_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(2);
endlabel1389: (void)0;
return 4;
}
#endif

#ifdef PART_7
unsigned long REGPARAM2 op_b018_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(2);
endlabel1390: (void)0;
return 4;
}
unsigned long REGPARAM2 op_b020_0(uae_u32 opcode) /* CMP */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(2);
endlabel1391: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_b028_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel1392: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b030_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel1393: (void)0;
return 4;
}
unsigned long REGPARAM2 op_b038_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel1394: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b039_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(6);
endlabel1395: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b03a_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel1396: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b03b_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel1397: (void)0;
return 4;
}
unsigned long REGPARAM2 op_b03c_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(4);
endlabel1398: (void)0;
return 4;
}
unsigned long REGPARAM2 op_b040_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(2);
endlabel1399: (void)0;
return 2;
}
unsigned long REGPARAM2 op_b048_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(2);
endlabel1400: (void)0;
return 2;
}
unsigned long REGPARAM2 op_b050_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(2);
endlabel1401: (void)0;
return 4;
}
unsigned long REGPARAM2 op_b058_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(2);
endlabel1402: (void)0;
return 4;
}
unsigned long REGPARAM2 op_b060_0(uae_u32 opcode) /* CMP */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(2);
endlabel1403: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_b068_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel1404: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b070_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel1405: (void)0;
return 4;
}
unsigned long REGPARAM2 op_b078_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel1406: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b079_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(6);
endlabel1407: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b07a_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel1408: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b07b_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel1409: (void)0;
return 4;
}
unsigned long REGPARAM2 op_b07c_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(4);
endlabel1410: (void)0;
return 4;
}
unsigned long REGPARAM2 op_b080_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(2);
endlabel1411: (void)0;
return 2;
}
unsigned long REGPARAM2 op_b088_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(2);
endlabel1412: (void)0;
return 2;
}
unsigned long REGPARAM2 op_b090_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(2);
endlabel1413: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b098_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(2);
endlabel1414: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b0a0_0(uae_u32 opcode) /* CMP */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(2);
endlabel1415: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_b0a8_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel1416: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b0b0_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel1417: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b0b8_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel1418: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b0b9_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(6);
endlabel1419: (void)0;
return 10;
}
unsigned long REGPARAM2 op_b0ba_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel1420: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b0bb_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel1421: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b0bc_0(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(6);
endlabel1422: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b0c0_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(2);
endlabel1423: (void)0;
return 2;
}
unsigned long REGPARAM2 op_b0c8_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(2);
endlabel1424: (void)0;
return 2;
}
unsigned long REGPARAM2 op_b0d0_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(2);
endlabel1425: (void)0;
return 4;
}
unsigned long REGPARAM2 op_b0d8_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(2);
endlabel1426: (void)0;
return 4;
}
unsigned long REGPARAM2 op_b0e0_0(uae_u32 opcode) /* CMPA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(2);
endlabel1427: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_b0e8_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel1428: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b0f0_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel1429: (void)0;
return 4;
}
unsigned long REGPARAM2 op_b0f8_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel1430: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b0f9_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(6);
endlabel1431: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b0fa_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel1432: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b0fb_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel1433: (void)0;
return 4;
}
unsigned long REGPARAM2 op_b0fc_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(4);
endlabel1434: (void)0;
return 4;
}
unsigned long REGPARAM2 op_b100_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}m68k_incpc(2);
endlabel1435: (void)0;
return 2;
}
unsigned long REGPARAM2 op_b108_0(uae_u32 opcode) /* CMPM */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}}m68k_incpc(2);
endlabel1436: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b110_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel1437: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b118_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel1438: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b120_0(uae_u32 opcode) /* EOR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel1439: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_b128_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel1440: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b130_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel1441: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b138_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel1442: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b139_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s8 dst = get_byte(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel1443: (void)0;
return 10;
}
unsigned long REGPARAM2 op_b140_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}m68k_incpc(2);
endlabel1444: (void)0;
return 2;
}
unsigned long REGPARAM2 op_b148_0(uae_u32 opcode) /* CMPM */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}}m68k_incpc(2);
endlabel1445: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b150_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 dst = get_word(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel1446: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b158_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 dst = get_word(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel1447: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b160_0(uae_u32 opcode) /* EOR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel1448: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_b168_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 dst = get_word(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel1449: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b170_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s16 dst = get_word(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel1450: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b178_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 dst = get_word(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel1451: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b179_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s16 dst = get_word(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel1452: (void)0;
return 10;
}
unsigned long REGPARAM2 op_b180_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}m68k_incpc(2);
endlabel1453: (void)0;
return 2;
}
unsigned long REGPARAM2 op_b188_0(uae_u32 opcode) /* CMPM */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}}m68k_incpc(2);
endlabel1454: (void)0;
return 10;
}
unsigned long REGPARAM2 op_b190_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel1455: (void)0;
return 10;
}
unsigned long REGPARAM2 op_b198_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel1456: (void)0;
return 10;
}
unsigned long REGPARAM2 op_b1a0_0(uae_u32 opcode) /* EOR */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel1457: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_b1a8_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel1458: (void)0;
return 12;
}
unsigned long REGPARAM2 op_b1b0_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel1459: (void)0;
return 10;
}
unsigned long REGPARAM2 op_b1b8_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel1460: (void)0;
return 12;
}
unsigned long REGPARAM2 op_b1b9_0(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s32 dst = get_long(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel1461: (void)0;
return 14;
}
unsigned long REGPARAM2 op_b1c0_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(2);
endlabel1462: (void)0;
return 2;
}
unsigned long REGPARAM2 op_b1c8_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(2);
endlabel1463: (void)0;
return 2;
}
unsigned long REGPARAM2 op_b1d0_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(2);
endlabel1464: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b1d8_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(2);
endlabel1465: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b1e0_0(uae_u32 opcode) /* CMPA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(2);
endlabel1466: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_b1e8_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel1467: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b1f0_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel1468: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b1f8_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel1469: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b1f9_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(6);
endlabel1470: (void)0;
return 10;
}
unsigned long REGPARAM2 op_b1fa_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel1471: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b1fb_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}endlabel1472: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b1fc_0(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(6);
endlabel1473: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c000_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}m68k_incpc(2);
endlabel1474: (void)0;
return 2;
}
unsigned long REGPARAM2 op_c010_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(2);
endlabel1475: (void)0;
return 4;
}
unsigned long REGPARAM2 op_c018_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(2);
endlabel1476: (void)0;
return 4;
}
unsigned long REGPARAM2 op_c020_0(uae_u32 opcode) /* AND */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(2);
endlabel1477: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_c028_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(4);
endlabel1478: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c030_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}endlabel1479: (void)0;
return 4;
}
unsigned long REGPARAM2 op_c038_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(4);
endlabel1480: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c039_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(6);
endlabel1481: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c03a_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(4);
endlabel1482: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c03b_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}endlabel1483: (void)0;
return 4;
}
unsigned long REGPARAM2 op_c03c_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uae_s8 src = get_ibyte(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}m68k_incpc(4);
endlabel1484: (void)0;
return 4;
}
unsigned long REGPARAM2 op_c040_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}m68k_incpc(2);
endlabel1485: (void)0;
return 2;
}
unsigned long REGPARAM2 op_c050_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(2);
endlabel1486: (void)0;
return 4;
}
unsigned long REGPARAM2 op_c058_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(2);
endlabel1487: (void)0;
return 4;
}
unsigned long REGPARAM2 op_c060_0(uae_u32 opcode) /* AND */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(2);
endlabel1488: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_c068_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(4);
endlabel1489: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c070_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}endlabel1490: (void)0;
return 4;
}
unsigned long REGPARAM2 op_c078_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(4);
endlabel1491: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c079_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(6);
endlabel1492: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c07a_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(4);
endlabel1493: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c07b_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}endlabel1494: (void)0;
return 4;
}
unsigned long REGPARAM2 op_c07c_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}m68k_incpc(4);
endlabel1495: (void)0;
return 4;
}
unsigned long REGPARAM2 op_c080_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}m68k_incpc(2);
endlabel1496: (void)0;
return 2;
}
unsigned long REGPARAM2 op_c090_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(2);
endlabel1497: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c098_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(2);
endlabel1498: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c0a0_0(uae_u32 opcode) /* AND */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(2);
endlabel1499: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_c0a8_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(4);
endlabel1500: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c0b0_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}endlabel1501: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c0b8_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(4);
endlabel1502: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c0b9_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(6);
endlabel1503: (void)0;
return 10;
}
unsigned long REGPARAM2 op_c0ba_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(4);
endlabel1504: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c0bb_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}endlabel1505: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c0bc_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}m68k_incpc(6);
endlabel1506: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c0c0_0(uae_u32 opcode) /* MULU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}m68k_incpc(2);
endlabel1507: (void)0;
return 34;
}
unsigned long REGPARAM2 op_c0d0_0(uae_u32 opcode) /* MULU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1508: (void)0;
return 36;
}
unsigned long REGPARAM2 op_c0d8_0(uae_u32 opcode) /* MULU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1509: (void)0;
return 36;
}
unsigned long REGPARAM2 op_c0e0_0(uae_u32 opcode) /* MULU */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1510: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 36;
}
unsigned long REGPARAM2 op_c0e8_0(uae_u32 opcode) /* MULU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1511: (void)0;
return 38;
}
unsigned long REGPARAM2 op_c0f0_0(uae_u32 opcode) /* MULU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}endlabel1512: (void)0;
return 36;
}
unsigned long REGPARAM2 op_c0f8_0(uae_u32 opcode) /* MULU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1513: (void)0;
return 38;
}
unsigned long REGPARAM2 op_c0f9_0(uae_u32 opcode) /* MULU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(6);
endlabel1514: (void)0;
return 40;
}
unsigned long REGPARAM2 op_c0fa_0(uae_u32 opcode) /* MULU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1515: (void)0;
return 38;
}
unsigned long REGPARAM2 op_c0fb_0(uae_u32 opcode) /* MULU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}endlabel1516: (void)0;
return 36;
}
unsigned long REGPARAM2 op_c0fc_0(uae_u32 opcode) /* MULU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}m68k_incpc(4);
endlabel1517: (void)0;
return 36;
}
unsigned long REGPARAM2 op_c100_0(uae_u32 opcode) /* ABCD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uae_u16 newv_lo = (src & 0xF) + (dst & 0xF) + (XFLG ? 1 : 0);
	uae_u16 newv_hi = (src & 0xF0) + (dst & 0xF0);
	uae_u16 newv;
	if (newv_lo > 9) { newv_lo +=6; }
	newv = newv_hi + newv_lo;	CFLG = XFLG = (newv & 0x1F0) > 0x90;
	if (CFLG) newv += 0x60;
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}m68k_incpc(2);
endlabel1518: (void)0;
return 2;
}
unsigned long REGPARAM2 op_c108_0(uae_u32 opcode) /* ABCD */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{	uae_u16 newv_lo = (src & 0xF) + (dst & 0xF) + (XFLG ? 1 : 0);
	uae_u16 newv_hi = (src & 0xF0) + (dst & 0xF0);
	uae_u16 newv;
	if (newv_lo > 9) { newv_lo +=6; }
	newv = newv_hi + newv_lo;	CFLG = XFLG = (newv & 0x1F0) > 0x90;
	if (CFLG) newv += 0x60;
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1519: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_c110_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel1520: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c118_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel1521: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c120_0(uae_u32 opcode) /* AND */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(2);
endlabel1522: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_c128_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel1523: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c130_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}endlabel1524: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c138_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel1525: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c139_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s8 dst = get_byte(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel1526: (void)0;
return 10;
}
unsigned long REGPARAM2 op_c140_0(uae_u32 opcode) /* EXG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	m68k_dreg(regs, srcreg) = (dst);
	m68k_dreg(regs, dstreg) = (src);
}}}m68k_incpc(2);
endlabel1527: (void)0;
return 2;
}
unsigned long REGPARAM2 op_c148_0(uae_u32 opcode) /* EXG */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	uae_s32 dst = m68k_areg(regs, dstreg);
	m68k_areg(regs, srcreg) = (dst);
	m68k_areg(regs, dstreg) = (src);
}}}m68k_incpc(2);
endlabel1528: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (kEXGOpcode, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (kEXGOpcode, oldA7);
return 2;
}
unsigned long REGPARAM2 op_c150_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 dst = get_word(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel1529: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c158_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 dst = get_word(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel1530: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c160_0(uae_u32 opcode) /* AND */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(2);
endlabel1531: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_c168_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 dst = get_word(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel1532: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c170_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s16 dst = get_word(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}endlabel1533: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c178_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 dst = get_word(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel1534: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c179_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s16 dst = get_word(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel1535: (void)0;
return 10;
}
unsigned long REGPARAM2 op_c188_0(uae_u32 opcode) /* EXG */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_areg(regs, dstreg);
	m68k_dreg(regs, srcreg) = (dst);
	m68k_areg(regs, dstreg) = (src);
}}}m68k_incpc(2);
endlabel1536: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (kEXGOpcode, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (kEXGOpcode, oldA7);
return 2;
}
unsigned long REGPARAM2 op_c190_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel1537: (void)0;
return 10;
}
unsigned long REGPARAM2 op_c198_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel1538: (void)0;
return 10;
}
unsigned long REGPARAM2 op_c1a0_0(uae_u32 opcode) /* AND */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(2);
endlabel1539: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_c1a8_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel1540: (void)0;
return 12;
}
unsigned long REGPARAM2 op_c1b0_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}endlabel1541: (void)0;
return 10;
}
unsigned long REGPARAM2 op_c1b8_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel1542: (void)0;
return 12;
}
unsigned long REGPARAM2 op_c1b9_0(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s32 dst = get_long(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel1543: (void)0;
return 14;
}
unsigned long REGPARAM2 op_c1c0_0(uae_u32 opcode) /* MULS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}m68k_incpc(2);
endlabel1544: (void)0;
return 34;
}
unsigned long REGPARAM2 op_c1d0_0(uae_u32 opcode) /* MULS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1545: (void)0;
return 36;
}
unsigned long REGPARAM2 op_c1d8_0(uae_u32 opcode) /* MULS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1546: (void)0;
return 36;
}
unsigned long REGPARAM2 op_c1e0_0(uae_u32 opcode) /* MULS */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1547: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 36;
}
unsigned long REGPARAM2 op_c1e8_0(uae_u32 opcode) /* MULS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1548: (void)0;
return 38;
}
unsigned long REGPARAM2 op_c1f0_0(uae_u32 opcode) /* MULS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}endlabel1549: (void)0;
return 36;
}
unsigned long REGPARAM2 op_c1f8_0(uae_u32 opcode) /* MULS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1550: (void)0;
return 38;
}
unsigned long REGPARAM2 op_c1f9_0(uae_u32 opcode) /* MULS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(6);
endlabel1551: (void)0;
return 40;
}
unsigned long REGPARAM2 op_c1fa_0(uae_u32 opcode) /* MULS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1552: (void)0;
return 38;
}
unsigned long REGPARAM2 op_c1fb_0(uae_u32 opcode) /* MULS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}endlabel1553: (void)0;
return 36;
}
unsigned long REGPARAM2 op_c1fc_0(uae_u32 opcode) /* MULS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}m68k_incpc(4);
endlabel1554: (void)0;
return 36;
}
unsigned long REGPARAM2 op_d000_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}m68k_incpc(2);
endlabel1555: (void)0;
return 2;
}
unsigned long REGPARAM2 op_d010_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(2);
endlabel1556: (void)0;
return 4;
}
unsigned long REGPARAM2 op_d018_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(2);
endlabel1557: (void)0;
return 4;
}
unsigned long REGPARAM2 op_d020_0(uae_u32 opcode) /* ADD */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(2);
endlabel1558: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_d028_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(4);
endlabel1559: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d030_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}endlabel1560: (void)0;
return 4;
}
unsigned long REGPARAM2 op_d038_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(4);
endlabel1561: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d039_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(6);
endlabel1562: (void)0;
return 8;
}
unsigned long REGPARAM2 op_d03a_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(4);
endlabel1563: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d03b_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}endlabel1564: (void)0;
return 4;
}
unsigned long REGPARAM2 op_d03c_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}m68k_incpc(4);
endlabel1565: (void)0;
return 4;
}
unsigned long REGPARAM2 op_d040_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}m68k_incpc(2);
endlabel1566: (void)0;
return 2;
}
unsigned long REGPARAM2 op_d048_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}m68k_incpc(2);
endlabel1567: (void)0;
return 2;
}
unsigned long REGPARAM2 op_d050_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(2);
endlabel1568: (void)0;
return 4;
}
unsigned long REGPARAM2 op_d058_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(2);
endlabel1569: (void)0;
return 4;
}
unsigned long REGPARAM2 op_d060_0(uae_u32 opcode) /* ADD */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(2);
endlabel1570: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_d068_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(4);
endlabel1571: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d070_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}endlabel1572: (void)0;
return 4;
}
unsigned long REGPARAM2 op_d078_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(4);
endlabel1573: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d079_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(6);
endlabel1574: (void)0;
return 8;
}
unsigned long REGPARAM2 op_d07a_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(4);
endlabel1575: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d07b_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}endlabel1576: (void)0;
return 4;
}
unsigned long REGPARAM2 op_d07c_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}m68k_incpc(4);
endlabel1577: (void)0;
return 4;
}
unsigned long REGPARAM2 op_d080_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}m68k_incpc(2);
endlabel1578: (void)0;
return 2;
}
unsigned long REGPARAM2 op_d088_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}m68k_incpc(2);
endlabel1579: (void)0;
return 2;
}
unsigned long REGPARAM2 op_d090_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(2);
endlabel1580: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d098_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(2);
endlabel1581: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d0a0_0(uae_u32 opcode) /* ADD */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(2);
endlabel1582: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_d0a8_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(4);
endlabel1583: (void)0;
return 8;
}
unsigned long REGPARAM2 op_d0b0_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}endlabel1584: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d0b8_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(4);
endlabel1585: (void)0;
return 8;
}
unsigned long REGPARAM2 op_d0b9_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(6);
endlabel1586: (void)0;
return 10;
}
unsigned long REGPARAM2 op_d0ba_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(4);
endlabel1587: (void)0;
return 8;
}
unsigned long REGPARAM2 op_d0bb_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}endlabel1588: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d0bc_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}m68k_incpc(6);
endlabel1589: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d0c0_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}m68k_incpc(2);
endlabel1590: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 2;
}
unsigned long REGPARAM2 op_d0c8_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}m68k_incpc(2);
endlabel1591: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 2;
}
unsigned long REGPARAM2 op_d0d0_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1592: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_d0d8_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1593: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_d0e0_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1594: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_d0e8_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1595: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_d0f0_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}endlabel1596: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_d0f8_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1597: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_d0f9_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(6);
endlabel1598: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_d0fa_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1599: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_d0fb_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}endlabel1600: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_d0fc_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_s16 src = get_iword(2);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}m68k_incpc(4);
endlabel1601: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_d100_0(uae_u32 opcode) /* ADDX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = dst + src + (XFLG ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgo) & (flgo ^ flgn));
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}m68k_incpc(2);
endlabel1602: (void)0;
return 2;
}
unsigned long REGPARAM2 op_d108_0(uae_u32 opcode) /* ADDX */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{	uae_u32 newv = dst + src + (XFLG ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgo) & (flgo ^ flgn));
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1603: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_d110_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1604: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d118_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1605: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d120_0(uae_u32 opcode) /* ADD */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1606: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_d128_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel1607: (void)0;
return 8;
}
unsigned long REGPARAM2 op_d130_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}endlabel1608: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d138_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel1609: (void)0;
return 8;
}
unsigned long REGPARAM2 op_d139_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel1610: (void)0;
return 10;
}
unsigned long REGPARAM2 op_d140_0(uae_u32 opcode) /* ADDX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = dst + src + (XFLG ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgo) & (flgo ^ flgn));
	if (((uae_s16)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s16)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}m68k_incpc(2);
endlabel1611: (void)0;
return 2;
}
unsigned long REGPARAM2 op_d148_0(uae_u32 opcode) /* ADDX */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
{	uae_u32 newv = dst + src + (XFLG ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgo) & (flgo ^ flgn));
	if (((uae_s16)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s16)(newv)) < 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1612: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_d150_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1613: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d158_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1614: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d160_0(uae_u32 opcode) /* ADD */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1615: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_d168_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel1616: (void)0;
return 8;
}
unsigned long REGPARAM2 op_d170_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}endlabel1617: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d178_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel1618: (void)0;
return 8;
}
unsigned long REGPARAM2 op_d179_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel1619: (void)0;
return 10;
}
unsigned long REGPARAM2 op_d180_0(uae_u32 opcode) /* ADDX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = dst + src + (XFLG ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgo) & (flgo ^ flgn));
	if (((uae_s32)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1620: (void)0;
return 2;
}
#endif

#ifdef PART_8
unsigned long REGPARAM2 op_d188_0(uae_u32 opcode) /* ADDX */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
{	uae_u32 newv = dst + src + (XFLG ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgo) & (flgo ^ flgn));
	if (((uae_s32)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s32)(newv)) < 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1621: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 14;
}
unsigned long REGPARAM2 op_d190_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1622: (void)0;
return 10;
}
unsigned long REGPARAM2 op_d198_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1623: (void)0;
return 10;
}
unsigned long REGPARAM2 op_d1a0_0(uae_u32 opcode) /* ADD */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(2);
endlabel1624: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_d1a8_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel1625: (void)0;
return 12;
}
unsigned long REGPARAM2 op_d1b0_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
m68k_incpc(2);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}endlabel1626: (void)0;
return 10;
}
unsigned long REGPARAM2 op_d1b8_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel1627: (void)0;
return 12;
}
unsigned long REGPARAM2 op_d1b9_0(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_ilong(2);
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel1628: (void)0;
return 14;
}
unsigned long REGPARAM2 op_d1c0_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}m68k_incpc(2);
endlabel1629: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 2;
}
unsigned long REGPARAM2 op_d1c8_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}m68k_incpc(2);
endlabel1630: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 2;
}
unsigned long REGPARAM2 op_d1d0_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1631: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_d1d8_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1632: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_d1e0_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(2);
endlabel1633: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_d1e8_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1634: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_d1f0_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr srca = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}endlabel1635: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_d1f8_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1636: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_d1f9_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(6);
endlabel1637: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 10;
}
unsigned long REGPARAM2 op_d1fa_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel1638: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_d1fb_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{m68k_incpc(2);
{	uaecptr tmppc = m68k_getpc();
	uaecptr srca = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}endlabel1639: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_d1fc_0(uae_u32 opcode) /* ADDA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_s32 src = get_ilong(2);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}m68k_incpc(6);
endlabel1640: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_e000_0(uae_u32 opcode) /* ASR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	uae_u32 sign = cmask & val;
	cnt &= 63;
	VFLG = 0;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 8) {
		val = sign ? 0xff : 0;
		CFLG=XFLG= sign ? 1 : 0;
	} else {
		CFLG=XFLG=(val >> (cnt-1)) & 1;
		val >>= cnt;
		if (sign) val |= 0xff << (8 - cnt);
	}}
	NFLG = sign != 0;
	ZFLG = val == 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1641: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e008_0(uae_u32 opcode) /* LSR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 8) {
		CFLG=XFLG = cnt == 8 ? (val & cmask ? 1 : 0) : 0;
		val = 0;
	} else {
		CFLG=XFLG=(val >> (cnt-1)) & 1;
		val >>= cnt;
	}}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1642: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e010_0(uae_u32 opcode) /* ROXR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	uae_u32 carry;
	cnt &= 63;
	for(;cnt;--cnt){
	carry=val&1; val >>= 1;
	if(XFLG) val |= cmask;
	XFLG = carry;
	}
	CFLG = XFLG;
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1643: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e018_0(uae_u32 opcode) /* ROR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {	uae_u32 carry;
	for(;cnt;--cnt){
	carry=val&1; val = val >> 1;
	if(carry) val |= cmask;
	}
	CFLG = carry;
}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1644: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e020_0(uae_u32 opcode) /* ASR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 cnt = m68k_dreg(regs, srcreg);
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	uae_u32 sign = cmask & val;
	cnt &= 63;
	VFLG = 0;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 8) {
		val = sign ? 0xff : 0;
		CFLG=XFLG= sign ? 1 : 0;
	} else {
		CFLG=XFLG=(val >> (cnt-1)) & 1;
		val >>= cnt;
		if (sign) val |= 0xff << (8 - cnt);
	}}
	NFLG = sign != 0;
	ZFLG = val == 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1645: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e028_0(uae_u32 opcode) /* LSR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 cnt = m68k_dreg(regs, srcreg);
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 8) {
		CFLG=XFLG = cnt == 8 ? (val & cmask ? 1 : 0) : 0;
		val = 0;
	} else {
		CFLG=XFLG=(val >> (cnt-1)) & 1;
		val >>= cnt;
	}}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1646: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e030_0(uae_u32 opcode) /* ROXR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 cnt = m68k_dreg(regs, srcreg);
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	uae_u32 carry;
	cnt &= 63;
	for(;cnt;--cnt){
	carry=val&1; val >>= 1;
	if(XFLG) val |= cmask;
	XFLG = carry;
	}
	CFLG = XFLG;
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1647: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e038_0(uae_u32 opcode) /* ROR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 cnt = m68k_dreg(regs, srcreg);
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {	uae_u32 carry;
	for(;cnt;--cnt){
	carry=val&1; val = val >> 1;
	if(carry) val |= cmask;
	}
	CFLG = carry;
}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1648: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e040_0(uae_u32 opcode) /* ASR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	cnt &= 63;
	VFLG = 0;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 16) {
		val = sign ? 0xffff : 0;
		CFLG=XFLG= sign ? 1 : 0;
	} else {
		CFLG=XFLG=(val >> (cnt-1)) & 1;
		val >>= cnt;
		if (sign) val |= 0xffff << (16 - cnt);
	}}
	NFLG = sign != 0;
	ZFLG = val == 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1649: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e048_0(uae_u32 opcode) /* LSR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 16) {
		CFLG=XFLG = cnt == 16 ? (val & cmask ? 1 : 0) : 0;
		val = 0;
	} else {
		CFLG=XFLG=(val >> (cnt-1)) & 1;
		val >>= cnt;
	}}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1650: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e050_0(uae_u32 opcode) /* ROXR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry;
	cnt &= 63;
	for(;cnt;--cnt){
	carry=val&1; val >>= 1;
	if(XFLG) val |= cmask;
	XFLG = carry;
	}
	CFLG = XFLG;
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1651: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e058_0(uae_u32 opcode) /* ROR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {	uae_u32 carry;
	for(;cnt;--cnt){
	carry=val&1; val = val >> 1;
	if(carry) val |= cmask;
	}
	CFLG = carry;
}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1652: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e060_0(uae_u32 opcode) /* ASR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 cnt = m68k_dreg(regs, srcreg);
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	cnt &= 63;
	VFLG = 0;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 16) {
		val = sign ? 0xffff : 0;
		CFLG=XFLG= sign ? 1 : 0;
	} else {
		CFLG=XFLG=(val >> (cnt-1)) & 1;
		val >>= cnt;
		if (sign) val |= 0xffff << (16 - cnt);
	}}
	NFLG = sign != 0;
	ZFLG = val == 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1653: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e068_0(uae_u32 opcode) /* LSR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 cnt = m68k_dreg(regs, srcreg);
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 16) {
		CFLG=XFLG = cnt == 16 ? (val & cmask ? 1 : 0) : 0;
		val = 0;
	} else {
		CFLG=XFLG=(val >> (cnt-1)) & 1;
		val >>= cnt;
	}}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1654: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e070_0(uae_u32 opcode) /* ROXR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 cnt = m68k_dreg(regs, srcreg);
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry;
	cnt &= 63;
	for(;cnt;--cnt){
	carry=val&1; val >>= 1;
	if(XFLG) val |= cmask;
	XFLG = carry;
	}
	CFLG = XFLG;
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1655: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e078_0(uae_u32 opcode) /* ROR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 cnt = m68k_dreg(regs, srcreg);
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {	uae_u32 carry;
	for(;cnt;--cnt){
	carry=val&1; val = val >> 1;
	if(carry) val |= cmask;
	}
	CFLG = carry;
}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1656: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e080_0(uae_u32 opcode) /* ASR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	uae_u32 sign = cmask & val;
	cnt &= 63;
	VFLG = 0;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 32) {
		val = sign ? 0xffffffff : 0;
		CFLG=XFLG= sign ? 1 : 0;
	} else {
		CFLG=XFLG=(val >> (cnt-1)) & 1;
		val >>= cnt;
		if (sign) val |= 0xffffffff << (32 - cnt);
	}}
	NFLG = sign != 0;
	ZFLG = val == 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1657: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e088_0(uae_u32 opcode) /* LSR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 32) {
		CFLG=XFLG = cnt == 32 ? (val & cmask ? 1 : 0) : 0;
		val = 0;
	} else {
		CFLG=XFLG=(val >> (cnt-1)) & 1;
		val >>= cnt;
	}}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1658: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e090_0(uae_u32 opcode) /* ROXR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	uae_u32 carry;
	cnt &= 63;
	for(;cnt;--cnt){
	carry=val&1; val >>= 1;
	if(XFLG) val |= cmask;
	XFLG = carry;
	}
	CFLG = XFLG;
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1659: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e098_0(uae_u32 opcode) /* ROR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {	uae_u32 carry;
	for(;cnt;--cnt){
	carry=val&1; val = val >> 1;
	if(carry) val |= cmask;
	}
	CFLG = carry;
}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1660: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e0a0_0(uae_u32 opcode) /* ASR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 cnt = m68k_dreg(regs, srcreg);
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	uae_u32 sign = cmask & val;
	cnt &= 63;
	VFLG = 0;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 32) {
		val = sign ? 0xffffffff : 0;
		CFLG=XFLG= sign ? 1 : 0;
	} else {
		CFLG=XFLG=(val >> (cnt-1)) & 1;
		val >>= cnt;
		if (sign) val |= 0xffffffff << (32 - cnt);
	}}
	NFLG = sign != 0;
	ZFLG = val == 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1661: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e0a8_0(uae_u32 opcode) /* LSR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 cnt = m68k_dreg(regs, srcreg);
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 32) {
		CFLG=XFLG = cnt == 32 ? (val & cmask ? 1 : 0) : 0;
		val = 0;
	} else {
		CFLG=XFLG=(val >> (cnt-1)) & 1;
		val >>= cnt;
	}}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1662: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e0b0_0(uae_u32 opcode) /* ROXR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 cnt = m68k_dreg(regs, srcreg);
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	uae_u32 carry;
	cnt &= 63;
	for(;cnt;--cnt){
	carry=val&1; val >>= 1;
	if(XFLG) val |= cmask;
	XFLG = carry;
	}
	CFLG = XFLG;
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1663: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e0b8_0(uae_u32 opcode) /* ROR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 cnt = m68k_dreg(regs, srcreg);
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {	uae_u32 carry;
	for(;cnt;--cnt){
	carry=val&1; val = val >> 1;
	if(carry) val |= cmask;
	}
	CFLG = carry;
}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1664: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e0d0_0(uae_u32 opcode) /* ASRW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=val&1; val = (val >> 1) | sign;
	NFLG = sign != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1665: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e0d8_0(uae_u32 opcode) /* ASRW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=val&1; val = (val >> 1) | sign;
	NFLG = sign != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1666: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e0e0_0(uae_u32 opcode) /* ASRW */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = dataa;
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=val&1; val = (val >> 1) | sign;
	NFLG = sign != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1667: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_e0e8_0(uae_u32 opcode) /* ASRW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=val&1; val = (val >> 1) | sign;
	NFLG = sign != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1668: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e0f0_0(uae_u32 opcode) /* ASRW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr dataa = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=val&1; val = (val >> 1) | sign;
	NFLG = sign != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}endlabel1669: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e0f8_0(uae_u32 opcode) /* ASRW */
{
{{	uaecptr dataa = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=val&1; val = (val >> 1) | sign;
	NFLG = sign != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1670: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e0f9_0(uae_u32 opcode) /* ASRW */
{
{{	uaecptr dataa = get_ilong(2);
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=val&1; val = (val >> 1) | sign;
	NFLG = sign != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}m68k_incpc(6);
endlabel1671: (void)0;
return 10;
}
unsigned long REGPARAM2 op_e100_0(uae_u32 opcode) /* ASL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	cnt &= 63;
	VFLG = 0;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 8) {
		VFLG = val != 0;
		CFLG=XFLG = cnt == 8 ? val & 1 : 0;
		val = 0;
	} else {
		uae_u32 mask = (0xff << (7 - cnt)) & 0xff;
		CFLG=XFLG=(val << (cnt-1)) & cmask ? 1 : 0;
		VFLG = (val & mask) != mask && (val & mask) != 0;
		val <<= cnt;
	}}
	NFLG = (val&cmask) != 0;
	ZFLG = val == 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1672: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e108_0(uae_u32 opcode) /* LSL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 8) {
		CFLG=XFLG = cnt == 8 ? val & 1 : 0;
		val = 0;
	} else {
		CFLG=XFLG=(val << (cnt-1)) & cmask ? 1 : 0;
		val <<= cnt;
	}}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1673: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e110_0(uae_u32 opcode) /* ROXL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	uae_u32 carry;
	cnt &= 63;
	for(;cnt;--cnt){
	carry=val&cmask; val <<= 1;
	if(XFLG) val |= 1;
	XFLG = carry != 0;
	}
	CFLG = XFLG;
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1674: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e118_0(uae_u32 opcode) /* ROL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	uae_u32 carry;
	for(;cnt;--cnt){
	carry=val&cmask; val <<= 1;
	if(carry) val |= 1;
	}
	CFLG = carry!=0;
}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1675: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e120_0(uae_u32 opcode) /* ASL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 cnt = m68k_dreg(regs, srcreg);
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	cnt &= 63;
	VFLG = 0;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 8) {
		VFLG = val != 0;
		CFLG=XFLG = cnt == 8 ? val & 1 : 0;
		val = 0;
	} else {
		uae_u32 mask = (0xff << (7 - cnt)) & 0xff;
		CFLG=XFLG=(val << (cnt-1)) & cmask ? 1 : 0;
		VFLG = (val & mask) != mask && (val & mask) != 0;
		val <<= cnt;
	}}
	NFLG = (val&cmask) != 0;
	ZFLG = val == 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1676: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e128_0(uae_u32 opcode) /* LSL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 cnt = m68k_dreg(regs, srcreg);
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 8) {
		CFLG=XFLG = cnt == 8 ? val & 1 : 0;
		val = 0;
	} else {
		CFLG=XFLG=(val << (cnt-1)) & cmask ? 1 : 0;
		val <<= cnt;
	}}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1677: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e130_0(uae_u32 opcode) /* ROXL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 cnt = m68k_dreg(regs, srcreg);
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	uae_u32 carry;
	cnt &= 63;
	for(;cnt;--cnt){
	carry=val&cmask; val <<= 1;
	if(XFLG) val |= 1;
	XFLG = carry != 0;
	}
	CFLG = XFLG;
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1678: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e138_0(uae_u32 opcode) /* ROL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 cnt = m68k_dreg(regs, srcreg);
{	uae_s8 data = m68k_dreg(regs, dstreg);
{	uae_u8 val = data;
	uae_u32 cmask = 0x80;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	uae_u32 carry;
	for(;cnt;--cnt){
	carry=val&cmask; val <<= 1;
	if(carry) val |= 1;
	}
	CFLG = carry!=0;
}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((val) & 0xff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1679: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e140_0(uae_u32 opcode) /* ASL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	cnt &= 63;
	VFLG = 0;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 16) {
		VFLG = val != 0;
		CFLG=XFLG = cnt == 16 ? val & 1 : 0;
		val = 0;
	} else {
		uae_u32 mask = (0xffff << (15 - cnt)) & 0xffff;
		CFLG=XFLG=(val << (cnt-1)) & cmask ? 1 : 0;
		VFLG = (val & mask) != mask && (val & mask) != 0;
		val <<= cnt;
	}}
	NFLG = (val&cmask) != 0;
	ZFLG = val == 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1680: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e148_0(uae_u32 opcode) /* LSL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 16) {
		CFLG=XFLG = cnt == 16 ? val & 1 : 0;
		val = 0;
	} else {
		CFLG=XFLG=(val << (cnt-1)) & cmask ? 1 : 0;
		val <<= cnt;
	}}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1681: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e150_0(uae_u32 opcode) /* ROXL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry;
	cnt &= 63;
	for(;cnt;--cnt){
	carry=val&cmask; val <<= 1;
	if(XFLG) val |= 1;
	XFLG = carry != 0;
	}
	CFLG = XFLG;
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1682: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e158_0(uae_u32 opcode) /* ROL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	uae_u32 carry;
	for(;cnt;--cnt){
	carry=val&cmask; val <<= 1;
	if(carry) val |= 1;
	}
	CFLG = carry!=0;
}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1683: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e160_0(uae_u32 opcode) /* ASL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 cnt = m68k_dreg(regs, srcreg);
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	cnt &= 63;
	VFLG = 0;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 16) {
		VFLG = val != 0;
		CFLG=XFLG = cnt == 16 ? val & 1 : 0;
		val = 0;
	} else {
		uae_u32 mask = (0xffff << (15 - cnt)) & 0xffff;
		CFLG=XFLG=(val << (cnt-1)) & cmask ? 1 : 0;
		VFLG = (val & mask) != mask && (val & mask) != 0;
		val <<= cnt;
	}}
	NFLG = (val&cmask) != 0;
	ZFLG = val == 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1684: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e168_0(uae_u32 opcode) /* LSL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 cnt = m68k_dreg(regs, srcreg);
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 16) {
		CFLG=XFLG = cnt == 16 ? val & 1 : 0;
		val = 0;
	} else {
		CFLG=XFLG=(val << (cnt-1)) & cmask ? 1 : 0;
		val <<= cnt;
	}}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1685: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e170_0(uae_u32 opcode) /* ROXL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 cnt = m68k_dreg(regs, srcreg);
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry;
	cnt &= 63;
	for(;cnt;--cnt){
	carry=val&cmask; val <<= 1;
	if(XFLG) val |= 1;
	XFLG = carry != 0;
	}
	CFLG = XFLG;
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1686: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e178_0(uae_u32 opcode) /* ROL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 cnt = m68k_dreg(regs, srcreg);
{	uae_s16 data = m68k_dreg(regs, dstreg);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	uae_u32 carry;
	for(;cnt;--cnt){
	carry=val&cmask; val <<= 1;
	if(carry) val |= 1;
	}
	CFLG = carry!=0;
}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((val) & 0xffff);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1687: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e180_0(uae_u32 opcode) /* ASL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	cnt &= 63;
	VFLG = 0;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 32) {
		VFLG = val != 0;
		CFLG=XFLG = cnt == 32 ? val & 1 : 0;
		val = 0;
	} else {
		uae_u32 mask = (0xffffffff << (31 - cnt)) & 0xffffffff;
		CFLG=XFLG=(val << (cnt-1)) & cmask ? 1 : 0;
		VFLG = (val & mask) != mask && (val & mask) != 0;
		val <<= cnt;
	}}
	NFLG = (val&cmask) != 0;
	ZFLG = val == 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1688: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e188_0(uae_u32 opcode) /* LSL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 32) {
		CFLG=XFLG = cnt == 32 ? val & 1 : 0;
		val = 0;
	} else {
		CFLG=XFLG=(val << (cnt-1)) & cmask ? 1 : 0;
		val <<= cnt;
	}}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1689: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e190_0(uae_u32 opcode) /* ROXL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	uae_u32 carry;
	cnt &= 63;
	for(;cnt;--cnt){
	carry=val&cmask; val <<= 1;
	if(XFLG) val |= 1;
	XFLG = carry != 0;
	}
	CFLG = XFLG;
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1690: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e198_0(uae_u32 opcode) /* ROL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 cnt = srcreg;
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	uae_u32 carry;
	for(;cnt;--cnt){
	carry=val&cmask; val <<= 1;
	if(carry) val |= 1;
	}
	CFLG = carry!=0;
}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}m68k_incpc(2);
endlabel1691: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e1a0_0(uae_u32 opcode) /* ASL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 cnt = m68k_dreg(regs, srcreg);
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	cnt &= 63;
	VFLG = 0;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 32) {
		VFLG = val != 0;
		CFLG=XFLG = cnt == 32 ? val & 1 : 0;
		val = 0;
	} else {
		uae_u32 mask = (0xffffffff << (31 - cnt)) & 0xffffffff;
		CFLG=XFLG=(val << (cnt-1)) & cmask ? 1 : 0;
		VFLG = (val & mask) != mask && (val & mask) != 0;
		val <<= cnt;
	}}
	NFLG = (val&cmask) != 0;
	ZFLG = val == 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1692: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e1a8_0(uae_u32 opcode) /* LSL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 cnt = m68k_dreg(regs, srcreg);
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	if (cnt >= 32) {
		CFLG=XFLG = cnt == 32 ? val & 1 : 0;
		val = 0;
	} else {
		CFLG=XFLG=(val << (cnt-1)) & cmask ? 1 : 0;
		val <<= cnt;
	}}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1693: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e1b0_0(uae_u32 opcode) /* ROXL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 cnt = m68k_dreg(regs, srcreg);
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	uae_u32 carry;
	cnt &= 63;
	for(;cnt;--cnt){
	carry=val&cmask; val <<= 1;
	if(XFLG) val |= 1;
	XFLG = carry != 0;
	}
	CFLG = XFLG;
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1694: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e1b8_0(uae_u32 opcode) /* ROL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 cnt = m68k_dreg(regs, srcreg);
{	uae_s32 data = m68k_dreg(regs, dstreg);
{	uae_u32 val = data;
	uae_u32 cmask = 0x80000000;
	cnt &= 63;
	if (!cnt) { CFLG = 0; } else {
	uae_u32 carry;
	for(;cnt;--cnt){
	carry=val&cmask; val <<= 1;
	if(carry) val |= 1;
	}
	CFLG = carry!=0;
}
	NFLG = (val & cmask) != 0; ZFLG = val == 0; VFLG = 0;
	m68k_dreg(regs, dstreg) = (val);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2*cnt);
#endif
}}}}m68k_incpc(2);
endlabel1695: (void)0;
return 2;
}
unsigned long REGPARAM2 op_e1d0_0(uae_u32 opcode) /* ASLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=(val&cmask)!=0; val <<= 1;
	if ((val&cmask)!=sign) VFLG=1;
	NFLG = (val&cmask) != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1696: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e1d8_0(uae_u32 opcode) /* ASLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=(val&cmask)!=0; val <<= 1;
	if ((val&cmask)!=sign) VFLG=1;
	NFLG = (val&cmask) != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1697: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e1e0_0(uae_u32 opcode) /* ASLW */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = dataa;
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=(val&cmask)!=0; val <<= 1;
	if ((val&cmask)!=sign) VFLG=1;
	NFLG = (val&cmask) != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1698: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_e1e8_0(uae_u32 opcode) /* ASLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=(val&cmask)!=0; val <<= 1;
	if ((val&cmask)!=sign) VFLG=1;
	NFLG = (val&cmask) != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1699: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e1f0_0(uae_u32 opcode) /* ASLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr dataa = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=(val&cmask)!=0; val <<= 1;
	if ((val&cmask)!=sign) VFLG=1;
	NFLG = (val&cmask) != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}endlabel1700: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e1f8_0(uae_u32 opcode) /* ASLW */
{
{{	uaecptr dataa = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=(val&cmask)!=0; val <<= 1;
	if ((val&cmask)!=sign) VFLG=1;
	NFLG = (val&cmask) != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1701: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e1f9_0(uae_u32 opcode) /* ASLW */
{
{{	uaecptr dataa = get_ilong(2);
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=(val&cmask)!=0; val <<= 1;
	if ((val&cmask)!=sign) VFLG=1;
	NFLG = (val&cmask) != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}m68k_incpc(6);
endlabel1702: (void)0;
return 10;
}
unsigned long REGPARAM2 op_e2d0_0(uae_u32 opcode) /* LSRW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	val >>= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1703: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e2d8_0(uae_u32 opcode) /* LSRW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	val >>= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1704: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e2e0_0(uae_u32 opcode) /* LSRW */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = dataa;
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	val >>= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1705: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_e2e8_0(uae_u32 opcode) /* LSRW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	val >>= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1706: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e2f0_0(uae_u32 opcode) /* LSRW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr dataa = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	val >>= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}endlabel1707: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e2f8_0(uae_u32 opcode) /* LSRW */
{
{{	uaecptr dataa = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	val >>= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1708: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e2f9_0(uae_u32 opcode) /* LSRW */
{
{{	uaecptr dataa = get_ilong(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	val >>= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(6);
endlabel1709: (void)0;
return 10;
}
unsigned long REGPARAM2 op_e3d0_0(uae_u32 opcode) /* LSLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1710: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e3d8_0(uae_u32 opcode) /* LSLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1711: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e3e0_0(uae_u32 opcode) /* LSLW */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = dataa;
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1712: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_e3e8_0(uae_u32 opcode) /* LSLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1713: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e3f0_0(uae_u32 opcode) /* LSLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr dataa = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}endlabel1714: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e3f8_0(uae_u32 opcode) /* LSLW */
{
{{	uaecptr dataa = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1715: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e3f9_0(uae_u32 opcode) /* LSLW */
{
{{	uaecptr dataa = get_ilong(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(6);
endlabel1716: (void)0;
return 10;
}
unsigned long REGPARAM2 op_e4d0_0(uae_u32 opcode) /* ROXRW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(XFLG) val |= cmask;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1717: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e4d8_0(uae_u32 opcode) /* ROXRW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(XFLG) val |= cmask;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1718: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e4e0_0(uae_u32 opcode) /* ROXRW */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = dataa;
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(XFLG) val |= cmask;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1719: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_e4e8_0(uae_u32 opcode) /* ROXRW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(XFLG) val |= cmask;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1720: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e4f0_0(uae_u32 opcode) /* ROXRW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr dataa = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(XFLG) val |= cmask;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}endlabel1721: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e4f8_0(uae_u32 opcode) /* ROXRW */
{
{{	uaecptr dataa = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(XFLG) val |= cmask;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1722: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e4f9_0(uae_u32 opcode) /* ROXRW */
{
{{	uaecptr dataa = get_ilong(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(XFLG) val |= cmask;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(6);
endlabel1723: (void)0;
return 10;
}
unsigned long REGPARAM2 op_e5d0_0(uae_u32 opcode) /* ROXLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(XFLG) val |= 1;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1724: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e5d8_0(uae_u32 opcode) /* ROXLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(XFLG) val |= 1;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1725: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e5e0_0(uae_u32 opcode) /* ROXLW */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = dataa;
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(XFLG) val |= 1;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1726: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_e5e8_0(uae_u32 opcode) /* ROXLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(XFLG) val |= 1;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1727: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e5f0_0(uae_u32 opcode) /* ROXLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr dataa = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(XFLG) val |= 1;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}endlabel1728: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e5f8_0(uae_u32 opcode) /* ROXLW */
{
{{	uaecptr dataa = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(XFLG) val |= 1;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1729: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e5f9_0(uae_u32 opcode) /* ROXLW */
{
{{	uaecptr dataa = get_ilong(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(XFLG) val |= 1;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(6);
endlabel1730: (void)0;
return 10;
}
unsigned long REGPARAM2 op_e6d0_0(uae_u32 opcode) /* RORW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(carry) val |= cmask;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1731: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e6d8_0(uae_u32 opcode) /* RORW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(carry) val |= cmask;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1732: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e6e0_0(uae_u32 opcode) /* RORW */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = dataa;
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(carry) val |= cmask;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1733: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_e6e8_0(uae_u32 opcode) /* RORW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(carry) val |= cmask;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1734: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e6f0_0(uae_u32 opcode) /* RORW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr dataa = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(carry) val |= cmask;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}endlabel1735: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e6f8_0(uae_u32 opcode) /* RORW */
{
{{	uaecptr dataa = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(carry) val |= cmask;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1736: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e6f9_0(uae_u32 opcode) /* RORW */
{
{{	uaecptr dataa = get_ilong(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(carry) val |= cmask;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(6);
endlabel1737: (void)0;
return 10;
}
unsigned long REGPARAM2 op_e7d0_0(uae_u32 opcode) /* ROLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(carry)  val |= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1738: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e7d8_0(uae_u32 opcode) /* ROLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(carry)  val |= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1739: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e7e0_0(uae_u32 opcode) /* ROLW */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = dataa;
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(carry)  val |= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(2);
endlabel1740: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 6;
}
unsigned long REGPARAM2 op_e7e8_0(uae_u32 opcode) /* ROLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(carry)  val |= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1741: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e7f0_0(uae_u32 opcode) /* ROLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{m68k_incpc(2);
{	uaecptr dataa = get_disp_ea_020(m68k_areg(regs, srcreg), next_iword());
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(carry)  val |= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}endlabel1742: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e7f8_0(uae_u32 opcode) /* ROLW */
{
{{	uaecptr dataa = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(carry)  val |= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel1743: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e7f9_0(uae_u32 opcode) /* ROLW */
{
{{	uaecptr dataa = get_ilong(2);
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(carry)  val |= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(6);
endlabel1744: (void)0;
return 10;
}
unsigned long REGPARAM2 op_e8c0_0(uae_u32 opcode) /* BFTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp = m68k_dreg(regs, dstreg) << (offset & 0x1f);
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
}}}}m68k_incpc(4);
endlabel1745: (void)0;
return 4;
}
unsigned long REGPARAM2 op_e8d0_0(uae_u32 opcode) /* BFTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
}}}}m68k_incpc(4);
endlabel1746: (void)0;
return 4;
}
unsigned long REGPARAM2 op_e8e8_0(uae_u32 opcode) /* BFTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
}}}}m68k_incpc(6);
endlabel1747: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e8f0_0(uae_u32 opcode) /* BFTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
}}}}endlabel1748: (void)0;
return 4;
}
unsigned long REGPARAM2 op_e8f8_0(uae_u32 opcode) /* BFTST */
{
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
}}}m68k_incpc(6);
endlabel1749: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e8f9_0(uae_u32 opcode) /* BFTST */
{
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
}}}m68k_incpc(8);
endlabel1750: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e8fa_0(uae_u32 opcode) /* BFTST */
{
	uae_u32 dstreg = 2;
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = m68k_getpc () + 4;
	dsta += (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
}}}m68k_incpc(6);
endlabel1751: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e8fb_0(uae_u32 opcode) /* BFTST */
{
	uae_u32 dstreg = 3;
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
}}}}endlabel1752: (void)0;
return 4;
}
unsigned long REGPARAM2 op_e9c0_0(uae_u32 opcode) /* BFEXTU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp = m68k_dreg(regs, dstreg) << (offset & 0x1f);
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}}m68k_incpc(4);
endlabel1753: (void)0;
return 4;
}
unsigned long REGPARAM2 op_e9d0_0(uae_u32 opcode) /* BFEXTU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}}m68k_incpc(4);
endlabel1754: (void)0;
return 4;
}
unsigned long REGPARAM2 op_e9e8_0(uae_u32 opcode) /* BFEXTU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}}m68k_incpc(6);
endlabel1755: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e9f0_0(uae_u32 opcode) /* BFEXTU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}}endlabel1756: (void)0;
return 4;
}
unsigned long REGPARAM2 op_e9f8_0(uae_u32 opcode) /* BFEXTU */
{
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}m68k_incpc(6);
endlabel1757: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e9f9_0(uae_u32 opcode) /* BFEXTU */
{
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}m68k_incpc(8);
endlabel1758: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e9fa_0(uae_u32 opcode) /* BFEXTU */
{
	uae_u32 dstreg = 2;
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = m68k_getpc () + 4;
	dsta += (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}m68k_incpc(6);
endlabel1759: (void)0;
return 6;
}
unsigned long REGPARAM2 op_e9fb_0(uae_u32 opcode) /* BFEXTU */
{
	uae_u32 dstreg = 3;
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}}endlabel1760: (void)0;
return 4;
}
unsigned long REGPARAM2 op_eac0_0(uae_u32 opcode) /* BFCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp = m68k_dreg(regs, dstreg) << (offset & 0x1f);
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = ~tmp;
	tmp <<= (32 - width);
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ((offset & 0x1f) == 0 ? 0 :
		(0xffffffff << (32 - (offset & 0x1f))))) |
		(tmp >> (offset & 0x1f)) |
		(((offset & 0x1f) + width) >= 32 ? 0 :
 (m68k_dreg(regs, dstreg) & ((uae_u32)0xffffffff >> ((offset & 0x1f) + width))));
}}}}m68k_incpc(4);
endlabel1761: (void)0;
return 4;
}
unsigned long REGPARAM2 op_ead0_0(uae_u32 opcode) /* BFCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = ~tmp;
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}}m68k_incpc(4);
endlabel1762: (void)0;
return 4;
}
unsigned long REGPARAM2 op_eae8_0(uae_u32 opcode) /* BFCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = ~tmp;
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}}m68k_incpc(6);
endlabel1763: (void)0;
return 6;
}
unsigned long REGPARAM2 op_eaf0_0(uae_u32 opcode) /* BFCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = ~tmp;
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}}endlabel1764: (void)0;
return 4;
}
unsigned long REGPARAM2 op_eaf8_0(uae_u32 opcode) /* BFCHG */
{
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = ~tmp;
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}m68k_incpc(6);
endlabel1765: (void)0;
return 6;
}
unsigned long REGPARAM2 op_eaf9_0(uae_u32 opcode) /* BFCHG */
{
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = ~tmp;
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}m68k_incpc(8);
endlabel1766: (void)0;
return 8;
}
unsigned long REGPARAM2 op_ebc0_0(uae_u32 opcode) /* BFEXTS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp = m68k_dreg(regs, dstreg) << (offset & 0x1f);
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	if (NFLG) tmp |= width == 32 ? 0 : (-1 << width);
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}}m68k_incpc(4);
endlabel1767: (void)0;
return 4;
}
unsigned long REGPARAM2 op_ebd0_0(uae_u32 opcode) /* BFEXTS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	if (NFLG) tmp |= width == 32 ? 0 : (-1 << width);
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}}m68k_incpc(4);
endlabel1768: (void)0;
return 4;
}
unsigned long REGPARAM2 op_ebe8_0(uae_u32 opcode) /* BFEXTS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	if (NFLG) tmp |= width == 32 ? 0 : (-1 << width);
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}}m68k_incpc(6);
endlabel1769: (void)0;
return 6;
}
unsigned long REGPARAM2 op_ebf0_0(uae_u32 opcode) /* BFEXTS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	if (NFLG) tmp |= width == 32 ? 0 : (-1 << width);
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}}endlabel1770: (void)0;
return 4;
}
unsigned long REGPARAM2 op_ebf8_0(uae_u32 opcode) /* BFEXTS */
{
{{	uae_s16 extra = get_iword(2);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	if (NFLG) tmp |= width == 32 ? 0 : (-1 << width);
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}}m68k_incpc(6);
endlabel1771: (void)0;
return 6;
}
unsigned long REGPARAM2 op_ebf9_0(uae_u32 opcode) /* BFEXTS */
{
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	if (NFLG) tmp |= width == 32 ? 0 : (-1 << width);
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}m68k_incpc(8);
endlabel1772: (void)0;
return 8;
}
unsigned long REGPARAM2 op_ebfa_0(uae_u32 opcode) /* BFEXTS */
{
	uae_u32 dstreg = 2;
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = m68k_getpc () + 4;
	dsta += (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	if (NFLG) tmp |= width == 32 ? 0 : (-1 << width);
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}m68k_incpc(6);
endlabel1773: (void)0;
return 6;
}
unsigned long REGPARAM2 op_ebfb_0(uae_u32 opcode) /* BFEXTS */
{
	uae_u32 dstreg = 3;
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	if (NFLG) tmp |= width == 32 ? 0 : (-1 << width);
	m68k_dreg(regs, (extra >> 12) & 7) = tmp;
}}}}endlabel1774: (void)0;
return 4;
}
unsigned long REGPARAM2 op_ecc0_0(uae_u32 opcode) /* BFCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp = m68k_dreg(regs, dstreg) << (offset & 0x1f);
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = 0;
	tmp <<= (32 - width);
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ((offset & 0x1f) == 0 ? 0 :
		(0xffffffff << (32 - (offset & 0x1f))))) |
		(tmp >> (offset & 0x1f)) |
		(((offset & 0x1f) + width) >= 32 ? 0 :
 (m68k_dreg(regs, dstreg) & ((uae_u32)0xffffffff >> ((offset & 0x1f) + width))));
}}}}m68k_incpc(4);
endlabel1775: (void)0;
return 4;
}
unsigned long REGPARAM2 op_ecd0_0(uae_u32 opcode) /* BFCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = 0;
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}}m68k_incpc(4);
endlabel1776: (void)0;
return 4;
}
unsigned long REGPARAM2 op_ece8_0(uae_u32 opcode) /* BFCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = 0;
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}}m68k_incpc(6);
endlabel1777: (void)0;
return 6;
}
unsigned long REGPARAM2 op_ecf0_0(uae_u32 opcode) /* BFCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = 0;
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}}endlabel1778: (void)0;
return 4;
}
unsigned long REGPARAM2 op_ecf8_0(uae_u32 opcode) /* BFCLR */
{
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = 0;
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}m68k_incpc(6);
endlabel1779: (void)0;
return 6;
}
unsigned long REGPARAM2 op_ecf9_0(uae_u32 opcode) /* BFCLR */
{
{{	uae_s16 extra = get_iword(2);
{	uaecptr dsta = get_ilong(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = 0;
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}}m68k_incpc(8);
endlabel1780: (void)0;
return 8;
}
unsigned long REGPARAM2 op_edc0_0(uae_u32 opcode) /* BFFFO */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp = m68k_dreg(regs, dstreg) << (offset & 0x1f);
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	{ uae_u32 mask = 1 << (width-1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset++; }}
	m68k_dreg(regs, (extra >> 12) & 7) = offset;
}}}}m68k_incpc(4);
endlabel1781: (void)0;
return 4;
}
unsigned long REGPARAM2 op_edd0_0(uae_u32 opcode) /* BFFFO */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	{ uae_u32 mask = 1 << (width-1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset++; }}
	m68k_dreg(regs, (extra >> 12) & 7) = offset;
}}}}m68k_incpc(4);
endlabel1782: (void)0;
return 4;
}
unsigned long REGPARAM2 op_ede8_0(uae_u32 opcode) /* BFFFO */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	{ uae_u32 mask = 1 << (width-1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset++; }}
	m68k_dreg(regs, (extra >> 12) & 7) = offset;
}}}}m68k_incpc(6);
endlabel1783: (void)0;
return 6;
}
unsigned long REGPARAM2 op_edf0_0(uae_u32 opcode) /* BFFFO */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	{ uae_u32 mask = 1 << (width-1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset++; }}
	m68k_dreg(regs, (extra >> 12) & 7) = offset;
}}}}endlabel1784: (void)0;
return 4;
}
unsigned long REGPARAM2 op_edf8_0(uae_u32 opcode) /* BFFFO */
{
{{	uae_s16 extra = get_iword(2);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	{ uae_u32 mask = 1 << (width-1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset++; }}
	m68k_dreg(regs, (extra >> 12) & 7) = offset;
}}}}m68k_incpc(6);
endlabel1785: (void)0;
return 6;
}
unsigned long REGPARAM2 op_edf9_0(uae_u32 opcode) /* BFFFO */
{
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	{ uae_u32 mask = 1 << (width-1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset++; }}
	m68k_dreg(regs, (extra >> 12) & 7) = offset;
}}}m68k_incpc(8);
endlabel1786: (void)0;
return 8;
}
unsigned long REGPARAM2 op_edfa_0(uae_u32 opcode) /* BFFFO */
{
	uae_u32 dstreg = 2;
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = m68k_getpc () + 4;
	dsta += (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	{ uae_u32 mask = 1 << (width-1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset++; }}
	m68k_dreg(regs, (extra >> 12) & 7) = offset;
}}}m68k_incpc(6);
endlabel1787: (void)0;
return 6;
}
unsigned long REGPARAM2 op_edfb_0(uae_u32 opcode) /* BFFFO */
{
	uae_u32 dstreg = 3;
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr tmppc = m68k_getpc();
	uaecptr dsta = get_disp_ea_020(tmppc, next_iword());
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	{ uae_u32 mask = 1 << (width-1);
	while (mask) { if (tmp & mask) break; mask >>= 1; offset++; }}
	m68k_dreg(regs, (extra >> 12) & 7) = offset;
}}}}endlabel1788: (void)0;
return 4;
}
unsigned long REGPARAM2 op_eec0_0(uae_u32 opcode) /* BFSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp = m68k_dreg(regs, dstreg) << (offset & 0x1f);
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = 0xffffffff;
	tmp <<= (32 - width);
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ((offset & 0x1f) == 0 ? 0 :
		(0xffffffff << (32 - (offset & 0x1f))))) |
		(tmp >> (offset & 0x1f)) |
		(((offset & 0x1f) + width) >= 32 ? 0 :
 (m68k_dreg(regs, dstreg) & ((uae_u32)0xffffffff >> ((offset & 0x1f) + width))));
}}}}m68k_incpc(4);
endlabel1789: (void)0;
return 4;
}
unsigned long REGPARAM2 op_eed0_0(uae_u32 opcode) /* BFSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = 0xffffffff;
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}}m68k_incpc(4);
endlabel1790: (void)0;
return 4;
}
unsigned long REGPARAM2 op_eee8_0(uae_u32 opcode) /* BFSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = 0xffffffff;
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}}m68k_incpc(6);
endlabel1791: (void)0;
return 6;
}
unsigned long REGPARAM2 op_eef0_0(uae_u32 opcode) /* BFSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = 0xffffffff;
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}}endlabel1792: (void)0;
return 4;
}
unsigned long REGPARAM2 op_eef8_0(uae_u32 opcode) /* BFSET */
{
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = 0xffffffff;
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}m68k_incpc(6);
endlabel1793: (void)0;
return 6;
}
unsigned long REGPARAM2 op_eef9_0(uae_u32 opcode) /* BFSET */
{
{{	uae_s16 extra = get_iword(2);
{	uaecptr dsta = get_ilong(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = 0xffffffff;
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}}m68k_incpc(8);
endlabel1794: (void)0;
return 8;
}
unsigned long REGPARAM2 op_efc0_0(uae_u32 opcode) /* BFINS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp = m68k_dreg(regs, dstreg) << (offset & 0x1f);
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = m68k_dreg(regs, (extra >> 12) & 7);
	tmp <<= (32 - width);
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ((offset & 0x1f) == 0 ? 0 :
		(0xffffffff << (32 - (offset & 0x1f))))) |
		(tmp >> (offset & 0x1f)) |
		(((offset & 0x1f) + width) >= 32 ? 0 :
 (m68k_dreg(regs, dstreg) & ((uae_u32)0xffffffff >> ((offset & 0x1f) + width))));
}}}}m68k_incpc(4);
endlabel1795: (void)0;
return 4;
}
unsigned long REGPARAM2 op_efd0_0(uae_u32 opcode) /* BFINS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = m68k_dreg(regs, (extra >> 12) & 7);
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}}m68k_incpc(4);
endlabel1796: (void)0;
return 4;
}
unsigned long REGPARAM2 op_efe8_0(uae_u32 opcode) /* BFINS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uae_s16 extra = get_iword(2);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = m68k_dreg(regs, (extra >> 12) & 7);
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}}m68k_incpc(6);
endlabel1797: (void)0;
return 6;
}
unsigned long REGPARAM2 op_eff0_0(uae_u32 opcode) /* BFINS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
{	uaecptr dsta = get_disp_ea_020(m68k_areg(regs, dstreg), next_iword());
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = m68k_dreg(regs, (extra >> 12) & 7);
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}}endlabel1798: (void)0;
return 4;
}
unsigned long REGPARAM2 op_eff8_0(uae_u32 opcode) /* BFINS */
{
{{	uae_s16 extra = get_iword(2);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = m68k_dreg(regs, (extra >> 12) & 7);
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}}m68k_incpc(6);
endlabel1799: (void)0;
return 6;
}
unsigned long REGPARAM2 op_eff9_0(uae_u32 opcode) /* BFINS */
{
{{	uae_s16 extra = get_iword(2);
	uaecptr dsta = get_ilong(4);
{	uae_s32 offset = extra & 0x800 ? m68k_dreg(regs, (extra >> 6) & 7) : (extra >> 6) & 0x1f;
	int width = (((extra & 0x20 ? m68k_dreg(regs, extra & 7) : extra) -1) & 0x1f) +1;
	uae_u32 tmp,bf0,bf1;
	dsta += (offset >> 3) | (offset & 0x80000000 ? ~0x1fffffff : 0);
	bf0 = get_long(dsta);bf1 = get_byte(dsta+4) & 0xff;
	tmp = (bf0 << (offset & 7)) | (bf1 >> (8 - (offset & 7)));
	tmp >>= (32 - width);
	NFLG = tmp & (1 << (width-1)) ? 1 : 0;ZFLG = tmp == 0;VFLG = 0;CFLG = 0;
	tmp = m68k_dreg(regs, (extra >> 12) & 7);
	tmp <<= (32 - width);
	bf0 = (bf0 & (0xff000000 << (8 - (offset & 7)))) |
		(tmp >> (offset & 7)) |
		(((offset & 7) + width) >= 32 ? 0 :
		 (bf0 & ((uae_u32)0xffffffff >> ((offset & 7) + width))));
	put_long(dsta,bf0 );
	if (((offset & 7) + width) > 32) {
		bf1 = (bf1 & (0xff >> (width - 32 + (offset & 7)))) |
			(tmp << (8 - (offset & 7)));
		put_byte(dsta+4,bf1);
	}
}}}m68k_incpc(8);
endlabel1800: (void)0;
return 8;
}
unsigned long REGPARAM2 op_f200_0(uae_u32 opcode) /* FPP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fpp_opp(opcode,extra);
}}endlabel1801: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f208_0(uae_u32 opcode) /* FPP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fpp_opp(opcode,extra);
}}endlabel1802: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f210_0(uae_u32 opcode) /* FPP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fpp_opp(opcode,extra);
}}endlabel1803: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f218_0(uae_u32 opcode) /* FPP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fpp_opp(opcode,extra);
}}endlabel1804: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f220_0(uae_u32 opcode) /* FPP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fpp_opp(opcode,extra);
}}endlabel1805: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f228_0(uae_u32 opcode) /* FPP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fpp_opp(opcode,extra);
}}endlabel1806: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f230_0(uae_u32 opcode) /* FPP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fpp_opp(opcode,extra);
}}endlabel1807: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f238_0(uae_u32 opcode) /* FPP */
{
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fpp_opp(opcode,extra);
}}endlabel1808: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f239_0(uae_u32 opcode) /* FPP */
{
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fpp_opp(opcode,extra);
}}endlabel1809: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f23a_0(uae_u32 opcode) /* FPP */
{
	uae_u32 dstreg = 2;
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fpp_opp(opcode,extra);
}}endlabel1810: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f23b_0(uae_u32 opcode) /* FPP */
{
	uae_u32 dstreg = 3;
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fpp_opp(opcode,extra);
}}endlabel1811: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f23c_0(uae_u32 opcode) /* FPP */
{
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fpp_opp(opcode,extra);
}}endlabel1812: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f240_0(uae_u32 opcode) /* FScc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fscc_opp(opcode,extra);
}}endlabel1813: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f248_0(uae_u32 opcode) /* FDBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fdbcc_opp(opcode,extra);
}}endlabel1814: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f250_0(uae_u32 opcode) /* FScc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fscc_opp(opcode,extra);
}}endlabel1815: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f258_0(uae_u32 opcode) /* FScc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fscc_opp(opcode,extra);
}}endlabel1816: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f260_0(uae_u32 opcode) /* FScc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fscc_opp(opcode,extra);
}}endlabel1817: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f268_0(uae_u32 opcode) /* FScc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fscc_opp(opcode,extra);
}}endlabel1818: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f270_0(uae_u32 opcode) /* FScc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fscc_opp(opcode,extra);
}}endlabel1819: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f278_0(uae_u32 opcode) /* FScc */
{
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fscc_opp(opcode,extra);
}}endlabel1820: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f279_0(uae_u32 opcode) /* FScc */
{
{{	uae_s16 extra = get_iword(2);
m68k_incpc(4);
	fscc_opp(opcode,extra);
}}endlabel1821: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f27a_0(uae_u32 opcode) /* FTRAPcc */
{
{m68k_incpc(2);
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 dummy = get_iword(0);
m68k_incpc(2);
	ftrapcc_opp(opcode,oldpc);
}}}endlabel1822: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f27b_0(uae_u32 opcode) /* FTRAPcc */
{
{m68k_incpc(2);
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dummy = get_ilong(0);
m68k_incpc(4);
	ftrapcc_opp(opcode,oldpc);
}}}endlabel1823: (void)0;
return 6;
}
unsigned long REGPARAM2 op_f27c_0(uae_u32 opcode) /* FTRAPcc */
{
{m68k_incpc(2);
{	uaecptr oldpc = m68k_getpc();
	ftrapcc_opp(opcode,oldpc);
}}endlabel1824: (void)0;
return 2;
}
unsigned long REGPARAM2 op_f280_0(uae_u32 opcode) /* FBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 63);
#else
	uae_u32 srcreg = (opcode & 63);
#endif
{m68k_incpc(2);
{	uaecptr pc = m68k_getpc();
{	uae_s16 extra = get_iword(0);
m68k_incpc(2);
	fbcc_opp(opcode,pc,extra);
}}}endlabel1825: (void)0;
return 4;
}
unsigned long REGPARAM2 op_f2c0_0(uae_u32 opcode) /* FBcc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 63);
#else
	uae_u32 srcreg = (opcode & 63);
#endif
{m68k_incpc(2);
{	uaecptr pc = m68k_getpc();
{	uae_s32 extra = get_ilong(0);
m68k_incpc(4);
	fbcc_opp(opcode,pc,extra);
}}}endlabel1826: (void)0;
return 6;
}
unsigned long REGPARAM2 op_f310_0(uae_u32 opcode) /* FSAVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel1827; }
{m68k_incpc(2);
	fsave_opp(opcode);
}}endlabel1827: (void)0;
return 2;
}
unsigned long REGPARAM2 op_f320_0(uae_u32 opcode) /* FSAVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel1828; }
{m68k_incpc(2);
	fsave_opp(opcode);
}}endlabel1828: (void)0;
return 2;
}
unsigned long REGPARAM2 op_f328_0(uae_u32 opcode) /* FSAVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel1829; }
{m68k_incpc(2);
	fsave_opp(opcode);
}}endlabel1829: (void)0;
return 2;
}
unsigned long REGPARAM2 op_f330_0(uae_u32 opcode) /* FSAVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel1830; }
{m68k_incpc(2);
	fsave_opp(opcode);
}}endlabel1830: (void)0;
return 2;
}
unsigned long REGPARAM2 op_f338_0(uae_u32 opcode) /* FSAVE */
{
{if (!regs.s) { Exception(8,0); goto endlabel1831; }
{m68k_incpc(2);
	fsave_opp(opcode);
}}endlabel1831: (void)0;
return 2;
}
unsigned long REGPARAM2 op_f339_0(uae_u32 opcode) /* FSAVE */
{
{if (!regs.s) { Exception(8,0); goto endlabel1832; }
{m68k_incpc(2);
	fsave_opp(opcode);
}}endlabel1832: (void)0;
return 2;
}
unsigned long REGPARAM2 op_f350_0(uae_u32 opcode) /* FRESTORE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel1833; }
{m68k_incpc(2);
	frestore_opp(opcode);
}}endlabel1833: (void)0;
return 2;
}
unsigned long REGPARAM2 op_f358_0(uae_u32 opcode) /* FRESTORE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel1834; }
{m68k_incpc(2);
	frestore_opp(opcode);
}}endlabel1834: (void)0;
return 2;
}
unsigned long REGPARAM2 op_f368_0(uae_u32 opcode) /* FRESTORE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel1835; }
{m68k_incpc(2);
	frestore_opp(opcode);
}}endlabel1835: (void)0;
return 2;
}
unsigned long REGPARAM2 op_f370_0(uae_u32 opcode) /* FRESTORE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel1836; }
{m68k_incpc(2);
	frestore_opp(opcode);
}}endlabel1836: (void)0;
return 2;
}
unsigned long REGPARAM2 op_f378_0(uae_u32 opcode) /* FRESTORE */
{
{if (!regs.s) { Exception(8,0); goto endlabel1837; }
{m68k_incpc(2);
	frestore_opp(opcode);
}}endlabel1837: (void)0;
return 2;
}
unsigned long REGPARAM2 op_f379_0(uae_u32 opcode) /* FRESTORE */
{
{if (!regs.s) { Exception(8,0); goto endlabel1838; }
{m68k_incpc(2);
	frestore_opp(opcode);
}}endlabel1838: (void)0;
return 2;
}
unsigned long REGPARAM2 op_f37a_0(uae_u32 opcode) /* FRESTORE */
{
{if (!regs.s) { Exception(8,0); goto endlabel1839; }
{m68k_incpc(2);
	frestore_opp(opcode);
}}endlabel1839: (void)0;
return 2;
}
unsigned long REGPARAM2 op_f37b_0(uae_u32 opcode) /* FRESTORE */
{
{if (!regs.s) { Exception(8,0); goto endlabel1840; }
{m68k_incpc(2);
	frestore_opp(opcode);
}}endlabel1840: (void)0;
return 2;
}
#endif


#if !defined(PART_1) && !defined(PART_2) && !defined(PART_3) && !defined(PART_4) && !defined(PART_5) && !defined(PART_6) && !defined(PART_7) && !defined(PART_8)
#define PART_1 1
#define PART_2 1
#define PART_3 1
#define PART_4 1
#define PART_5 1
#define PART_6 1
#define PART_7 1
#define PART_8 1
#endif

#ifdef PART_1
#endif

#ifdef PART_2
#endif

#ifdef PART_3
#endif

#ifdef PART_4
#endif

#ifdef PART_5
#endif

#ifdef PART_6
#endif

#ifdef PART_7
#endif

#ifdef PART_8
#endif


#if !defined(PART_1) && !defined(PART_2) && !defined(PART_3) && !defined(PART_4) && !defined(PART_5) && !defined(PART_6) && !defined(PART_7) && !defined(PART_8)
#define PART_1 1
#define PART_2 1
#define PART_3 1
#define PART_4 1
#define PART_5 1
#define PART_6 1
#define PART_7 1
#define PART_8 1
#endif

#ifdef PART_1
unsigned long REGPARAM2 op_30_2(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel1841: (void)0;
return 10;
}
unsigned long REGPARAM2 op_70_2(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel1842: (void)0;
return 10;
}
unsigned long REGPARAM2 op_b0_2(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(6));
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(8);
endlabel1843: (void)0;
return 16;
}
unsigned long REGPARAM2 op_130_2(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}m68k_incpc(4);
endlabel1844: (void)0;
return 6;
}
unsigned long REGPARAM2 op_13b_2(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
	uae_u32 dstreg = 3;
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr tmppc = m68k_getpc() + 2;
{	uaecptr dsta = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}}m68k_incpc(4);
endlabel1845: (void)0;
return 6;
}
unsigned long REGPARAM2 op_170_2(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel1846: (void)0;
return 8;
}
unsigned long REGPARAM2 op_17b_2(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
	uae_u32 dstreg = 3;
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr tmppc = m68k_getpc() + 2;
{	uaecptr dsta = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}}m68k_incpc(4);
endlabel1847: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1b0_2(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel1848: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1bb_2(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
	uae_u32 dstreg = 3;
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr tmppc = m68k_getpc() + 2;
{	uaecptr dsta = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}}m68k_incpc(4);
endlabel1849: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1f0_2(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(4);
endlabel1850: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1fb_2(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
	uae_u32 dstreg = 3;
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr tmppc = m68k_getpc() + 2;
{	uaecptr dsta = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}}m68k_incpc(4);
endlabel1851: (void)0;
return 8;
}
unsigned long REGPARAM2 op_230_2(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel1852: (void)0;
return 10;
}
unsigned long REGPARAM2 op_270_2(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel1853: (void)0;
return 10;
}
unsigned long REGPARAM2 op_2b0_2(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(6));
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(8);
endlabel1854: (void)0;
return 16;
}
unsigned long REGPARAM2 op_430_2(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel1855: (void)0;
return 10;
}
unsigned long REGPARAM2 op_470_2(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel1856: (void)0;
return 10;
}
unsigned long REGPARAM2 op_4b0_2(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(6));
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(8);
endlabel1857: (void)0;
return 16;
}
unsigned long REGPARAM2 op_630_2(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel1858: (void)0;
return 10;
}
unsigned long REGPARAM2 op_670_2(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(6);
endlabel1859: (void)0;
return 10;
}
unsigned long REGPARAM2 op_6b0_2(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(6));
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(8);
endlabel1860: (void)0;
return 16;
}
unsigned long REGPARAM2 op_830_2(uae_u32 opcode) /* BTST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}}m68k_incpc(6);
endlabel1861: (void)0;
return 8;
}
unsigned long REGPARAM2 op_83b_2(uae_u32 opcode) /* BTST */
{
	uae_u32 dstreg = 3;
{{	uae_s16 src = get_iword(2);
	uaecptr tmppc = m68k_getpc() + 4;
	uaecptr dsta = get_disp_ea_000(tmppc, get_iword(4));
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
}}}m68k_incpc(6);
endlabel1862: (void)0;
return 8;
}
unsigned long REGPARAM2 op_870_2(uae_u32 opcode) /* BCHG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(6);
endlabel1863: (void)0;
return 10;
}
unsigned long REGPARAM2 op_87b_2(uae_u32 opcode) /* BCHG */
{
	uae_u32 dstreg = 3;
{{	uae_s16 src = get_iword(2);
	uaecptr tmppc = m68k_getpc() + 4;
	uaecptr dsta = get_disp_ea_000(tmppc, get_iword(4));
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst ^= (1 << src);
	put_byte(dsta,dst);
}}}m68k_incpc(6);
endlabel1864: (void)0;
return 10;
}
unsigned long REGPARAM2 op_8b0_2(uae_u32 opcode) /* BCLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(6);
endlabel1865: (void)0;
return 10;
}
unsigned long REGPARAM2 op_8bb_2(uae_u32 opcode) /* BCLR */
{
	uae_u32 dstreg = 3;
{{	uae_s16 src = get_iword(2);
	uaecptr tmppc = m68k_getpc() + 4;
	uaecptr dsta = get_disp_ea_000(tmppc, get_iword(4));
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst &= ~(1 << src);
	put_byte(dsta,dst);
}}}m68k_incpc(6);
endlabel1866: (void)0;
return 10;
}
unsigned long REGPARAM2 op_8f0_2(uae_u32 opcode) /* BSET */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s8 dst = get_byte(dsta);
{	uae_s16 src = get_iword(2);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}}m68k_incpc(6);
endlabel1867: (void)0;
return 10;
}
unsigned long REGPARAM2 op_8fb_2(uae_u32 opcode) /* BSET */
{
	uae_u32 dstreg = 3;
{{	uae_s16 src = get_iword(2);
	uaecptr tmppc = m68k_getpc() + 4;
	uaecptr dsta = get_disp_ea_000(tmppc, get_iword(4));
{	uae_s8 dst = get_byte(dsta);
	src &= 7;
	ZFLG = !(dst & (1 << src));
	dst |= (1 << src);
	put_byte(dsta,dst);
}}}m68k_incpc(6);
endlabel1868: (void)0;
return 10;
}
unsigned long REGPARAM2 op_a30_2(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel1869: (void)0;
return 10;
}
unsigned long REGPARAM2 op_a70_2(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel1870: (void)0;
return 10;
}
#endif

#ifdef PART_2
unsigned long REGPARAM2 op_ab0_2(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(6));
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(8);
endlabel1871: (void)0;
return 16;
}
unsigned long REGPARAM2 op_c30_2(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s8 dst = get_byte(dsta);
{	uae_s8 src = get_ibyte(2);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(6);
endlabel1872: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c3b_2(uae_u32 opcode) /* CMP */
{
	uae_u32 dstreg = 3;
{{	uae_s8 src = get_ibyte(2);
	uaecptr tmppc = m68k_getpc() + 4;
	uaecptr dsta = get_disp_ea_000(tmppc, get_iword(4));
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(6);
endlabel1873: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c70_2(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s16 dst = get_word(dsta);
{	uae_s16 src = get_iword(2);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(6);
endlabel1874: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c7b_2(uae_u32 opcode) /* CMP */
{
	uae_u32 dstreg = 3;
{{	uae_s16 src = get_iword(2);
	uaecptr tmppc = m68k_getpc() + 4;
	uaecptr dsta = get_disp_ea_000(tmppc, get_iword(4));
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(6);
endlabel1875: (void)0;
return 8;
}
unsigned long REGPARAM2 op_cb0_2(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(6));
{	uae_s32 dst = get_long(dsta);
{	uae_s32 src = get_ilong(2);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(8);
endlabel1876: (void)0;
return 12;
}
unsigned long REGPARAM2 op_cbb_2(uae_u32 opcode) /* CMP */
{
	uae_u32 dstreg = 3;
{{	uae_s32 src = get_ilong(2);
	uaecptr tmppc = m68k_getpc() + 6;
	uaecptr dsta = get_disp_ea_000(tmppc, get_iword(6));
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}m68k_incpc(8);
endlabel1877: (void)0;
return 12;
}
unsigned long REGPARAM2 op_1030_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(4);
endlabel1878: (void)0;
return 6;
}
unsigned long REGPARAM2 op_103b_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(4);
endlabel1879: (void)0;
return 6;
}
unsigned long REGPARAM2 op_10b0_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel1880: (void)0;
return 8;
}
unsigned long REGPARAM2 op_10bb_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel1881: (void)0;
return 8;
}
unsigned long REGPARAM2 op_10f0_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel1882: (void)0;
return 8;
}
unsigned long REGPARAM2 op_10fb_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += areg_byteinc[dstreg];
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel1883: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1130_2(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel1884: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_113b_2(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - areg_byteinc[dstreg];
	m68k_areg (regs, dstreg) = dsta;
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel1885: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_1170_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel1886: (void)0;
return 10;
}
unsigned long REGPARAM2 op_117b_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel1887: (void)0;
return 10;
}
unsigned long REGPARAM2 op_1180_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(4);
endlabel1888: (void)0;
return 6;
}
unsigned long REGPARAM2 op_1190_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel1889: (void)0;
return 8;
}
unsigned long REGPARAM2 op_1198_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += areg_byteinc[srcreg];
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel1890: (void)0;
return 8;
}
unsigned long REGPARAM2 op_11a0_2(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - areg_byteinc[srcreg];
	m68k_areg (regs, srcreg) = srca;
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel1891: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_11a8_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel1892: (void)0;
return 10;
}
unsigned long REGPARAM2 op_11b0_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel1893: (void)0;
return 10;
}
unsigned long REGPARAM2 op_11b8_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel1894: (void)0;
return 10;
}
unsigned long REGPARAM2 op_11b9_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(6));
{	uaecptr srca = get_ilong(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(8);
endlabel1895: (void)0;
return 12;
}
unsigned long REGPARAM2 op_11ba_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}}m68k_incpc(6);
endlabel1896: (void)0;
return 10;
}
unsigned long REGPARAM2 op_11bb_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel1897: (void)0;
return 10;
}
unsigned long REGPARAM2 op_11bc_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s8 src = get_ibyte(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(6);
endlabel1898: (void)0;
return 8;
}
unsigned long REGPARAM2 op_11f0_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(6);
endlabel1899: (void)0;
return 10;
}
unsigned long REGPARAM2 op_11fb_2(uae_u32 opcode) /* MOVE */
{
{{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 src = get_byte(srca);
	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(6);
endlabel1900: (void)0;
return 10;
}
unsigned long REGPARAM2 op_13f0_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(8);
endlabel1901: (void)0;
return 12;
}
unsigned long REGPARAM2 op_13fb_2(uae_u32 opcode) /* MOVE */
{
{{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 src = get_byte(srca);
	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}m68k_incpc(8);
endlabel1902: (void)0;
return 12;
}
unsigned long REGPARAM2 op_2030_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(4);
endlabel1903: (void)0;
return 8;
}
unsigned long REGPARAM2 op_203b_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(4);
endlabel1904: (void)0;
return 8;
}
unsigned long REGPARAM2 op_2070_2(uae_u32 opcode) /* MOVEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uae_u32 val = src;
	m68k_areg(regs, dstreg) = (val);
}}}}m68k_incpc(4);
endlabel1905: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (kMoveAOpcode, oldA7);
return 8;
}
unsigned long REGPARAM2 op_207b_2(uae_u32 opcode) /* MOVEA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr tmppc = m68k_getpc() + 2;
{	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
	uae_u32 val = src;
	m68k_areg(regs, dstreg) = (val);
}}}}}m68k_incpc(4);
endlabel1906: (void)0;
return 8;
}
unsigned long REGPARAM2 op_20b0_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel1907: (void)0;
return 12;
}
unsigned long REGPARAM2 op_20bb_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel1908: (void)0;
return 12;
}
unsigned long REGPARAM2 op_20f0_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel1909: (void)0;
return 12;
}
unsigned long REGPARAM2 op_20fb_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 4;
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel1910: (void)0;
return 12;
}
unsigned long REGPARAM2 op_2130_2(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel1911: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 12;
}
unsigned long REGPARAM2 op_213b_2(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 4;
	m68k_areg (regs, dstreg) = dsta;
{	uaecptr tmppc = m68k_getpc() + 2;
{	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}}m68k_incpc(4);
endlabel1912: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 12;
}
#endif

#ifdef PART_3
unsigned long REGPARAM2 op_2170_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel1913: (void)0;
return 14;
}
unsigned long REGPARAM2 op_217b_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel1914: (void)0;
return 14;
}
unsigned long REGPARAM2 op_2180_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(4);
endlabel1915: (void)0;
return 8;
}
unsigned long REGPARAM2 op_2188_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 src = m68k_areg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(4);
endlabel1916: (void)0;
return 8;
}
unsigned long REGPARAM2 op_2190_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel1917: (void)0;
return 12;
}
unsigned long REGPARAM2 op_2198_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 4;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel1918: (void)0;
return 12;
}
unsigned long REGPARAM2 op_21a0_2(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 4;
	m68k_areg (regs, srcreg) = srca;
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel1919: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 12;
}
unsigned long REGPARAM2 op_21a8_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel1920: (void)0;
return 14;
}
unsigned long REGPARAM2 op_21b0_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel1921: (void)0;
return 14;
}
unsigned long REGPARAM2 op_21b8_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel1922: (void)0;
return 14;
}
unsigned long REGPARAM2 op_21b9_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(6));
{	uaecptr srca = get_ilong(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(8);
endlabel1923: (void)0;
return 16;
}
unsigned long REGPARAM2 op_21ba_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uaecptr srca = m68k_getpc () + 2;
{	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}}m68k_incpc(6);
endlabel1924: (void)0;
return 14;
}
unsigned long REGPARAM2 op_21bb_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel1925: (void)0;
return 14;
}
unsigned long REGPARAM2 op_21bc_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(6));
{	uae_s32 src = get_ilong(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}m68k_incpc(8);
endlabel1926: (void)0;
return 12;
}
unsigned long REGPARAM2 op_21f0_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel1927: (void)0;
return 14;
}
unsigned long REGPARAM2 op_21fb_2(uae_u32 opcode) /* MOVE */
{
{{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(6);
endlabel1928: (void)0;
return 14;
}
unsigned long REGPARAM2 op_23f0_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(8);
endlabel1929: (void)0;
return 16;
}
unsigned long REGPARAM2 op_23fb_2(uae_u32 opcode) /* MOVE */
{
{{	uaecptr tmppc = m68k_getpc() + 2;
{	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(8);
endlabel1930: (void)0;
return 16;
}
unsigned long REGPARAM2 op_3030_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(4);
endlabel1931: (void)0;
return 6;
}
unsigned long REGPARAM2 op_303b_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(4);
endlabel1932: (void)0;
return 6;
}
unsigned long REGPARAM2 op_3070_2(uae_u32 opcode) /* MOVEA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_u32 val = (uae_s32)(uae_s16)src;
	m68k_areg(regs, dstreg) = (val);
}}}}m68k_incpc(4);
endlabel1933: (void)0;
return 6;
}
unsigned long REGPARAM2 op_307b_2(uae_u32 opcode) /* MOVEA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr tmppc = m68k_getpc() + 2;
{	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	uae_u32 val = (uae_s32)(uae_s16)src;
	m68k_areg(regs, dstreg) = (val);
}}}}}m68k_incpc(4);
endlabel1934: (void)0;
return 6;
}
unsigned long REGPARAM2 op_30b0_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel1935: (void)0;
return 8;
}
unsigned long REGPARAM2 op_30bb_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel1936: (void)0;
return 8;
}
unsigned long REGPARAM2 op_30f0_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel1937: (void)0;
return 8;
}
unsigned long REGPARAM2 op_30fb_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg);
	m68k_areg(regs, dstreg) += 2;
{	uaecptr tmppc = m68k_getpc() + 2;
{	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}}m68k_incpc(4);
endlabel1938: (void)0;
return 8;
}
unsigned long REGPARAM2 op_3130_2(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel1939: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_313b_2(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) - 2;
	m68k_areg (regs, dstreg) = dsta;
{	uaecptr tmppc = m68k_getpc() + 2;
{	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}}m68k_incpc(4);
endlabel1940: (void)0;
	if (dstreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_3170_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel1941: (void)0;
return 10;
}
unsigned long REGPARAM2 op_317b_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = m68k_areg(regs, dstreg) + (uae_s32)(uae_s16)get_iword(4);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel1942: (void)0;
return 10;
}
unsigned long REGPARAM2 op_3180_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(4);
endlabel1943: (void)0;
return 6;
}
unsigned long REGPARAM2 op_3188_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 src = m68k_areg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(4);
endlabel1944: (void)0;
return 6;
}
unsigned long REGPARAM2 op_3190_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel1945: (void)0;
return 8;
}
unsigned long REGPARAM2 op_3198_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel1946: (void)0;
return 8;
}
unsigned long REGPARAM2 op_31a0_2(uae_u32 opcode) /* MOVE */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel1947: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_31a8_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel1948: (void)0;
return 10;
}
unsigned long REGPARAM2 op_31b0_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel1949: (void)0;
return 10;
}
unsigned long REGPARAM2 op_31b8_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel1950: (void)0;
return 10;
}
unsigned long REGPARAM2 op_31b9_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(6));
{	uaecptr srca = get_ilong(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(8);
endlabel1951: (void)0;
return 12;
}
unsigned long REGPARAM2 op_31ba_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uaecptr srca = m68k_getpc () + 2;
	srca += (uae_s32)(uae_s16)get_iword(2);
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel1952: (void)0;
return 10;
}
unsigned long REGPARAM2 op_31bb_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel1953: (void)0;
return 10;
}
unsigned long REGPARAM2 op_31bc_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_s16 src = get_iword(2);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}m68k_incpc(6);
endlabel1954: (void)0;
return 8;
}
unsigned long REGPARAM2 op_31f0_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(6);
endlabel1955: (void)0;
return 10;
}
unsigned long REGPARAM2 op_31fb_2(uae_u32 opcode) /* MOVE */
{
{{	uaecptr tmppc = m68k_getpc() + 2;
{	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = (uae_s32)(uae_s16)get_iword(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}}m68k_incpc(6);
endlabel1956: (void)0;
return 10;
}
unsigned long REGPARAM2 op_33f0_2(uae_u32 opcode) /* MOVE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(8);
endlabel1957: (void)0;
return 12;
}
unsigned long REGPARAM2 op_33fb_2(uae_u32 opcode) /* MOVE */
{
{{	uaecptr tmppc = m68k_getpc() + 2;
{	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	uaecptr dsta = get_ilong(4);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(8);
endlabel1958: (void)0;
return 12;
}
unsigned long REGPARAM2 op_4030_2(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}}m68k_incpc(4);
endlabel1959: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4070_2(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s16)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s16)(newv)) < 0;
	put_word(srca,newv);
}}}}}m68k_incpc(4);
endlabel1960: (void)0;
return 8;
}
unsigned long REGPARAM2 op_40b0_2(uae_u32 opcode) /* NEGX */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = 0 - src - (XFLG ? 1 : 0);
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	VFLG = (flgs ^ flgo) & (flgo ^ flgn);
	XFLG = CFLG = flgs ^ ((flgs ^ flgn) & (flgo ^ flgn));
	if (((uae_s32)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s32)(newv)) < 0;
	put_long(srca,newv);
}}}}}m68k_incpc(4);
endlabel1961: (void)0;
return 12;
}
unsigned long REGPARAM2 op_40f0_2(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel1962; }
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
	MakeSR();
	put_word(srca,regs.sr);
}}}m68k_incpc(4);
endlabel1962: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4130_2(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel1963; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel1963; }
}}}}m68k_incpc(4);
endlabel1963: (void)0;
return 8;
}
unsigned long REGPARAM2 op_413b_2(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel1964; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel1964; }
}}}}m68k_incpc(4);
endlabel1964: (void)0;
return 8;
}
unsigned long REGPARAM2 op_41b0_2(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel1965; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel1965; }
}}}}m68k_incpc(4);
endlabel1965: (void)0;
return 6;
}
unsigned long REGPARAM2 op_41bb_2(uae_u32 opcode) /* CHK */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	if ((uae_s32)dst < 0) { NFLG=1; Exception(6,oldpc); goto endlabel1966; }
	else if (dst > src) { NFLG=0; Exception(6,oldpc); goto endlabel1966; }
}}}}m68k_incpc(4);
endlabel1966: (void)0;
return 6;
}
unsigned long REGPARAM2 op_41f0_2(uae_u32 opcode) /* LEA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	m68k_areg(regs, dstreg) = (srca);
}}}m68k_incpc(4);
endlabel1967: (void)0;
return 4;
}
unsigned long REGPARAM2 op_41fb_2(uae_u32 opcode) /* LEA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{{	uaecptr tmppc = m68k_getpc() + 2;
{	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
	m68k_areg(regs, dstreg) = (srca);
}}}}m68k_incpc(4);
endlabel1968: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4230_2(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(0)) == 0;
	NFLG = ((uae_s8)(0)) < 0;
	put_byte(srca,0);
}}m68k_incpc(4);
endlabel1969: (void)0;
return 6;
}
#endif

#ifdef PART_4
unsigned long REGPARAM2 op_4270_2(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(0)) == 0;
	NFLG = ((uae_s16)(0)) < 0;
	put_word(srca,0);
}}m68k_incpc(4);
endlabel1970: (void)0;
return 6;
}
unsigned long REGPARAM2 op_42b0_2(uae_u32 opcode) /* CLR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(0)) == 0;
	NFLG = ((uae_s32)(0)) < 0;
	put_long(srca,0);
}}m68k_incpc(4);
endlabel1971: (void)0;
return 8;
}
unsigned long REGPARAM2 op_42f0_2(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
	MakeSR();
	put_word(srca,regs.sr & 0xff);
}}m68k_incpc(4);
endlabel1972: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4430_2(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{{uae_u32 dst = ((uae_s8)(0)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(0)) < 0;
	int flgn = ((uae_s8)(dst)) < 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(0));
	NFLG = flgn != 0;
	put_byte(srca,dst);
}}}}}}m68k_incpc(4);
endlabel1973: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4470_2(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{{uae_u32 dst = ((uae_s16)(0)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(0)) < 0;
	int flgn = ((uae_s16)(dst)) < 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(0));
	NFLG = flgn != 0;
	put_word(srca,dst);
}}}}}}m68k_incpc(4);
endlabel1974: (void)0;
return 8;
}
unsigned long REGPARAM2 op_44b0_2(uae_u32 opcode) /* NEG */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{{uae_u32 dst = ((uae_s32)(0)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(0)) < 0;
	int flgn = ((uae_s32)(dst)) < 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(0));
	NFLG = flgn != 0;
	put_long(srca,dst);
}}}}}}m68k_incpc(4);
endlabel1975: (void)0;
return 12;
}
unsigned long REGPARAM2 op_44f0_2(uae_u32 opcode) /* MV2SR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
	MakeSR();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR();
}}}m68k_incpc(4);
endlabel1976: (void)0;
return 6;
}
unsigned long REGPARAM2 op_44fb_2(uae_u32 opcode) /* MV2SR */
{
{{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	MakeSR();
	regs.sr &= 0xFF00;
	regs.sr |= src & 0xFF;
	MakeFromSR();
}}}m68k_incpc(4);
endlabel1977: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4630_2(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(dst)) == 0;
	NFLG = ((uae_s8)(dst)) < 0;
	put_byte(srca,dst);
}}}}m68k_incpc(4);
endlabel1978: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4670_2(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(dst)) == 0;
	NFLG = ((uae_s16)(dst)) < 0;
	put_word(srca,dst);
}}}}m68k_incpc(4);
endlabel1979: (void)0;
return 8;
}
unsigned long REGPARAM2 op_46b0_2(uae_u32 opcode) /* NOT */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uae_u32 dst = ~src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(dst)) == 0;
	NFLG = ((uae_s32)(dst)) < 0;
	put_long(srca,dst);
}}}}m68k_incpc(4);
endlabel1980: (void)0;
return 12;
}
unsigned long REGPARAM2 op_46f0_2(uae_u32 opcode) /* MV2SR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{if (!regs.s) { Exception(8,0); goto endlabel1981; }
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
	regs.sr = src;
	MakeFromSR();
}}}}m68k_incpc(4);
endlabel1981: (void)0;
return 6;
}
unsigned long REGPARAM2 op_46fb_2(uae_u32 opcode) /* MV2SR */
{
{if (!regs.s) { Exception(8,0); goto endlabel1982; }
{{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	regs.sr = src;
	MakeFromSR();
}}}}m68k_incpc(4);
endlabel1982: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4830_2(uae_u32 opcode) /* NBCD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	uae_u16 newv_lo = - (src & 0xF) - (XFLG ? 1 : 0);
	uae_u16 newv_hi = - (src & 0xF0);
	uae_u16 newv;
	if (newv_lo > 9) { newv_lo-=6; newv_hi-=0x10; }
	newv = newv_hi + (newv_lo & 0xF);	CFLG = XFLG = (newv_hi & 0x1F0) > 0x90;
	if (CFLG) newv -= 0x60;
	if (((uae_s8)(newv)) != 0) ZFLG = 0;
	NFLG = ((uae_s8)(newv)) < 0;
	put_byte(srca,newv);
}}}}m68k_incpc(4);
endlabel1983: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4870_2(uae_u32 opcode) /* PEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uaecptr dsta = m68k_areg(regs, 7) - 4;
	m68k_areg (regs, 7) = dsta;
	put_long(dsta,srca);
}}}m68k_incpc(4);
endlabel1984: (void)0;
	Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_487b_2(uae_u32 opcode) /* PEA */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
{{	uaecptr dsta = m68k_areg(regs, 7) - 4;
	m68k_areg (regs, 7) = dsta;
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
	put_long(dsta,srca);
}}}m68k_incpc(4);
endlabel1985: (void)0;
	Software_CheckStackPointer (0, oldA7);
return 8;
}
unsigned long REGPARAM2 op_48b0_2(uae_u32 opcode) /* MVMLE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	while (dmask) { put_word(srca, m68k_dreg(regs, movem_index1[dmask])); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { put_word(srca, m68k_areg(regs, movem_index1[amask])); srca += 2; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel1986: (void)0;
return 6;
}
unsigned long REGPARAM2 op_48f0_2(uae_u32 opcode) /* MVMLE */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	uae_u16 dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
	while (dmask) { put_long(srca, m68k_dreg(regs, movem_index1[dmask])); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { put_long(srca, m68k_areg(regs, movem_index1[amask])); srca += 4; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel1987: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4a30_2(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
}}}m68k_incpc(4);
endlabel1988: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4a3b_2(uae_u32 opcode) /* TST */
{
{{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
}}}m68k_incpc(4);
endlabel1989: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4a70_2(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
}}}m68k_incpc(4);
endlabel1990: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4a7b_2(uae_u32 opcode) /* TST */
{
{{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
}}}m68k_incpc(4);
endlabel1991: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4ab0_2(uae_u32 opcode) /* TST */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
}}}m68k_incpc(4);
endlabel1992: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4abb_2(uae_u32 opcode) /* TST */
{
{{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
}}}m68k_incpc(4);
endlabel1993: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4af0_2(uae_u32 opcode) /* TAS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	src |= 0x80;
	put_byte(srca,src);
}}}m68k_incpc(4);
endlabel1994: (void)0;
return 8;
}
unsigned long REGPARAM2 op_4cb0_2(uae_u32 opcode) /* MVMEL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel1995: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4cbb_2(uae_u32 opcode) /* MVMEL */
{
	uae_u32 dstreg = 3;
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr tmppc = m68k_getpc() + 4;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(4));
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = (uae_s32)(uae_s16)get_word(srca); srca += 2; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel1996: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4cf0_2(uae_u32 opcode) /* MVMEL */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(4));
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = get_long(srca); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = get_long(srca); srca += 4; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel1997: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4cfb_2(uae_u32 opcode) /* MVMEL */
{
	uae_u32 dstreg = 3;
{	uae_u16 mask = get_iword(2);
	unsigned int dmask = mask & 0xff, amask = (mask >> 8) & 0xff;
{	uaecptr tmppc = m68k_getpc() + 4;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(4));
{	while (dmask) { m68k_dreg(regs, movem_index1[dmask]) = get_long(srca); srca += 4; dmask = movem_next[dmask]; }
	while (amask) { m68k_areg(regs, movem_index1[amask]) = get_long(srca); srca += 4; amask = movem_next[amask]; }
}}}m68k_incpc(6);
endlabel1998: (void)0;
return 6;
}
unsigned long REGPARAM2 op_4eb0_2(uae_u32 opcode) /* JSR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
	m68k_do_jsr(m68k_getpc() + 4, srca);
}}endlabel1999: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4ebb_2(uae_u32 opcode) /* JSR */
{
{{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
	m68k_do_jsr(m68k_getpc() + 4, srca);
}}endlabel2000: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4ef0_2(uae_u32 opcode) /* JMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
	m68k_setpc(srca);
}}endlabel2001: (void)0;
return 4;
}
unsigned long REGPARAM2 op_4efb_2(uae_u32 opcode) /* JMP */
{
{{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
	m68k_setpc(srca);
}}endlabel2002: (void)0;
return 4;
}
#endif

#ifdef PART_5
unsigned long REGPARAM2 op_5030_2(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel2003: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5070_2(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel2004: (void)0;
return 8;
}
unsigned long REGPARAM2 op_50b0_2(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel2005: (void)0;
return 12;
}
unsigned long REGPARAM2 op_50f0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(0) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2006: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5130_2(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel2007: (void)0;
return 8;
}
unsigned long REGPARAM2 op_5170_2(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel2008: (void)0;
return 8;
}
unsigned long REGPARAM2 op_51b0_2(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = imm8_table[((opcode >> 1) & 7)];
#else
	uae_u32 srcreg = imm8_table[((opcode >> 9) & 7)];
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{	uae_u32 src = srcreg;
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}m68k_incpc(4);
endlabel2009: (void)0;
return 12;
}
unsigned long REGPARAM2 op_51f0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(1) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2010: (void)0;
return 6;
}
unsigned long REGPARAM2 op_52f0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(2) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2011: (void)0;
return 6;
}
unsigned long REGPARAM2 op_53f0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(3) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2012: (void)0;
return 6;
}
unsigned long REGPARAM2 op_54f0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(4) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2013: (void)0;
return 6;
}
unsigned long REGPARAM2 op_55f0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(5) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2014: (void)0;
return 6;
}
unsigned long REGPARAM2 op_56f0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(6) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2015: (void)0;
return 6;
}
unsigned long REGPARAM2 op_57f0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(7) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2016: (void)0;
return 6;
}
unsigned long REGPARAM2 op_58f0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(8) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2017: (void)0;
return 6;
}
unsigned long REGPARAM2 op_59f0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(9) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2018: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5af0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(10) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2019: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5bf0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(11) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2020: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5cf0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(12) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2021: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5df0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(13) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2022: (void)0;
return 6;
}
unsigned long REGPARAM2 op_5ef0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(14) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2023: (void)0;
return 6;
}
#endif

#ifdef PART_6
unsigned long REGPARAM2 op_5ff0_2(uae_u32 opcode) /* Scc */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	int val = cctrue(15) ? 0xff : 0;
	put_byte(srca,val);
}}}m68k_incpc(4);
endlabel2024: (void)0;
return 6;
}
unsigned long REGPARAM2 op_60ff_2(uae_u32 opcode) /* Bcc */
{
{	m68k_incpc(2);
	if (!cctrue(0)) goto endlabel2025;
		last_addr_for_exception_3 = m68k_getpc() + 2;
		last_fault_for_exception_3 = m68k_getpc() + 1;
		last_op_for_exception_3 = opcode; Exception(3,0); goto endlabel2025;
{	uae_s32 src = get_ilong(2);
	if (!cctrue(0)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel2025;
didnt_jump:;
}}m68k_incpc(6);
endlabel2025: (void)0;
return 6;
}
unsigned long REGPARAM2 op_62ff_2(uae_u32 opcode) /* Bcc */
{
{	m68k_incpc(2);
	if (!cctrue(2)) goto endlabel2026;
		last_addr_for_exception_3 = m68k_getpc() + 2;
		last_fault_for_exception_3 = m68k_getpc() + 1;
		last_op_for_exception_3 = opcode; Exception(3,0); goto endlabel2026;
{	uae_s32 src = get_ilong(2);
	if (!cctrue(2)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel2026;
didnt_jump:;
}}m68k_incpc(6);
endlabel2026: (void)0;
return 6;
}
unsigned long REGPARAM2 op_63ff_2(uae_u32 opcode) /* Bcc */
{
{	m68k_incpc(2);
	if (!cctrue(3)) goto endlabel2027;
		last_addr_for_exception_3 = m68k_getpc() + 2;
		last_fault_for_exception_3 = m68k_getpc() + 1;
		last_op_for_exception_3 = opcode; Exception(3,0); goto endlabel2027;
{	uae_s32 src = get_ilong(2);
	if (!cctrue(3)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel2027;
didnt_jump:;
}}m68k_incpc(6);
endlabel2027: (void)0;
return 6;
}
unsigned long REGPARAM2 op_64ff_2(uae_u32 opcode) /* Bcc */
{
{	m68k_incpc(2);
	if (!cctrue(4)) goto endlabel2028;
		last_addr_for_exception_3 = m68k_getpc() + 2;
		last_fault_for_exception_3 = m68k_getpc() + 1;
		last_op_for_exception_3 = opcode; Exception(3,0); goto endlabel2028;
{	uae_s32 src = get_ilong(2);
	if (!cctrue(4)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel2028;
didnt_jump:;
}}m68k_incpc(6);
endlabel2028: (void)0;
return 6;
}
unsigned long REGPARAM2 op_65ff_2(uae_u32 opcode) /* Bcc */
{
{	m68k_incpc(2);
	if (!cctrue(5)) goto endlabel2029;
		last_addr_for_exception_3 = m68k_getpc() + 2;
		last_fault_for_exception_3 = m68k_getpc() + 1;
		last_op_for_exception_3 = opcode; Exception(3,0); goto endlabel2029;
{	uae_s32 src = get_ilong(2);
	if (!cctrue(5)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel2029;
didnt_jump:;
}}m68k_incpc(6);
endlabel2029: (void)0;
return 6;
}
unsigned long REGPARAM2 op_66ff_2(uae_u32 opcode) /* Bcc */
{
{	m68k_incpc(2);
	if (!cctrue(6)) goto endlabel2030;
		last_addr_for_exception_3 = m68k_getpc() + 2;
		last_fault_for_exception_3 = m68k_getpc() + 1;
		last_op_for_exception_3 = opcode; Exception(3,0); goto endlabel2030;
{	uae_s32 src = get_ilong(2);
	if (!cctrue(6)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel2030;
didnt_jump:;
}}m68k_incpc(6);
endlabel2030: (void)0;
return 6;
}
unsigned long REGPARAM2 op_67ff_2(uae_u32 opcode) /* Bcc */
{
{	m68k_incpc(2);
	if (!cctrue(7)) goto endlabel2031;
		last_addr_for_exception_3 = m68k_getpc() + 2;
		last_fault_for_exception_3 = m68k_getpc() + 1;
		last_op_for_exception_3 = opcode; Exception(3,0); goto endlabel2031;
{	uae_s32 src = get_ilong(2);
	if (!cctrue(7)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel2031;
didnt_jump:;
}}m68k_incpc(6);
endlabel2031: (void)0;
return 6;
}
unsigned long REGPARAM2 op_68ff_2(uae_u32 opcode) /* Bcc */
{
{	m68k_incpc(2);
	if (!cctrue(8)) goto endlabel2032;
		last_addr_for_exception_3 = m68k_getpc() + 2;
		last_fault_for_exception_3 = m68k_getpc() + 1;
		last_op_for_exception_3 = opcode; Exception(3,0); goto endlabel2032;
{	uae_s32 src = get_ilong(2);
	if (!cctrue(8)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel2032;
didnt_jump:;
}}m68k_incpc(6);
endlabel2032: (void)0;
return 6;
}
unsigned long REGPARAM2 op_69ff_2(uae_u32 opcode) /* Bcc */
{
{	m68k_incpc(2);
	if (!cctrue(9)) goto endlabel2033;
		last_addr_for_exception_3 = m68k_getpc() + 2;
		last_fault_for_exception_3 = m68k_getpc() + 1;
		last_op_for_exception_3 = opcode; Exception(3,0); goto endlabel2033;
{	uae_s32 src = get_ilong(2);
	if (!cctrue(9)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel2033;
didnt_jump:;
}}m68k_incpc(6);
endlabel2033: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6aff_2(uae_u32 opcode) /* Bcc */
{
{	m68k_incpc(2);
	if (!cctrue(10)) goto endlabel2034;
		last_addr_for_exception_3 = m68k_getpc() + 2;
		last_fault_for_exception_3 = m68k_getpc() + 1;
		last_op_for_exception_3 = opcode; Exception(3,0); goto endlabel2034;
{	uae_s32 src = get_ilong(2);
	if (!cctrue(10)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel2034;
didnt_jump:;
}}m68k_incpc(6);
endlabel2034: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6bff_2(uae_u32 opcode) /* Bcc */
{
{	m68k_incpc(2);
	if (!cctrue(11)) goto endlabel2035;
		last_addr_for_exception_3 = m68k_getpc() + 2;
		last_fault_for_exception_3 = m68k_getpc() + 1;
		last_op_for_exception_3 = opcode; Exception(3,0); goto endlabel2035;
{	uae_s32 src = get_ilong(2);
	if (!cctrue(11)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel2035;
didnt_jump:;
}}m68k_incpc(6);
endlabel2035: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6cff_2(uae_u32 opcode) /* Bcc */
{
{	m68k_incpc(2);
	if (!cctrue(12)) goto endlabel2036;
		last_addr_for_exception_3 = m68k_getpc() + 2;
		last_fault_for_exception_3 = m68k_getpc() + 1;
		last_op_for_exception_3 = opcode; Exception(3,0); goto endlabel2036;
{	uae_s32 src = get_ilong(2);
	if (!cctrue(12)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel2036;
didnt_jump:;
}}m68k_incpc(6);
endlabel2036: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6dff_2(uae_u32 opcode) /* Bcc */
{
{	m68k_incpc(2);
	if (!cctrue(13)) goto endlabel2037;
		last_addr_for_exception_3 = m68k_getpc() + 2;
		last_fault_for_exception_3 = m68k_getpc() + 1;
		last_op_for_exception_3 = opcode; Exception(3,0); goto endlabel2037;
{	uae_s32 src = get_ilong(2);
	if (!cctrue(13)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel2037;
didnt_jump:;
}}m68k_incpc(6);
endlabel2037: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6eff_2(uae_u32 opcode) /* Bcc */
{
{	m68k_incpc(2);
	if (!cctrue(14)) goto endlabel2038;
		last_addr_for_exception_3 = m68k_getpc() + 2;
		last_fault_for_exception_3 = m68k_getpc() + 1;
		last_op_for_exception_3 = opcode; Exception(3,0); goto endlabel2038;
{	uae_s32 src = get_ilong(2);
	if (!cctrue(14)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel2038;
didnt_jump:;
}}m68k_incpc(6);
endlabel2038: (void)0;
return 6;
}
unsigned long REGPARAM2 op_6fff_2(uae_u32 opcode) /* Bcc */
{
{	m68k_incpc(2);
	if (!cctrue(15)) goto endlabel2039;
		last_addr_for_exception_3 = m68k_getpc() + 2;
		last_fault_for_exception_3 = m68k_getpc() + 1;
		last_op_for_exception_3 = opcode; Exception(3,0); goto endlabel2039;
{	uae_s32 src = get_ilong(2);
	if (!cctrue(15)) goto didnt_jump;
	m68k_incpc ((uae_s32)src + 2);
#if HAS_PROFILING
	if (gProfilingEnabled)
		ProfileIncrementClock(2);
#endif
	goto endlabel2039;
didnt_jump:;
}}m68k_incpc(6);
endlabel2039: (void)0;
return 6;
}
unsigned long REGPARAM2 op_8030_2(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(4);
endlabel2040: (void)0;
return 6;
}
unsigned long REGPARAM2 op_803b_2(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 src = get_byte(srca);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(4);
endlabel2041: (void)0;
return 6;
}
unsigned long REGPARAM2 op_8070_2(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(4);
endlabel2042: (void)0;
return 6;
}
unsigned long REGPARAM2 op_807b_2(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(4);
endlabel2043: (void)0;
return 6;
}
unsigned long REGPARAM2 op_80b0_2(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(4);
endlabel2044: (void)0;
return 8;
}
unsigned long REGPARAM2 op_80bb_2(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(4);
endlabel2045: (void)0;
return 8;
}
unsigned long REGPARAM2 op_80f0_2(uae_u32 opcode) /* DIVU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel2046; } else {
	uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
	uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
	if (newv > 0xffff) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(4);
endlabel2046: (void)0;
return 74;
}
unsigned long REGPARAM2 op_80fb_2(uae_u32 opcode) /* DIVU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	if(src == 0) { Exception(5,oldpc); goto endlabel2047; } else {
	uae_u32 newv = (uae_u32)dst / (uae_u32)(uae_u16)src;
	uae_u32 rem = (uae_u32)dst % (uae_u32)(uae_u16)src;
	if (newv > 0xffff) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(4);
endlabel2047: (void)0;
return 74;
}
unsigned long REGPARAM2 op_8130_2(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s8 dst = get_byte(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel2048: (void)0;
return 8;
}
unsigned long REGPARAM2 op_8170_2(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s16 dst = get_word(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel2049: (void)0;
return 8;
}
unsigned long REGPARAM2 op_81b0_2(uae_u32 opcode) /* OR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s32 dst = get_long(dsta);
	src |= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel2050: (void)0;
return 12;
}
unsigned long REGPARAM2 op_81f0_2(uae_u32 opcode) /* DIVS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	if(src == 0) { Exception(5,oldpc); goto endlabel2051; } else {
	uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
	uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
	if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(4);
endlabel2051: (void)0;
return 78;
}
unsigned long REGPARAM2 op_81fb_2(uae_u32 opcode) /* DIVS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{	uaecptr oldpc = m68k_getpc();
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	if(src == 0) { Exception(5,oldpc); goto endlabel2052; } else {
	uae_s32 newv = (uae_s32)dst / (uae_s32)(uae_s16)src;
	uae_u16 rem = (uae_s32)dst % (uae_s32)(uae_s16)src;
	if ((newv & 0xffff8000) != 0 && (newv & 0xffff8000) != 0xffff8000) { VFLG = NFLG = 1; CFLG = 0; } else
	{
	if (((uae_s16)rem < 0) != ((uae_s32)dst < 0)) rem = -rem;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	NFLG = ((uae_s16)(newv)) < 0;
	newv = (newv & 0xffff) | ((uae_u32)rem << 16);
	m68k_dreg(regs, dstreg) = (newv);
	}
	}
}}}}m68k_incpc(4);
endlabel2052: (void)0;
return 78;
}
unsigned long REGPARAM2 op_9030_2(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(4);
endlabel2053: (void)0;
return 6;
}
unsigned long REGPARAM2 op_903b_2(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 src = get_byte(srca);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(4);
endlabel2054: (void)0;
return 6;
}
unsigned long REGPARAM2 op_9070_2(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(4);
endlabel2055: (void)0;
return 6;
}
unsigned long REGPARAM2 op_907b_2(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(4);
endlabel2056: (void)0;
return 6;
}
unsigned long REGPARAM2 op_90b0_2(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(4);
endlabel2057: (void)0;
return 8;
}
unsigned long REGPARAM2 op_90bb_2(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(4);
endlabel2058: (void)0;
return 8;
}
unsigned long REGPARAM2 op_90f0_2(uae_u32 opcode) /* SUBA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel2059: (void)0;
return 6;
}
unsigned long REGPARAM2 op_90fb_2(uae_u32 opcode) /* SUBA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel2060: (void)0;
return 6;
}
unsigned long REGPARAM2 op_9130_2(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel2061: (void)0;
return 8;
}
unsigned long REGPARAM2 op_9170_2(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel2062: (void)0;
return 8;
}
unsigned long REGPARAM2 op_91b0_2(uae_u32 opcode) /* SUB */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgo) & (flgn ^ flgo);
	CFLG = XFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel2063: (void)0;
return 12;
}
unsigned long REGPARAM2 op_91f0_2(uae_u32 opcode) /* SUBA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel2064: (void)0;
return 8;
}
unsigned long REGPARAM2 op_91fb_2(uae_u32 opcode) /* SUBA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = dst - src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel2065: (void)0;
return 8;
}
#endif

#ifdef PART_7
unsigned long REGPARAM2 op_b030_2(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel2066: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b03b_2(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 src = get_byte(srca);
{{uae_u32 newv = ((uae_s8)(dst)) - ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u8)(src)) > ((uae_u8)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel2067: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b070_2(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel2068: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b07b_2(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s16)(dst)) - ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u16)(src)) > ((uae_u16)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel2069: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b0b0_2(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel2070: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b0bb_2(uae_u32 opcode) /* CMP */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel2071: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b0f0_2(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel2072: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b0fb_2(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel2073: (void)0;
return 6;
}
unsigned long REGPARAM2 op_b130_2(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s8 dst = get_byte(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel2074: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b170_2(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s16 dst = get_word(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel2075: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b1b0_2(uae_u32 opcode) /* EOR */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s32 dst = get_long(dsta);
	src ^= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel2076: (void)0;
return 12;
}
unsigned long REGPARAM2 op_b1f0_2(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel2077: (void)0;
return 8;
}
unsigned long REGPARAM2 op_b1fb_2(uae_u32 opcode) /* CMPA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) - ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs != flgo) && (flgn != flgo);
	CFLG = ((uae_u32)(src)) > ((uae_u32)(dst));
	NFLG = flgn != 0;
}}}}}}}m68k_incpc(4);
endlabel2078: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c030_2(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(4);
endlabel2079: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c03b_2(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 src = get_byte(srca);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((src) & 0xff);
}}}}m68k_incpc(4);
endlabel2080: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c070_2(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(4);
endlabel2081: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c07b_2(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((src) & 0xffff);
}}}}m68k_incpc(4);
endlabel2082: (void)0;
return 6;
}
unsigned long REGPARAM2 op_c0b0_2(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(4);
endlabel2083: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c0bb_2(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	m68k_dreg(regs, dstreg) = (src);
}}}}m68k_incpc(4);
endlabel2084: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c0f0_2(uae_u32 opcode) /* MULU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel2085: (void)0;
return 38;
}
unsigned long REGPARAM2 op_c0fb_2(uae_u32 opcode) /* MULU */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = (uae_u32)(uae_u16)dst * (uae_u32)(uae_u16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel2086: (void)0;
return 38;
}
unsigned long REGPARAM2 op_c130_2(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s8 dst = get_byte(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s8)(src)) == 0;
	NFLG = ((uae_s8)(src)) < 0;
	put_byte(dsta,src);
}}}}m68k_incpc(4);
endlabel2087: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c170_2(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s16 dst = get_word(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(src)) == 0;
	NFLG = ((uae_s16)(src)) < 0;
	put_word(dsta,src);
}}}}m68k_incpc(4);
endlabel2088: (void)0;
return 8;
}
unsigned long REGPARAM2 op_c1b0_2(uae_u32 opcode) /* AND */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s32 dst = get_long(dsta);
	src &= dst;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(src)) == 0;
	NFLG = ((uae_s32)(src)) < 0;
	put_long(dsta,src);
}}}}m68k_incpc(4);
endlabel2089: (void)0;
return 12;
}
unsigned long REGPARAM2 op_c1f0_2(uae_u32 opcode) /* MULS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel2090: (void)0;
return 38;
}
unsigned long REGPARAM2 op_c1fb_2(uae_u32 opcode) /* MULS */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = (uae_s32)(uae_s16)dst * (uae_s32)(uae_s16)src;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	NFLG = ((uae_s32)(newv)) < 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel2091: (void)0;
return 38;
}
unsigned long REGPARAM2 op_d030_2(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s8 src = get_byte(srca);
{	uae_s8 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(4);
endlabel2092: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d03b_2(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s8 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s8 src = get_byte(srca);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xff) | ((newv) & 0xff);
}}}}}}}m68k_incpc(4);
endlabel2093: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d070_2(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_s16 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(4);
endlabel2094: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d07b_2(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s16 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (m68k_dreg(regs, dstreg) & ~0xffff) | ((newv) & 0xffff);
}}}}}}}m68k_incpc(4);
endlabel2095: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d0b0_2(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_dreg(regs, dstreg);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(4);
endlabel2096: (void)0;
return 8;
}
unsigned long REGPARAM2 op_d0bb_2(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_dreg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	m68k_dreg(regs, dstreg) = (newv);
}}}}}}}m68k_incpc(4);
endlabel2097: (void)0;
return 8;
}
unsigned long REGPARAM2 op_d0f0_2(uae_u32 opcode) /* ADDA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel2098: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d0fb_2(uae_u32 opcode) /* ADDA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s16 src = get_word(srca);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel2099: (void)0;
return 6;
}
unsigned long REGPARAM2 op_d130_2(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s8 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s8 dst = get_byte(dsta);
{{uae_u32 newv = ((uae_s8)(dst)) + ((uae_s8)(src));
{	int flgs = ((uae_s8)(src)) < 0;
	int flgo = ((uae_s8)(dst)) < 0;
	int flgn = ((uae_s8)(newv)) < 0;
	ZFLG = ((uae_s8)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u8)(~dst)) < ((uae_u8)(src));
	NFLG = flgn != 0;
	put_byte(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel2100: (void)0;
return 8;
}
unsigned long REGPARAM2 op_d170_2(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s16 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s16 dst = get_word(dsta);
{{uae_u32 newv = ((uae_s16)(dst)) + ((uae_s16)(src));
{	int flgs = ((uae_s16)(src)) < 0;
	int flgo = ((uae_s16)(dst)) < 0;
	int flgn = ((uae_s16)(newv)) < 0;
	ZFLG = ((uae_s16)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u16)(~dst)) < ((uae_u16)(src));
	NFLG = flgn != 0;
	put_word(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel2101: (void)0;
return 8;
}
#endif

#ifdef PART_8
unsigned long REGPARAM2 op_d1b0_2(uae_u32 opcode) /* ADD */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 1) & 7);
#else
	uae_u32 srcreg = ((opcode >> 9) & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 8) & 7;
#else
	uae_u32 dstreg = opcode & 7;
#endif
{{	uae_s32 src = m68k_dreg(regs, srcreg);
{	uaecptr dsta = get_disp_ea_000(m68k_areg(regs, dstreg), get_iword(2));
{	uae_s32 dst = get_long(dsta);
{{uae_u32 newv = ((uae_s32)(dst)) + ((uae_s32)(src));
{	int flgs = ((uae_s32)(src)) < 0;
	int flgo = ((uae_s32)(dst)) < 0;
	int flgn = ((uae_s32)(newv)) < 0;
	ZFLG = ((uae_s32)(newv)) == 0;
	VFLG = (flgs ^ flgn) & (flgo ^ flgn);
	CFLG = XFLG = ((uae_u32)(~dst)) < ((uae_u32)(src));
	NFLG = flgn != 0;
	put_long(dsta,newv);
}}}}}}}m68k_incpc(4);
endlabel2102: (void)0;
return 12;
}
unsigned long REGPARAM2 op_d1f0_2(uae_u32 opcode) /* ADDA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s32 src = get_long(srca);
{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel2103: (void)0;
return 8;
}
unsigned long REGPARAM2 op_d1fb_2(uae_u32 opcode) /* ADDA */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 dstreg = (opcode >> 1) & 7;
#else
	uae_u32 dstreg = (opcode >> 9) & 7;
#endif
{{	uae_s32 dst = m68k_areg(regs, dstreg);
{	uaecptr tmppc = m68k_getpc() + 2;
	uaecptr srca = get_disp_ea_000(tmppc, get_iword(2));
{	uae_s32 src = get_long(srca);
{	uae_u32 newv = dst + src;
	m68k_areg(regs, dstreg) = (newv);
}}}}}m68k_incpc(4);
endlabel2104: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e0f0_2(uae_u32 opcode) /* ASRW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=val&1; val = (val >> 1) | sign;
	NFLG = sign != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel2105: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e1f0_2(uae_u32 opcode) /* ASLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 data = get_word(dataa);
	VFLG = 0;
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 sign = cmask & val;
	CFLG=XFLG=(val&cmask)!=0; val <<= 1;
	if ((val&cmask)!=sign) VFLG=1;
	NFLG = (val&cmask) != 0;
	ZFLG = val == 0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel2106: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e2f0_2(uae_u32 opcode) /* LSRW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	val >>= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel2107: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e3f0_2(uae_u32 opcode) /* LSLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = XFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel2108: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e4f0_2(uae_u32 opcode) /* ROXRW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(XFLG) val |= cmask;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel2109: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e5f0_2(uae_u32 opcode) /* ROXLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(XFLG) val |= 1;
	XFLG = carry != 0;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
XFLG = CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel2110: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e6f0_2(uae_u32 opcode) /* RORW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 carry = val&1;
	uae_u32 cmask = 0x8000;
	val >>= 1;
	if(carry) val |= cmask;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel2111: (void)0;
return 8;
}
unsigned long REGPARAM2 op_e7f0_2(uae_u32 opcode) /* ROLW */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr dataa = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
{	uae_s16 data = get_word(dataa);
{	uae_u16 val = data;
	uae_u32 cmask = 0x8000;
	uae_u32 carry = val&cmask;
	val <<= 1;
	if(carry)  val |= 1;
	VFLG = CFLG = 0;
	ZFLG = ((uae_s16)(val)) == 0;
	NFLG = ((uae_s16)(val)) < 0;
CFLG = carry!=0;
	put_word(dataa,val);
}}}}m68k_incpc(4);
endlabel2112: (void)0;
return 8;
}
#endif


#if !defined(PART_1) && !defined(PART_2) && !defined(PART_3) && !defined(PART_4) && !defined(PART_5) && !defined(PART_6) && !defined(PART_7) && !defined(PART_8)
#define PART_1 1
#define PART_2 1
#define PART_3 1
#define PART_4 1
#define PART_5 1
#define PART_6 1
#define PART_7 1
#define PART_8 1
#endif

#ifdef PART_1
#endif

#ifdef PART_2
#endif

#ifdef PART_3
unsigned long REGPARAM2 op_40c0_3(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	MakeSR();
	m68k_dreg(regs, srcreg) = (m68k_dreg(regs, srcreg) & ~0xffff) | ((regs.sr) & 0xffff);
}}m68k_incpc(2);
endlabel2113: (void)0;
return 2;
}
unsigned long REGPARAM2 op_40d0_3(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	MakeSR();
	put_word(srca,regs.sr);
}}m68k_incpc(2);
endlabel2114: (void)0;
return 4;
}
unsigned long REGPARAM2 op_40d8_3(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg);
	m68k_areg(regs, srcreg) += 2;
	MakeSR();
	put_word(srca,regs.sr);
}}m68k_incpc(2);
endlabel2115: (void)0;
return 4;
}
unsigned long REGPARAM2 op_40e0_3(uae_u32 opcode) /* MVSR2 */
{
	uaecptr oldA7 = m68k_areg(regs, 7);
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) - 2;
	m68k_areg (regs, srcreg) = srca;
	MakeSR();
	put_word(srca,regs.sr);
}}m68k_incpc(2);
endlabel2116: (void)0;
	if (srcreg == 7) Software_CheckStackPointer (0, oldA7);
return 4;
}
unsigned long REGPARAM2 op_40e8_3(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = m68k_areg(regs, srcreg) + (uae_s32)(uae_s16)get_iword(2);
	MakeSR();
	put_word(srca,regs.sr);
}}m68k_incpc(4);
endlabel2117: (void)0;
return 6;
}
unsigned long REGPARAM2 op_40f0_3(uae_u32 opcode) /* MVSR2 */
{
#ifdef HAVE_GET_WORD_UNSWAPPED
	uae_u32 srcreg = ((opcode >> 8) & 7);
#else
	uae_u32 srcreg = (opcode & 7);
#endif
{{	uaecptr srca = get_disp_ea_000(m68k_areg(regs, srcreg), get_iword(2));
	MakeSR();
	put_word(srca,regs.sr);
}}m68k_incpc(4);
endlabel2118: (void)0;
return 6;
}
unsigned long REGPARAM2 op_40f8_3(uae_u32 opcode) /* MVSR2 */
{
{{	uaecptr srca = (uae_s32)(uae_s16)get_iword(2);
	MakeSR();
	put_word(srca,regs.sr);
}}m68k_incpc(4);
endlabel2119: (void)0;
return 6;
}
unsigned long REGPARAM2 op_40f9_3(uae_u32 opcode) /* MVSR2 */
{
{{	uaecptr srca = get_ilong(2);
	MakeSR();
	put_word(srca,regs.sr);
}}m68k_incpc(6);
endlabel2120: (void)0;
return 8;
}
#endif

#ifdef PART_4
unsigned long REGPARAM2 op_4e73_3(uae_u32 opcode) /* RTE */
{
{if (!regs.s) { Exception(8,0); goto endlabel2121; }
{{	uaecptr sra = m68k_areg(regs, 7);
	m68k_areg(regs, 7) += 2;
{	uae_s16 sr = get_word(sra);
{	uaecptr pca = m68k_areg(regs, 7);
	m68k_areg(regs, 7) += 4;
{	uae_s32 pc = get_long(pca);
	regs.sr = sr; m68k_do_rte(pc);
	MakeFromSR();
}}}}}}endlabel2121: (void)0;
return 8;
}
#endif

#ifdef PART_5
#endif

#ifdef PART_6
#endif

#ifdef PART_7
#endif

#ifdef PART_8
#endif

